# ProtoBuf.jl

[![][docs-dev-img]][docs-dev-url]

This is a Julia package that provides a compiler and a codec for Protocol Buffers.

[Protocol Buffers](https://developers.google.com/protocol-buffers) are a language-neutral, platform-neutral extensible mechanism for serializing structured data.

## Example

Given a `test.proto` file in your current working directory:
```protobuf
syntax = "proto3";

message MyMessage {
    sint32 a = 1;
    repeated string b = 2;
}
```
You can generate Julia bindings with the `protojl` function:
```julia
using ProtoBuf
protojl("test.proto", ".", "output_dir")
```

This will create a Julia file at `output_dir/test_pb.jl` which you can simply `include` and start using it to encode and decode messages:

```julia
include("output_dir/test_pb.jl")
# Main.test_pb

io = IOBuffer();

e = ProtoEncoder(io);

encode(e, test_pb.MyMessage(-1, ["a", "b"]))
# 8

seekstart(io);

d = ProtoDecoder(io);

decode(d, test_pb.MyMessage)
# Main.test_pb.MyMessage(-1, ["a", "b"])
```
## Acknowledgement

We'd like to thank the authors of the following packages, as we took inspiration from their projects:

* We used [Tokenize.jl](https://github.com/JuliaLang/Tokenize.jl) as a reference when implementing the Lexer/Parser.
* We used the pre-1.0 version of `ProtoBuf.jl` as a giant shoulder to stand on:).

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://juliaio.github.io/ProtoBuf.jl/dev/

module OlderVersion
    # Autogenerated using ProtoBuf.jl v1.1.1 on 2025-07-08T10:40:02.200
    # original file: /Users/tdrvostep/.julia/dev/ProtoBuf/test/test_protos/test_messages_for_codec.proto (proto3 syntax)

    import ProtoBuf as PB
    using ProtoBuf: OneOf
    using ProtoBuf.EnumX: @enumx

    abstract type var"##Abstract#TestStruct" end


    struct TestInner
        x::Int64
        r::Union{Nothing,TestInner}
    end
    PB.default_values(::Type{TestInner}) = (;x = zero(Int64), r = nothing)
    PB.field_numbers(::Type{TestInner}) = (;x = 1, r = 2)

    function PB.decode(d::PB.AbstractProtoDecoder, ::Type{<:TestInner})
        x = zero(Int64)
        r = Ref{Union{Nothing,TestInner}}(nothing)
        while !PB.message_done(d)
            field_number, wire_type = PB.decode_tag(d)
            if field_number == 1
                x = PB.decode(d, Int64)
            elseif field_number == 2
                PB.decode!(d, r)
            else
                Base.skip(d, wire_type)
            end
        end
        return TestInner(x, r[])
    end

    function PB.encode(e::PB.AbstractProtoEncoder, x::TestInner)
        initpos = position(e.io)
        x.x != zero(Int64) && PB.encode(e, 1, x.x)
        !isnothing(x.r) && PB.encode(e, 2, x.r)
        return position(e.io) - initpos
    end
    function PB._encoded_size(x::TestInner)
        encoded_size = 0
        x.x != zero(Int64) && (encoded_size += PB._encoded_size(x.x, 1))
        !isnothing(x.r) && (encoded_size += PB._encoded_size(x.r, 2))
        return encoded_size
    end
end

@enum(Kind,
    ENDMARKER, # EOF
    UNINIT, # used in uninitialized lexer and parser
    ERROR, # If we encounter an error during lexing, paired with TokenErorr
    COMMENT,
    begin_single_character_lexical_items,
        LBRACE, # {
        RBRACE, # }
        LESS,    # <
        GREATER, # >
        COMMA, # ,
        DOT, # .
        LPAREN, # (
        RPAREN, # )
        LBRACKET, # [
        RBRACKET, # ]
        MINUS, # -
        PLUS,  # +
        COLON, # :
        EQ, # =
        DOUBLE_QUOTE, # "
        SINGLE_QUOTE, # '
        WHITESPACE, # '\n \t'
        SEMICOLON, # ;
        UNDERSCORE, # _
        BACKWARD_SLASH, # \
        FORWARD_SLASH, # /
    end_single_character_lexical_items,

    begin_identifiers,
        IDENTIFIER,
    end_identifiers,

    begin_reserved_words,
        RESERVED,
        SYNTAX,
        PACKAGE,
        IMPORT,
        PUBLIC,
        WEAK,

        OPTION,
        EXTENSIONS,
        TO,
        MAX,

        SERVICE,
        STREAM,
        RPC,
        RETURNS,

        EXTEND,
        GROUP,

        REPEATED,
        ONEOF,
        OPTIONAL,
        REQUIRED,

        FLOAT,
        DOUBLE,
        INT32,
        INT64,
        UINT32,
        UINT64,
        SINT32,
        SINT64,
        FIXED32,
        FIXED64,
        SFIXED32,
        SFIXED64,
        BOOL,
        STRING,
        BYTES,

        MAP,
        MESSAGE,
        ENUM,
    end_reserved_words,

    begin_literals,
        DEC_INT_LIT, # 123
        OCT_INT_LIT, # 0173
        HEX_INT_LIT, # 0x7b
        FLOAT_LIT,   # 123.0
        STRING_LIT,  # "a" 'b'
        BYTES_LIT,
        TRUE,
        FALSE,
        INF,
        NAN,
    end_literals,
)

isident(k::Kind) = begin_identifiers < k < end_identifiers
isliteral(k::Kind) = begin_literals < k < end_literals

# TODO: proper handling of valid names, this rule is too loose
maybevalidname(k::Kind) = begin_identifiers < k < end_literals

is_reserved_word(k::Kind) = begin_reserved_words < k < end_reserved_words
is_single_letter_lexical_item(k::Kind) = begin_single_character_lexical_items < k < end_single_character_lexical_items


@enum(TokenError,
    NO_ERROR,
    EOF_STRING,
    EOL_STRING,
    INVALID_STRING_ESCAPE_SEQUENCE,
    INVALID_NUMERIC_CONSTANT,
    INVALID_IDENTIFIER,
    INVALID_NUMERIC_LITERAL_JUXTAPOSITION,
    EOF_MULTICOMMENT,
    UNKNOWN,
)

function encode_tag(io::IO, field_number, wire_type::WireType)
    vbyte_encode(io, (UInt32(field_number) << 3) | UInt32(wire_type))
    return nothing
end
encode_tag(e::ProtoEncoder, field_number, wire_type::WireType) = encode_tag(e.io, field_number, wire_type)
# TODO: audit usage and composability of maybe_ensure_room
maybe_ensure_room(io::IOBuffer, n) = Base.ensureroom(io, min(io.maxsize, n))

maybe_ensure_room(::IO, n) = nothing

@noinline _incomplete_encode_error(io::IOBuffer, nb, target) = throw(ArgumentError("Failed to write to IOBuffer, only written $nb bytes out of $target (maxsize: $(io.maxsize), positiom : $(position(io))"))
@noinline _incomplete_encode_error(::IO, nb, target) = throw(ArgumentError("Failed to write to IO, only written $nb bytes out of $target"))

@inline function _with_size(f, io::IOBuffer, sink, x, V...)
    if io.seekable
        initpos = position(io)
        # We need to encode the encoded size of x before we know it. We first preallocate 1
        # byte as that is the mininum size of the encoded size.
        # If our guess is right, it will save us a copy, but we never want to preallocate too much
        # space for the size, because then we risk outgrowing the buffer that was allocated with exact size
        # needed to contain the message.
        # TODO: make the guess better (e.g. by incorporating maxsize)
        encoded_size_len_guess = 1
        truncate(io, initpos + encoded_size_len_guess)
        seek(io, initpos + encoded_size_len_guess)
        # Now we can encode the object itself
        f(sink, x, V...) # e.g. _encode(io, x) or _encode(io, x, Val{:zigzag})
        endpos = position(io)
        encoded_size = endpos - initpos - encoded_size_len_guess
        encoded_size_len = _encoded_size(UInt32(encoded_size))
        @assert (initpos + encoded_size_len + encoded_size) <= io.maxsize
        # If our initial guess on encoded size of the size was wrong, then we need to move the encoded data
        if encoded_size_len_guess < encoded_size_len
            truncate(io, initpos + encoded_size_len + encoded_size)
            # Move the data right after the correct size
            unsafe_copyto!(
                io.data,
                initpos + encoded_size_len + 1,
                io.data,
                initpos + encoded_size_len_guess + 1,
                encoded_size
            )
        end
        # Now we can encode the size
        seek(io, initpos)
        vbyte_encode(io, UInt32(encoded_size))
        seek(io, initpos + encoded_size_len + encoded_size)
    else
        # TODO: avoid quadratic behavior when estimating encoded size by providing a scratch buffer
        vbyte_encode(io, UInt32(_encoded_size(x, V...)))
        f(sink, x, V...)
    end
    return nothing
end

@inline function _with_size(f, io::IO, sink, x, V...)
    # TODO: avoid quadratic behavior when estimating encoded size by providing a scratch buffer
    vbyte_encode(io, UInt32(_encoded_size(x, V...)))
    f(sink, x, V...)
    return nothing
end

function _encode(io::IO, x::T) where {T<:Union{UInt32,UInt64}}
    vbyte_encode(io, x)
    return nothing
end

function _encode(io::IO, x::Int64)
    vbyte_encode(io, reinterpret(UInt64, x))
    return nothing
end

function _encode(io::IO, x::Int32)
    x < 0 ? vbyte_encode(io, reinterpret(UInt64, Int64(x))) : vbyte_encode(io, reinterpret(UInt32, x))
    return nothing
end

function _encode(io::IO, x::T) where {T<:Union{Enum{Int32},Enum{UInt32}}}
    vbyte_encode(io, reinterpret(UInt32, x))
    return nothing
end

function _encode(io::IO, x::Vector{T}, ::Type{Val{:fixed}}) where {T<:Union{Int32,Int64,UInt32,UInt64}}
    nb = write(io, x)
    nb == sizeof(x) || _incomplete_encode_error(io, nb, sizeof(x))
    return nothing
end

function _encode(io::IO, x::T, ::Type{Val{:fixed}}) where {T<:Union{Int32,Int64,UInt32,UInt64}}
    _unsafe_write(io, Ref(x), Core.sizeof(x))
    return nothing
end

function _encode(io::IO, x::T, ::Type{Val{:zigzag}}) where {T<:Union{Int32,Int64}}
    vbyte_encode(io, reinterpret(unsigned(T), zigzag_encode(x)))
    return nothing
end

function _encode(io::IO, x::Vector{T}, ::Type{Val{:zigzag}}) where {T<:Union{Int32,Int64}}
    maybe_ensure_room(io, length(x))
    for el in x
        _encode(io, el, Val{:zigzag})
    end
    return nothing
end

function _encode(io::IO, x::String)
    nb = write(io, x)
    nb == sizeof(x) || _incomplete_encode_error(io, nb, sizeof(x))
    return nothing
end

function _encode(io::IO, x::T) where {T<:Union{Bool,Float32,Float64}}
    _unsafe_write(io, Ref(x), Core.sizeof(x))
    return nothing
end

function _encode(io::IO, x::Vector{T}) where {T<:Union{Bool,UInt8,Float32,Float64}}
    nb = write(io, x)
    nb == sizeof(x) || _incomplete_encode_error(io, nb, sizeof(x))
    return nothing
end

function _encode(io::IO, x::Base.CodeUnits{UInt8, String})
    nb = write(io, x)
    nb == sizeof(x) || _incomplete_encode_error(io, nb, sizeof(x))
    return nothing
end

function _encode(io::IO, x::Vector{T}) where {T<:Union{UInt32,UInt64,Int32,Int64,Enum{Int32},Enum{UInt32}}}
    maybe_ensure_room(io, length(x))
    for el in x
        _encode(io, el)
    end
    return nothing
end

function encode(e::ProtoEncoder, i::Int, x::Dict{K,V}) where {K,V}
    maybe_ensure_room(e.io, 2*(length(x)+1))
    for (k, v) in x
        # encode header for key-value pair message
        encode_tag(e, i, LENGTH_DELIMITED)
        vbyte_encode(e.io, UInt32(_encoded_size(k, 1) + _encoded_size(v, 2)))
        encode(e, 1, k)
        encode(e, 2, v)
    end
    nothing
end

for T in (:(:fixed), :(:zigzag))
    @eval function encode(e::ProtoEncoder, i::Int, x::Dict{K,V}, ::Type{Val{Tuple{$(T),Nothing}}}) where {K,V}
        maybe_ensure_room(e.io, 2*(length(x)+1))
        for (k, v) in x
            # encode header for key-value pair message
            encode_tag(e, i, LENGTH_DELIMITED)
            vbyte_encode(e.io, UInt32(_encoded_size(k, 1, Val{$(T)}) + _encoded_size(v, 2)))
            encode(e, 1, k, Val{$(T)})
            encode(e, 2, v)
        end
        nothing
    end
    @eval function encode(e::ProtoEncoder, i::Int, x::Dict{K,V}, ::Type{Val{Tuple{Nothing,$(T)}}}) where {K,V}
        maybe_ensure_room(e.io, 2*(length(x)+1))
        for (k, v) in x
            # encode header for key-value pair message
            encode_tag(e, i, LENGTH_DELIMITED)
            vbyte_encode(e.io, UInt32(_encoded_size(k, 1) + _encoded_size(v, 2, Val{$(T)})))
            encode(e, 1, k)
            encode(e, 2, v, Val{$(T)})
        end
        nothing
    end
end

for T in (:(:fixed), :(:zigzag)), S in (:(:fixed), :(:zigzag))
    @eval function encode(e::AbstractProtoEncoder, i::Int, x::Dict{K,V}, ::Type{Val{Tuple{$(T),$(S)}}}) where {K,V}
        maybe_ensure_room(e.io, 2*(length(x)+1))
        for (k, v) in x
            # encode header for key-value pair message
            encode_tag(e, i, LENGTH_DELIMITED)
            vbyte_encode(e.io, UInt32(_encoded_size(k, 1, Val{$(T)}) + _encoded_size(v, 2, Val{$(S)})))
            encode(e, 1, k, Val{$(T)})
            encode(e, 2, v, Val{$(S)})
        end
        nothing
    end
end


function encode(e::AbstractProtoEncoder, i::Int, x::T) where {T<:Union{Bool,Int32,Int64,UInt32,UInt64,Enum{Int32},Enum{UInt32}}}
    encode_tag(e, i, VARINT)
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::T, ::Type{Val{:zigzag}}) where {T<:Union{Int32,Int64}}
    encode_tag(e, i, VARINT)
    _encode(e.io, x, Val{:zigzag})
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::T, ::Type{Val{:fixed}}) where {T<:Union{Int32,UInt32}}
    encode_tag(e, i, FIXED32)
    _encode(e.io, x, Val{:fixed})
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Float32)
    encode_tag(e, i, FIXED32)
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::T, ::Type{Val{:fixed}}) where {T<:Union{Int64,UInt64}}
    encode_tag(e, i, FIXED64)
    _encode(e.io, x, Val{:fixed})
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Float64)
    encode_tag(e, i, FIXED64)
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}) where {T<:Union{Bool,UInt8,Float32,Float64}}
    encode_tag(e, i, LENGTH_DELIMITED)
    vbyte_encode(e.io, UInt32(sizeof(x)))
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Base.CodeUnits{UInt8, String})
    encode_tag(e, i, LENGTH_DELIMITED)
    vbyte_encode(e.io, UInt32(sizeof(x)))
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{String})
    maybe_ensure_room(e.io, length(x) * (sizeof(first(x)) + 1))
    for el in x
        encode_tag(e, i, LENGTH_DELIMITED)
        vbyte_encode(e.io, UInt32(sizeof(el)))
        _encode(e.io, el)
    end
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{Vector{UInt8}})
    maybe_ensure_room(e.io, length(x) * (sizeof(first(x)) + 1))
    for el in x
        encode_tag(e, i, LENGTH_DELIMITED)
        vbyte_encode(e.io, UInt32(sizeof(el)))
        _encode(e.io, el)
    end
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::String)
    encode_tag(e, i, LENGTH_DELIMITED)
    vbyte_encode(e.io, UInt32(sizeof(x)))
    _encode(e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}, ::Type{Val{:fixed}}) where {T<:Union{UInt32,UInt64,Int32,Int64}}
    encode_tag(e, i, LENGTH_DELIMITED)
    vbyte_encode(e.io, UInt32(sizeof(x)))
    _encode(e.io, x, Val{:fixed})
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}) where {T<:Union{UInt32,UInt64,Int32,Int64,Enum{Int32},Enum{UInt32}}}
    encode_tag(e, i, LENGTH_DELIMITED)
    _with_size(_encode, e.io, e.io, x)
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}, ::Type{Val{:zigzag}}) where {T<:Union{Int32,Int64}}
    encode_tag(e, i, LENGTH_DELIMITED)
    _with_size(_encode, e.io, e.io, x, Val{:zigzag})
    return nothing
end

# T is a struct/message type
function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}) where {T}
    @assert !isempty(x)
    maybe_ensure_room(e.io, length(x) * (1 + sizeof(typeof(first(x)))))
    for el in x
        encode_tag(e, i, LENGTH_DELIMITED)
        _with_size(encode, e.io, e, el)
    end
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::T) where {T}
    encode_tag(e, i, LENGTH_DELIMITED)
    _with_size(encode, e.io, e, x)
    return nothing
end

# Groups
function encode(e::AbstractProtoEncoder, i::Int, x::Vector{T}, ::Type{Val{:group}}) where {T}
    @assert !isempty(x)
    maybe_ensure_room(e.io, length(x) * (2 + sizeof(typeof(first(x)))))
    for el in x
        encode_tag(e, i, START_GROUP)
        encode(e, el) # This method has to be generated by protojl
        vbyte_encode(e.io, UInt32(END_GROUP))
    end
    return nothing
end

function encode(e::AbstractProtoEncoder, i::Int, x::T, ::Type{Val{:group}}) where {T}
    maybe_ensure_room(e.io, 2 + sizeof(T))
    encode_tag(e, i, START_GROUP)
    encode(e, x) # This method has to be generated by protojl
    vbyte_encode(e.io, UInt32(END_GROUP))
    return nothing
end

# Resolving a method ambiguity
function encode(::AbstractProtoEncoder, ::Int, ::Dict{K, V}, ::Type{Val{:group}}) where {K, V}
    throw(MethodError(encode, (AbstractProtoEncoder, Int, Dict{K, V}, Val{:group})))
end

module TestEncode
using ProtoBuf: Codecs
import ProtoBuf as PB
using .Codecs: encode, decode!, _encoded_size, ProtoEncoder, ProtoDecoder, WireType, vbyte_decode, vbyte_encode
using Test
using EnumX: @enumx

const temp_dir = mktempdir()
const test_dir = joinpath(pkgdir(PB), "test")

PB.protojl("test_messages_for_codec.proto", joinpath(test_dir, "test_protos"), temp_dir, always_use_modules=false, parametrize_oneofs=true)
include(joinpath(temp_dir, "test_messages_for_codec_pb.jl"))

TestInner(x::Int) = TestInner(x, nothing) # convenience constructor for a generated struct

function test_encode_struct(input::TestStruct, i, expected, V=nothing)
    d = ProtoEncoder(IOBuffer())
    is_group = !isnothing(V)
    if is_group
        encode(d, 0, input, V)
    else
        encode(d, input)
    end
    bytes = take!(d.io)
    if is_group
        @testset "group tags" begin
            @test first(bytes) == UInt8(Codecs.START_GROUP)
            @test last(bytes) == UInt8(Codecs.END_GROUP)
        end
        bytes = bytes[2:end-1]
    end
    tag = first(bytes)
    bytes = bytes[2:end]
    if !isa(input.oneof[], Enum)
        len = first(bytes)
        bytes = bytes[2:end]
        @testset "length" begin
            @test len == length(expected)
        end
        w = Codecs.LENGTH_DELIMITED
    else
        w = Codecs.VARINT
    end
    @testset "tag" begin
        @test tag >> 3 == i
        @test tag & 0x07 == Int(w)
    end
    @testset "encoded payload" begin
        @test bytes == expected
    end
end

function test_encode(input, i, w::WireType, expected, V::Type=Nothing)
    d = ProtoEncoder(IOBuffer())
    initpos = position(d.io)
    if V === Nothing
        encode(d, i, input)
        exp_len = _encoded_size(input, i)
    else
        encode(d, i, input, V)
        exp_len = _encoded_size(input, i, V)

    end
    endpos = position(d.io)
    @testset "encoded size" begin
        @test endpos - initpos == exp_len
    end

    bytes = take!(d.io)
    if isa(input, AbstractDict)
        # dictionaries should be decoded and compared in order-independent manner
        result = empty(input)

        bytes_io = IOBuffer(bytes)
        while !eof(bytes_io)
            # Parse tag and length of the outer message
            _ = vbyte_decode(bytes_io, UInt32)  # tag (field number + wire type)
            msg_len = vbyte_decode(bytes_io, UInt32)  # read length so that we know how much to read
            msg_bytes = read(bytes_io, msg_len) # read message bytes

            # Create a decoder for this, recreate the message in the form decoder needs
            size_bytes = IOBuffer()
            Codecs.vbyte_encode(size_bytes, UInt32(msg_len))
            full_msg_bytes = vcat(take!(size_bytes), msg_bytes)

            entry_decoder = Codecs.ProtoDecoder(IOBuffer(full_msg_bytes))
            # provide encoding type info when available
            if V === Nothing
                decode!(entry_decoder, result)
            else
                decode!(entry_decoder, result, V)
            end
        end

        @testset "decoded dict matches" begin
            @test result == input
        end
    elseif isa(input, AbstractVector) && eltype(input) <: Union{Vector{UInt8}, String, TestInner}
        j = 1
        while !isempty(bytes)
            tag = bytes[1]
            len = bytes[2]
            elbytes = bytes[3:len+2]
            bytes = bytes[3+len:end]

            extag = expected[1]
            exlen = expected[2]
            elexpected = expected[3:len+2]
            expected = expected[3+len:end]
            @testset "length $j" begin
                @test len == exlen
            end
            @testset "tag $j" begin
                @test ((tag >> 3) == (extag >> 3)) & ((tag >> 3) == i)
                @test ((tag & 0x07) == (extag & 0x07)) & ((tag & 0x07) == Int(w))
            end
            @testset "encoded payload $j" begin
                @test elbytes == elexpected
            end
            j += 1
        end
    else
        tag = first(bytes)
        bytes = bytes[2:end]
        if w == Codecs.LENGTH_DELIMITED
            len = first(bytes)
            bytes = bytes[2:end]
            @testset "length" begin
                @test len == length(expected)
            end
        end
        @testset "tag" begin
            @test tag >> 3 == i
            @test tag & 0x07 == Int(w)
        end
        @testset "encoded payload" begin
            @test bytes == expected
        end
    end
end

@testset "encode" begin
    @testset "length delimited" begin
        @testset "bytes" begin
            test_encode(b"123456789", 2, Codecs.LENGTH_DELIMITED, b"123456789")
            test_encode(b"", 2, Codecs.LENGTH_DELIMITED, b"")
        end

        @testset "string" begin
            test_encode("123456789", 2, Codecs.LENGTH_DELIMITED, b"123456789")
            test_encode("", 2, Codecs.LENGTH_DELIMITED, b"")
        end

        @testset "repeated bytes" begin
            test_encode([[0x31, 0x32], [0x33, 0x34]], 2, Codecs.LENGTH_DELIMITED, [0x12, 0x02, 0x31, 0x32, 0x12, 0x02, 0x33, 0x34])
        end

        @testset "repeated string" begin
            test_encode(["12", "34"], 2, Codecs.LENGTH_DELIMITED, [0x12, 0x02, 0x31, 0x32, 0x12, 0x02, 0x33, 0x34])
        end

        @testset "repeated uint32" begin
            test_encode(UInt32[1, 2], 2, Codecs.LENGTH_DELIMITED, [0x01, 0x02])
        end

        @testset "repeated uint64" begin
            test_encode(UInt64[1, 2], 2, Codecs.LENGTH_DELIMITED, [0x01, 0x02])
        end

        @testset "repeated int32" begin
            test_encode(Int32[1, 2], 2, Codecs.LENGTH_DELIMITED, [0x01, 0x02])
            test_encode(Int32[-1], 2, Codecs.LENGTH_DELIMITED, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01])
        end

        @testset "repeated enum" begin
            test_encode([TestEnum.B, TestEnum.C], 2, Codecs.LENGTH_DELIMITED, [0x01, 0x02])
        end

        @testset "repeated int64" begin
            test_encode(Int64[1, 2], 2, Codecs.LENGTH_DELIMITED, [0x01, 0x02])
            test_encode(Int64[-1], 2, Codecs.LENGTH_DELIMITED, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01])
        end

        @testset "repeated bool" begin
            test_encode(Bool[false, true, false], 2, Codecs.LENGTH_DELIMITED, [0x00, 0x01, 0x00])
        end

        @testset "repeated float64" begin
            test_encode(Float64[1.0, 2.0], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, Float64[1.0, 2.0]))
        end

        @testset "repeated float32" begin
            test_encode(Float32[1.0, 2.0], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, Float32[1.0, 2.0]))
        end

        @testset "repeated sfixed32" begin
            test_encode(Int32[1, 2], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, Int32[1, 2]), Val{:fixed})
        end

        @testset "repeated sfixed64" begin
            test_encode(Int64[1, 2], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, Int64[1, 2]), Val{:fixed})
        end

        @testset "repeated fixed32" begin
            test_encode(UInt32[1, 2], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, UInt32[1, 2]), Val{:fixed})
        end

        @testset "repeated fixed64" begin
            test_encode(UInt64[1, 2], 2, Codecs.LENGTH_DELIMITED, reinterpret(UInt8, UInt64[1, 2]), Val{:fixed})
        end

        @testset "repeated sint32" begin
            test_encode(Int32[1, 2, -1, -2], 2, Codecs.LENGTH_DELIMITED, [0x02, 0x04, 0x01, 0x03], Val{:zigzag})
        end

        @testset "repeated sint64" begin
            test_encode(Int64[1, 2, -1, -2], 2, Codecs.LENGTH_DELIMITED, [0x02, 0x04, 0x01, 0x03], Val{:zigzag})
        end

        @testset "repeated message" begin
            test_encode([TestInner(3), TestInner(4)], 2, Codecs.LENGTH_DELIMITED, [0x12, 0x02, 0x08, 0x03, 0x12, 0x02, 0x08, 0x04])
        end

        @testset "map" begin
            @testset "string,string" begin test_encode(Dict{String,String}("b" => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x06, 0x0a, 0x01, 0x62, 0x12, 0x01, 0x61]) end
            @testset "multiple string,string" begin test_encode(Dict{String,String}("b" => "a", "c" => "d"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x06, 0x0a, 0x01, 0x63, 0x12, 0x01, 0x64, 0x12, 0x06, 0x0a, 0x01, 0x62, 0x12, 0x01, 0x61]) end

            @testset "int32,string" begin test_encode(Dict{Int32,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61]) end
            @testset "int64,string" begin test_encode(Dict{Int64,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61]) end
            @testset "uint32,string" begin test_encode(Dict{UInt32,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61]) end
            @testset "uint64,string" begin test_encode(Dict{UInt64,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61]) end
            @testset "bool,string" begin test_encode(Dict{Bool,String}(true => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61]) end

            @testset "sfixed32,string" begin test_encode(Dict{Int32,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x08, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Val{Tuple{:fixed,Nothing}}) end
            @testset "sfixed64,string" begin test_encode(Dict{Int64,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0c, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Val{Tuple{:fixed,Nothing}}) end
            @testset "fixed32,string" begin test_encode(Dict{UInt32,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x08, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Val{Tuple{:fixed,Nothing}}) end
            @testset "fixed64,string" begin test_encode(Dict{UInt64,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0c, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Val{Tuple{:fixed,Nothing}}) end

            @testset "sint32,string" begin test_encode(Dict{Int32,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x02, 0x12, 0x01, 0x61], Val{Tuple{:zigzag,Nothing}}) end
            @testset "sint64,string" begin test_encode(Dict{Int64,String}(1 => "a"), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x08, 0x02, 0x12, 0x01, 0x61], Val{Tuple{:zigzag,Nothing}}) end

            @testset "string,int32" begin test_encode(Dict{String,Int32}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01]) end
            @testset "string,int64" begin test_encode(Dict{String,Int64}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01]) end
            @testset "string,uint32" begin test_encode(Dict{String,UInt32}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01]) end
            @testset "string,uint64" begin test_encode(Dict{String,UInt64}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01]) end
            @testset "string,bool" begin test_encode(Dict{String,Bool}("a" => true), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01]) end

            @testset "string,sfixed32" begin test_encode(Dict{String,Int32}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x08, 0x0a, 0x01, 0x61, 0x15, 0x01, 0x00, 0x00, 0x00], Val{Tuple{Nothing,:fixed}}) end
            @testset "string,sfixed64" begin test_encode(Dict{String,Int64}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0c, 0x0a, 0x01, 0x61, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Val{Tuple{Nothing,:fixed}}) end
            @testset "string,fixed32" begin test_encode(Dict{String,UInt32}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x08, 0x0a, 0x01, 0x61, 0x15, 0x01, 0x00, 0x00, 0x00], Val{Tuple{Nothing,:fixed}}) end
            @testset "string,fixed64" begin test_encode(Dict{String,UInt64}("a" => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0c, 0x0a, 0x01, 0x61, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Val{Tuple{Nothing,:fixed}}) end

            @testset "sfixed32,sfixed32" begin test_encode(Dict{Int32,Int32}(1 => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0a, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x15, 0x01, 0x00, 0x00, 0x00], Val{Tuple{:fixed,:fixed}}) end
            @testset "sfixed64,sfixed64" begin test_encode(Dict{Int64,Int64}(1 => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x12, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Val{Tuple{:fixed,:fixed}}) end
            @testset "fixed32,fixed32" begin test_encode(Dict{UInt32,UInt32}(1 => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x0a, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x15, 0x01, 0x00, 0x00, 0x00], Val{Tuple{:fixed,:fixed}}) end
            @testset "fixed64,fixed64" begin test_encode(Dict{UInt64,UInt64}(1 => 1), 2, Codecs.LENGTH_DELIMITED, [0x12, 0x12, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Val{Tuple{:fixed,:fixed}}) end
        end

        @testset "message" begin
            test_encode_struct(TestStruct(PB.OneOf(:bytes, collect(b"123"))), 1, b"123")
            test_encode_struct(TestStruct(PB.OneOf(:enum, TestEnum.C)), 2, [0x02])
            test_encode_struct(TestStruct(PB.OneOf(:var"#struct", TestInner(2))), 3, [0x08, 0x02])
            test_encode_struct(TestStruct(PB.OneOf(:var"#struct", TestInner(2, TestInner(3)))), 3, [0x08, 0x02, 0x12, 0x02, 0x08, 0x03])
        end

        @testset "group message" begin
            test_encode_struct(TestStruct(PB.OneOf(:bytes, collect(b"123"))), 1, b"123", Val{:group})
            test_encode_struct(TestStruct(PB.OneOf(:enum, TestEnum.C)), 2, [0x02], Val{:group})
            test_encode_struct(TestStruct(PB.OneOf(:var"#struct", TestInner(2))), 3, [0x08, 0x02], Val{:group})
            test_encode_struct(TestStruct(PB.OneOf(:var"#struct", TestInner(2, TestInner(3)))), 3, [0x08, 0x02, 0x12, 0x02, 0x08, 0x03], Val{:group})
        end
    end

    @testset "varint" begin
        @testset "uint32" begin
            test_encode(UInt32(2), 2, Codecs.VARINT, [0x02])
        end

        @testset "uint64" begin
            test_encode(UInt64(2), 2, Codecs.VARINT, [0x02])
        end

        @testset "int32" begin
            test_encode(Int32(2), 2, Codecs.VARINT, [0x02])
            test_encode(Int32(-1), 2, Codecs.VARINT, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01])
        end

        @testset "enum" begin
            test_encode(TestEnum.C, 2, Codecs.VARINT, [0x02])
        end

        @testset "int64" begin
            test_encode(Int64(2), 2, Codecs.VARINT, [0x02])
            test_encode(Int64(-1), 2, Codecs.VARINT, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01])
        end

        @testset "bool" begin
            test_encode(true, 2, Codecs.VARINT, [0x01])
        end

        @testset "sint32" begin
            test_encode(Int32(2), 2, Codecs.VARINT, [0x04], Val{:zigzag})
            test_encode(typemax(Int32), 2, Codecs.VARINT, [0xFE, 0xFF, 0xFF, 0xFF, 0x0F], Val{:zigzag})
            test_encode(typemin(Int32), 2, Codecs.VARINT, [0xFF, 0xFF, 0xFF, 0xFF, 0x0F], Val{:zigzag})
        end

        @testset "sint64" begin
            test_encode(Int64(2), 2, Codecs.VARINT, [0x04], Val{:zigzag})
            test_encode(typemax(Int64), 2, Codecs.VARINT, [0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Val{:zigzag})
            test_encode(typemin(Int64), 2, Codecs.VARINT, [0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Val{:zigzag})
        end
    end

    @testset "fixed" begin
        @testset "sfixed32" begin
            test_encode(Int32(2), 2, Codecs.FIXED32, reinterpret(UInt8, [Int32(2)]), Val{:fixed})
        end

        @testset "sfixed64" begin
            test_encode(Int64(2), 2, Codecs.FIXED64, reinterpret(UInt8, [Int64(2)]), Val{:fixed})
        end

        @testset "fixed32" begin
            test_encode(UInt32(2), 2, Codecs.FIXED32, reinterpret(UInt8, [UInt32(2)]), Val{:fixed})
        end

        @testset "fixed64" begin
            test_encode(UInt64(2), 2, Codecs.FIXED64, reinterpret(UInt8, [UInt64(2)]), Val{:fixed})
        end
    end
end
end # module

module TestEncodedSize
using Test
using ProtoBuf: Codecs, ProtoEncoder, _encoded_size
import ProtoBuf as PB

const temp_dir = mktempdir()
const test_dir = joinpath(pkgdir(PB), "test")

PB.protojl("test_messages_for_codec2.proto", joinpath(test_dir, "test_protos"), temp_dir, always_use_modules=false, parametrize_oneofs=true)
include(joinpath(temp_dir, "test_messages_for_codec2_pb.jl"))

@testset "_with_size" begin
    io = IOBuffer()
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6])
    @test take!(io) == UInt8[6, 1, 2, 3, 4, 5, 6]

    io = IOBuffer()
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6], Val{:zigzag})
    @test take!(io) == UInt8[6, 2, 4, 6, 8, 10, 12]

    io = IOBuffer(zeros(UInt8, 7), maxsize=7, read=false, write=true)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6])
    @test Codecs._with_size(PB._encoded_size([1, 2, 3, 4, 5, 6])) == length(io.data)
    @test io.data == UInt8[6, 1, 2, 3, 4, 5, 6]

    io = IOBuffer(zeros(UInt8, 7), maxsize=7, read=false, write=true)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6], Val{:zigzag})
    @test Codecs._with_size(PB._encoded_size([1, 2, 3, 4, 5, 6], Val{:zigzag})) == length(io.data)
    @test io.data == UInt8[6, 2, 4, 6, 8, 10, 12]

    io = IOBuffer(;maxsize=2^14 + 1)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6])
    @test take!(io) == UInt8[6, 1, 2, 3, 4, 5, 6]

    io = IOBuffer(;maxsize=2^14 + 1)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6], Val{:zigzag})
    @test take!(io) == UInt8[6, 2, 4, 6, 8, 10, 12]

    io = IOBuffer(;maxsize=2^21 + 1)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6])
    @test take!(io) == UInt8[6, 1, 2, 3, 4, 5, 6]

    io = IOBuffer(;maxsize=2^21 + 1)
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6], Val{:zigzag})
    @test take!(io) == UInt8[6, 2, 4, 6, 8, 10, 12]

    io = PipeBuffer()
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6])
    @test take!(io) == UInt8[6, 1, 2, 3, 4, 5, 6]

    io = PipeBuffer()
    Codecs._with_size(Codecs._encode, io, io, [1, 2, 3, 4, 5, 6], Val{:zigzag})
    @test take!(io) == UInt8[6, 2, 4, 6, 8, 10, 12]

    io = IOBuffer()
    Codecs._with_size(Codecs._encode, io, io, collect(1:128))
    @test take!(io) == vcat(UInt8(129), UInt8(1), UInt8.(collect(1:127)), UInt8(128), UInt8(1))

    io = IOBuffer()
    Codecs._with_size(Codecs._encode, io, io, fill(2, 129), Val{:zigzag})
    @test take!(io) == vcat(UInt8(129), UInt8(1), fill(UInt8(4), 129))

    io = IOBuffer(;maxsize=2^14 + 1)
    Codecs._with_size(Codecs._encode, io, io, collect(1:128))
    @test take!(io) == vcat(UInt8(129), UInt8(1), UInt8.(collect(1:127)), UInt8(128), UInt8(1))

    io = IOBuffer(;maxsize=2^14 + 1)
    Codecs._with_size(Codecs._encode, io, io, fill(2, 129), Val{:zigzag})
    @test take!(io) == vcat(UInt8(129), UInt8(1), fill(UInt8(4), 129))

    io = IOBuffer(;maxsize=2^21 + 1)
    Codecs._with_size(Codecs._encode, io, io, collect(1:128))
    @test take!(io) == vcat(UInt8(129), UInt8(1), UInt8.(collect(1:127)), UInt8(128), UInt8(1))

    io = IOBuffer(;maxsize=2^21 + 1)
    Codecs._with_size(Codecs._encode, io, io, fill(2, 129), Val{:zigzag})
    @test take!(io) == vcat(UInt8(129), UInt8(1), fill(UInt8(4), 129))

    io = PipeBuffer()
    Codecs._with_size(Codecs._encode, io, io, collect(1:128))
    @test take!(io) == vcat(UInt8(129), UInt8(1), UInt8.(collect(1:127)), UInt8(128), UInt8(1))

    io = PipeBuffer()
    Codecs._with_size(Codecs._encode, io, io, fill(2, 129), Val{:zigzag})
    @test take!(io) == vcat(UInt8(129), UInt8(1), fill(UInt8(4), 129))

    empty_field_size = PB._encoded_size(EmptyMessage(), 1)
    io = IOBuffer(zeros(UInt8, empty_field_size), maxsize=empty_field_size, read=false, write=true)
    PB.encode(ProtoEncoder(io), 1, EmptyMessage())
    @test empty_field_size == length(io.data)
    @test io.data == UInt8[0x0a, 0x00]

    non_empty_field = NonEmptyMessage(8, nothing)
    non_empty_field_size = PB._encoded_size(non_empty_field, 1)
    io = IOBuffer(zeros(UInt8, non_empty_field_size), maxsize=non_empty_field_size, read=false, write=true)
    PB.encode(ProtoEncoder(io), 1, non_empty_field)
    @test non_empty_field_size == length(io.data)
    @test io.data == UInt8[0x0a, 0x02, 0x08, 0x08]

    non_empty_field = NonEmptyMessage(5, NonEmptyMessage(10, nothing))
    non_empty_field_size = PB._encoded_size(non_empty_field, 1)
    io = IOBuffer(zeros(UInt8, non_empty_field_size), maxsize=non_empty_field_size, read=false, write=true)
    PB.encode(ProtoEncoder(io), 1, non_empty_field)
    @test non_empty_field_size == length(io.data)
    @test io.data == UInt8[0x0a, 0x06, 0x08, 0x05, 0x12, 0x02, 0x08, 0x0a]
end

@testset "_encoded_size" begin
    @test _encoded_size(nothing) == 0
    @test _encoded_size(UInt8[0xff]) == 1
    @test _encoded_size(UInt8[]) == 0
    @test _encoded_size("S") == 1
    @test _encoded_size("") == 0
    @test _encoded_size(typemax(UInt32)) == 5
    @test _encoded_size(typemax(UInt64)) == 10
    @test _encoded_size(typemax(Int32)) == 5
    @test _encoded_size(typemax(Int64)) == 9
    @test _encoded_size(true) == 1
    @test _encoded_size(typemax(Int32), Val{:zigzag}) == 5
    @test _encoded_size(typemax(Int64), Val{:zigzag}) == 10
    @test _encoded_size(typemax(Int32), Val{:zigzag}) == 5
    @test _encoded_size(typemax(Int64), Val{:zigzag}) == 10
    @test _encoded_size(TestEnum.OTHER) == 1
    @test _encoded_size(typemax(Int32), Val{:fixed}) == 4
    @test _encoded_size(typemax(Int64), Val{:fixed}) == 8
    @test _encoded_size(typemax(UInt32), Val{:fixed}) == 4
    @test _encoded_size(typemax(UInt64), Val{:fixed}) == 8
    @test _encoded_size(EmptyMessage()) == 0
    #                                                                                                    T   D     T    L    T   D
    @test _encoded_size(NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))) == (1 + 5) + (1 + (1 + (1 + 5)))
    @test _encoded_size([UInt8[0xff]]) == 2
    @test _encoded_size(["S"]) == 2
    @test _encoded_size([typemax(UInt32)]) == 5
    @test _encoded_size([typemax(UInt64)]) == 10
    @test _encoded_size([typemax(Int32)]) == 5
    @test _encoded_size([typemax(Int64)]) == 9
    @test _encoded_size([true]) == 1
    @test _encoded_size([typemax(Int32)], Val{:zigzag}) == 5
    @test _encoded_size([typemax(Int64)], Val{:zigzag}) == 10
    @test _encoded_size([typemin(Int32)], Val{:zigzag}) == 5
    @test _encoded_size([typemax(Int64)], Val{:zigzag}) == 10
    @test _encoded_size([TestEnum.OTHER]) == 1
    @test _encoded_size([typemax(Int32)], Val{:fixed}) == 4
    @test _encoded_size([typemax(Int64)], Val{:fixed}) == 8
    @test _encoded_size([typemax(UInt32)], Val{:fixed}) == 4
    @test _encoded_size([typemax(UInt64)], Val{:fixed}) == 8
    @test _encoded_size([EmptyMessage()]) == 1
    @test _encoded_size([EmptyMessage(), EmptyMessage()]) == 2
    @test _encoded_size([EmptyMessage(), EmptyMessage()], 1) == 4
    #                                                                                                     L    T   D     T    L    T   D
    @test _encoded_size([NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))]) == 1 + (1 + 5) + (1 + (1 + (1 + 5)))
    #                                                                                                                  S    T   D     T    L    T   D      E
    @test _encoded_size([NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))], Val{:group}) == 1 + (1 + 5) + (1 + (1 + (1 + 5))) + 1
    #                                                  T   L   D     T   L   D
    @test _encoded_size(Dict("K" => UInt8[0xff]))    == ((1 + 1 + 1) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict("K" => UInt8[0xff]), 1) == ((1 + 1 + 1) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict("K" => "S"))            == ((1 + 1 + 1) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict("K" => "S"), 1)         == ((1 + 1 + 1) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict("KEY" => "STR"))        == ((1 + 1 + 3) + (1 + 1 + 3)) + 1
    @test _encoded_size(Dict("KEY" => "STR"), 1)     == ((1 + 1 + 3) + (1 + 1 + 3)) + 2
    @test _encoded_size(Dict("KEY1" => "STR1", "KEY2" => "STR2"))       == 2 * (((1 + 1 + 4) + (1 + 1 + 4)) + 1)
    @test _encoded_size(Dict("KEY1" => "STR1", "KEY2" => "STR2"), 1)    == 2 * (((1 + 1 + 4) + (1 + 1 + 4)) + 2)
    @test _encoded_size(Dict("KEY1" => "STR1", "KEY2" => "STR2"), 128)  == 2 * (((1 + 1 + 4) + (1 + 1 + 4)) + 3)
    #                                                      T   L   D     T    D
    @test _encoded_size(Dict("K" => typemax(UInt32)))    == ((1 + 1 + 1) + (1 +  5)) + 1
    @test _encoded_size(Dict("K" => typemax(UInt32)), 1) == ((1 + 1 + 1) + (1 +  5)) + 2
    @test _encoded_size(Dict("K" => typemax(UInt64)))    == ((1 + 1 + 1) + (1 + 10)) + 1
    @test _encoded_size(Dict("K" => typemax(UInt64)), 1) == ((1 + 1 + 1) + (1 + 10)) + 2
    @test _encoded_size(Dict("K" => typemax(Int32)))     == ((1 + 1 + 1) + (1 +  5)) + 1
    @test _encoded_size(Dict("K" => typemax(Int32)), 1)  == ((1 + 1 + 1) + (1 +  5)) + 2
    @test _encoded_size(Dict("K" => typemax(Int64)))     == ((1 + 1 + 1) + (1 +  9)) + 1
    @test _encoded_size(Dict("K" => typemax(Int64)), 1)  == ((1 + 1 + 1) + (1 +  9)) + 2
    @test _encoded_size(Dict("K" => true))               == ((1 + 1 + 1) + (1 +  1)) + 1
    @test _encoded_size(Dict("K" => true), 1)            == ((1 + 1 + 1) + (1 +  1)) + 2
    @test _encoded_size(Dict("K" => typemax(Int32)), Val{Tuple{Nothing,:zigzag}})    == ((1 + 1 + 1) + (1 +  5)) + 1
    @test _encoded_size(Dict("K" => typemax(Int32)), 1, Val{Tuple{Nothing,:zigzag}}) == ((1 + 1 + 1) + (1 +  5)) + 2
    @test _encoded_size(Dict("K" => typemax(Int64)), Val{Tuple{Nothing,:zigzag}})    == ((1 + 1 + 1) + (1 + 10)) + 1
    @test _encoded_size(Dict("K" => typemax(Int64)), 1, Val{Tuple{Nothing,:zigzag}}) == ((1 + 1 + 1) + (1 + 10)) + 2
    @test _encoded_size(Dict("K" => typemin(Int32)), Val{Tuple{Nothing,:zigzag}})    == ((1 + 1 + 1) + (1 +  5)) + 1
    @test _encoded_size(Dict("K" => typemin(Int32)), 1, Val{Tuple{Nothing,:zigzag}}) == ((1 + 1 + 1) + (1 +  5)) + 2
    @test _encoded_size(Dict("K" => typemin(Int64)), Val{Tuple{Nothing,:zigzag}})    == ((1 + 1 + 1) + (1 + 10)) + 1
    @test _encoded_size(Dict("K" => typemin(Int64)), 1, Val{Tuple{Nothing,:zigzag}}) == ((1 + 1 + 1) + (1 + 10)) + 2
    @test _encoded_size(Dict("K" => TestEnum.OTHER))     == ((1 + 1 + 1) + (1 +  1)) + 1
    @test _encoded_size(Dict("K" => TestEnum.OTHER), 1)  == ((1 + 1 + 1) + (1 +  1)) + 2

    @test _encoded_size(Dict("K" => typemax(UInt32)), Val{Tuple{Nothing,:fixed}})    == ((1 + 1 + 1) + (1 + 4)) + 1
    @test _encoded_size(Dict("K" => typemax(UInt32)), 1, Val{Tuple{Nothing,:fixed}}) == ((1 + 1 + 1) + (1 + 4)) + 2
    @test _encoded_size(Dict("K" => typemax(UInt64)), Val{Tuple{Nothing,:fixed}})    == ((1 + 1 + 1) + (1 + 8)) + 1
    @test _encoded_size(Dict("K" => typemax(UInt64)), 1, Val{Tuple{Nothing,:fixed}}) == ((1 + 1 + 1) + (1 + 8)) + 2
    @test _encoded_size(Dict("K" => typemax(Int32)),  Val{Tuple{Nothing,:fixed}})    == ((1 + 1 + 1) + (1 + 4)) + 1
    @test _encoded_size(Dict("K" => typemax(Int32)),  1, Val{Tuple{Nothing,:fixed}}) == ((1 + 1 + 1) + (1 + 4)) + 2
    @test _encoded_size(Dict("K" => typemax(Int64)),  Val{Tuple{Nothing,:fixed}})    == ((1 + 1 + 1) + (1 + 8)) + 1
    @test _encoded_size(Dict("K" => typemax(Int64)),  1, Val{Tuple{Nothing,:fixed}}) == ((1 + 1 + 1) + (1 + 8)) + 2

    @test _encoded_size(Dict("K" => EmptyMessage()))    == ((1 + 1 + 1) + (1 + 1 + 0)) + 1
    @test _encoded_size(Dict("K" => EmptyMessage()), 1) == ((1 + 1 + 1) + (1 + 1 + 0)) + 2
    #                                                                                                                     T   L   D      T   L     T   D    T    L    T   D
    @test _encoded_size(Dict("K" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))))    == ((1 + 1 + 1) + (1 + 1 + (1 + 5) + (1 + (1 + (1 + 5))))) + 1
    @test _encoded_size(Dict("K" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))), 1) == ((1 + 1 + 1) + (1 + 1 + (1 + 5) + (1 + (1 + (1 + 5))))) + 2
    #                                                      T    D     T   L   D    TH
    @test _encoded_size(Dict(typemax(UInt32) => "V"))    == ((1 +  5) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(UInt32) => "V"), 1) == ((1 +  5) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(UInt64) => "V"))    == ((1 + 10) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(UInt64) => "V"), 1) == ((1 + 10) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int32) => "V"))     == ((1 +  5) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int32) => "V"), 1)  == ((1 +  5) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int64) => "V"))     == ((1 +  9) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int64) => "V"), 1)  == ((1 +  9) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(true => "V"))               == ((1 +  1) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(true => "V"), 1)            == ((1 +  1) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int32) => "V"), Val{Tuple{:zigzag,Nothing}})    == ((1 +  5) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int32) => "V"), 1, Val{Tuple{:zigzag,Nothing}}) == ((1 +  5) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int64) => "V"), Val{Tuple{:zigzag,Nothing}})    == ((1 + 10) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int64) => "V"), 1, Val{Tuple{:zigzag,Nothing}}) == ((1 + 10) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemin(Int32) => "V"), Val{Tuple{:zigzag,Nothing}})    == ((1 +  5) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemin(Int32) => "V"), 1, Val{Tuple{:zigzag,Nothing}}) == ((1 +  5) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemin(Int64) => "V"), Val{Tuple{:zigzag,Nothing}})    == ((1 + 10) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemin(Int64) => "V"), 1, Val{Tuple{:zigzag,Nothing}}) == ((1 + 10) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(TestEnum.OTHER => "V"))     == ((1 +  1) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(TestEnum.OTHER => "V"), 1)  == ((1 +  1) + (1 + 1 + 1)) + 2

    @test _encoded_size(Dict(typemax(UInt32) => "V"), Val{Tuple{:fixed,Nothing}})    == ((1 + 4) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(UInt32) => "V"), 1, Val{Tuple{:fixed,Nothing}}) == ((1 + 4) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(UInt64) => "V"), Val{Tuple{:fixed,Nothing}})    == ((1 + 8) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(UInt64) => "V"), 1, Val{Tuple{:fixed,Nothing}}) == ((1 + 8) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int32) => "V"),  Val{Tuple{:fixed,Nothing}})    == ((1 + 4) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int32) => "V"), 1,  Val{Tuple{:fixed,Nothing}}) == ((1 + 4) + (1 + 1 + 1)) + 2
    @test _encoded_size(Dict(typemax(Int64) => "V"),  Val{Tuple{:fixed,Nothing}})    == ((1 + 8) + (1 + 1 + 1)) + 1
    @test _encoded_size(Dict(typemax(Int64) => "V"), 1,  Val{Tuple{:fixed,Nothing}}) == ((1 + 8) + (1 + 1 + 1)) + 2

    @test _encoded_size(Dict(typemax(UInt32) => typemax(UInt32)), Val{Tuple{:fixed,:fixed}})    == ((1 + 4) + (1 + 4)) + 1
    @test _encoded_size(Dict(typemax(UInt32) => typemax(UInt32)), 1, Val{Tuple{:fixed,:fixed}}) == ((1 + 4) + (1 + 4)) + 2
    @test _encoded_size(Dict(typemax(UInt64) => typemax(UInt64)), Val{Tuple{:fixed,:fixed}})    == ((1 + 8) + (1 + 8)) + 1
    @test _encoded_size(Dict(typemax(UInt64) => typemax(UInt64)), 1, Val{Tuple{:fixed,:fixed}}) == ((1 + 8) + (1 + 8)) + 2
    @test _encoded_size(Dict(typemax(Int32) => typemax(Int32)),  Val{Tuple{:fixed,:fixed}})    == ((1 + 4) + (1 + 4)) + 1
    @test _encoded_size(Dict(typemax(Int32) => typemax(Int32)),  1, Val{Tuple{:fixed,:fixed}}) == ((1 + 4) + (1 + 4)) + 2
    @test _encoded_size(Dict(typemax(Int64) => typemax(Int64)),  Val{Tuple{:fixed,:fixed}})    == ((1 + 8) + (1 + 8)) + 1
    @test _encoded_size(Dict(typemax(Int64) => typemax(Int64)),  1, Val{Tuple{:fixed,:fixed}}) == ((1 + 8) + (1 + 8)) + 2

    @test _encoded_size(Dict(typemax(Int32) => typemax(Int32)), Val{Tuple{:zigzag,:zigzag}})    == ((1 +  5) + (1 +  5)) + 1
    @test _encoded_size(Dict(typemax(Int32) => typemax(Int32)), 1, Val{Tuple{:zigzag,:zigzag}}) == ((1 +  5) + (1 +  5)) + 2
    @test _encoded_size(Dict(typemax(Int64) => typemax(Int64)), Val{Tuple{:zigzag,:zigzag}})    == ((1 + 10) + (1 + 10)) + 1
    @test _encoded_size(Dict(typemax(Int64) => typemax(Int64)), 1, Val{Tuple{:zigzag,:zigzag}}) == ((1 + 10) + (1 + 10)) + 2
    @test _encoded_size(Dict(typemin(Int32) => typemax(Int32)), Val{Tuple{:zigzag,:zigzag}})    == ((1 +  5) + (1 +  5)) + 1
    @test _encoded_size(Dict(typemin(Int32) => typemax(Int32)), 1, Val{Tuple{:zigzag,:zigzag}}) == ((1 +  5) + (1 +  5)) + 2
    @test _encoded_size(Dict(typemin(Int64) => typemax(Int64)), Val{Tuple{:zigzag,:zigzag}})    == ((1 + 10) + (1 + 10)) + 1
    @test _encoded_size(Dict(typemin(Int64) => typemax(Int64)), 1, Val{Tuple{:zigzag,:zigzag}}) == ((1 + 10) + (1 + 10)) + 2

    @test _encoded_size(typemax(Float32)) == 4
    @test _encoded_size(typemax(Float64)) == 8
    @test _encoded_size([typemax(Float32)]) == 4
    @test _encoded_size([typemax(Float64)]) == 8
    @test _encoded_size(Dict("K" => typemax(Float32)))    == ((1 + 1 + 1) + (1 + 4)) + 1
    @test _encoded_size(Dict("K" => typemax(Float32)), 1) == ((1 + 1 + 1) + (1 + 4)) + 2
    @test _encoded_size(Dict("K" => typemax(Float64)))    == ((1 + 1 + 1) + (1 + 8)) + 1
    @test _encoded_size(Dict("K" => typemax(Float64)), 1) == ((1 + 1 + 1) + (1 + 8)) + 2
end
end # module

function maybe_generate_deprecation(io, t::Union{MessageType, EnumType, ServiceType})
    if parse(Bool, get(t.options, "deprecated", "false"))
        name = safename(t)
        println(io, "Base.depwarn(\"`$(escape_string(name))` is deprecated.\", nameof($name))")
    end
end

function maybe_generate_reserved_fields_method(io, t::MessageType)
    isempty(t.reserved_names) && isempty(t.reserved_nums) && return
    println(io, "PB.reserved_fields(::Type{", safename(t), "}) = (names = ", string(t.reserved_names), ", numbers = Union{Int,UnitRange{Int}}[", join(t.reserved_nums, ", "), "])")
end

function maybe_generate_reserved_fields_method(io, t::EnumType)
    isempty(t.reserved_names) && isempty(t.reserved_nums) && return
    println(io, "PB.reserved_fields(::Type{", safename(t), ".T}) = (names = ", string(t.reserved_names), ", numbers = Union{Int,UnitRange{Int}}[", join(t.reserved_nums, ", "), "])")
end

function maybe_generate_extendable_field_numbers_method(io, t::MessageType)
    n = length(t.extensions)
    n == 0 && return
    print(io, "PB.extendable_field_numbers(::Type{", safename(t), "}) = Union{Int,UnitRange{Int}}[")
    print(io, string(t.extensions[1]))
    n == 1 && (println(io, "]"); return)
    for i in 2:n
        print(io, ", ")
        print(io, string(t.extensions[i]))
    end
    println(io, ']')
end

_get_fields(t::AbstractProtoType) = [t]
_get_fields(t::Union{OneOfType,MessageType}) = Iterators.flatten(Iterators.map(_get_fields, t.fields))

function maybe_generate_oneof_field_types_method(io, t::MessageType, ctx)
    oneofs = filter(x->isa(x, OneOfType), t.fields)
    n = length(oneofs)
    n == 0 && return
    print(io, "PB.oneof_field_types(::Type{", safename(t), "}) = (;")
    for oneof in oneofs
        n = length(oneof.fields)
        print(io, "\n    ", jl_fieldname(oneof), " = (;")
        for (i, field) in enumerate(oneof.fields)
            print(io, jl_fieldname(field), "=", jl_typename(field, ctx))
            i < n && print(io, ", ")
        end
        print(io, "),")
    end
    println(io, "\n)")
end

function _field_numbers_per_field(io, f::Union{FieldType,GroupType})
    print(io, jl_fieldname(f), " = ", string(f.number))
end
function _field_numbers_per_field(io, f::OneOfType)
    n = length(f.fields)
    for (i, field) in enumerate(f.fields)
        _field_numbers_per_field(io, field)
        i < n && print(io, ", ")
    end
end
function maybe_generate_field_numbers_method(io, t::MessageType)
    n = length(t.fields)
    n == 0 && return nothing
    print(io, "PB.field_numbers(::Type{", safename(t), "}) = (;")
    for (i, field) in enumerate(t.fields)
        _field_numbers_per_field(io, field)
        i < n && print(io, ", ")
    end
    println(io,  ')')
end

function _default_values_per_leaf_field(io, f::Union{FieldType,GroupType}, ctx::Context)
    @nospecialize
    val = jl_default_value(f, ctx)
    print(io, jl_fieldname(f), !isnothing(val) ? string(" = ", val) : "")
end
function _default_values_per_leaf_field(io, f::OneOfType, ctx::Context)
    n = length(f.fields)
    for (i, field) in enumerate(f.fields)
        _default_values_per_leaf_field(io, field, ctx)
        i < n && print(io, ", ")
    end
end
function maybe_generate_default_values_method(io, t::MessageType, ctx::Context)
    n = length(t.fields)
    n == 0 && return nothing
    print(io, "PB.default_values(::Type{", safename(t), "}) = (;")
    for (i, field) in enumerate(t.fields)
        _default_values_per_leaf_field(io, field, ctx)
        i < n && print(io, ", ")
    end
    println(io,  ')')
end

function maybe_generate_kwarg_constructor_method(io, t::MessageType, ctx::Context)
    n = length(t.fields)
    (!ctx.options.add_kwarg_constructors || n == 0) && return
    type_name = safename(t)
    print(io, "$(type_name)(;")
    for (i, field) in enumerate(t.fields)
        val = jl_default_value(field, ctx)
        print(io, jl_fieldname(field), !isnothing(val) ? string(" = ", val) : "")
        i < n && print(io, ", ")
    end
    print(io, ") = ")
    _maybe_parametrize_constructor_to_handle_oneofs(io, t, ctx)

    print(io, "(")
    for (i, field) in enumerate(t.fields)
        print(io, jl_fieldname(field))
        i < n && print(io, ", ")
    end
    println(io, ')')
end

function maybe_generate_constructor_for_type_alias(io, t::MessageType, ctx::Context)
    #=
    Type aliases are supposed to point to _concretized_ stub definitions of the types which
    we couldn't generate the normal way due to mutually recursive type dependencies. In case
    the stub definition also contains oneof fields and we parametrize oneofs, the alias would
    no longer be concretized and would would fail to type-match concrete OneOf instances
    as valid inputs. Here we generate a constructor for the alias that that provides the
    concrete types of all parameters to the stub definition. E.g:

    ```proto
    message A { B b = 1; }
    message B { oneof x { int32 i = 1; A a = 2; } }
    ```

    would generate the following types, constructors and aliases:

    ```julia
    using ProtoBuf: OneOf
    abstract type var"##Abstract#A" end
    abstract type var"##Abstract#B" end

    struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
        b::Union{Nothing,T1}
    end
    struct var"##Stub#B"{T1<:Union{Nothing,OneOf{<:Union{Int32,var"##Abstract#A"}}}} <: var"##Abstract#B"
        x::T1
    end

    const A = var"##Stub#A"{var"##Stub#B"{<:Union{Nothing,<:OneOf}}}
    const B = var"##Stub#B"{<:Union{Nothing,<:OneOf}}
    B(x) = var"##Stub#B"{typeof(x)}(x) # <- This is what we generate in this method
    ```
    Without the last line, we wouldn't be able to call B on concrete OneOf instances:
    ```julia
    julia> B(OneOf(:i, Int32(1)))
    ERROR: MethodError: no method matching (B)(::OneOf{Int32})
    Stacktrace:
    [1] top-level scope
    @ REPL[9]:1

    julia> B(x) = var"##Stub#B"{typeof(x)}(x)
    B (alias for var"##Stub#B"{<:Union{Nothing, var"#s31"} where var"#s31"<:OneOf})

    julia> B(OneOf(:i, Int32(1)))
    B{OneOf{Int32}}(OneOf{Int32}(:i, 1))
    ```
    =#
    !(ctx.options.parametrize_oneofs && t.has_oneof_field) && return
    n = length(t.fields)
    type_name = safename(t)
    print(io, "$(type_name)(")
    for (i, field) in enumerate(t.fields)
        print(io, jl_fieldname(field))
        i < n && print(io, ", ")
    end
    print(io, ") = ")
    _maybe_parametrize_constructor_to_handle_oneofs(io, t, ctx)

    print(io, "(")
    for (i, field) in enumerate(t.fields)
        print(io, jl_fieldname(field))
        i < n && print(io, ", ")
    end
    println(io, ')')
end

module Tokens

include("enums.jl")

struct Token
    kind::Kind
    error::Tokens.TokenError
    startpos::Tuple{Int,Int}  # row, col
    endtpos::Tuple{Int,Int}   # row, col
    val::String
end
function Token(kind::Kind, startposition::Tuple{Int, Int}, endposition::Tuple{Int, Int}, val::String)
    return Token(kind, NO_ERROR, startposition, endposition, val)
end
kind(t::Token) = t.kind
val(t::Token) = t.val

end #module

function get_upstream_dependencies!(m::ProtoModule, upstreams)
    ns = namespace(m)
    for i in m.internal_imports
        length(i) >= length(ns) && !_startswith(ns, i) && push!(upstreams, i)
    end
    for s in values(m.submodules)
        _get_upstream_dependencies!(s, upstreams, m)
    end
    delete!(upstreams, namespace(m))
end

function _get_upstream_dependencies!(m::ProtoModule, upstreams, root)
    ns = namespace(root)
    for i in m.internal_imports
        length(i) >= length(ns) && !_startswith(ns, i) && push!(upstreams, i)
    end
    for s in values(m.submodules)
        _get_upstream_dependencies!(s, upstreams, root)
    end
end


function get_all_transitive_imports!(resolved_file::ResolvedProtoFile, file_map)
    _get_all_transitive_imports!(resolved_file.transitive_imports, resolved_file.proto_file, file_map)
    return nothing
end

function _get_all_transitive_imports!(seen::Set{String}, proto_file::ProtoFile, file_map, depth=0)
    for i in proto_file.preamble.imports
        ((depth > 1) && i.import_option != Parsers.PUBLIC) && continue
        push!(seen, i.path)
        _get_all_transitive_imports!(seen, file_map[i.path].proto_file, file_map, depth+1)
    end
end

function get_upstream_dependencies!(file::ResolvedProtoFile, upstreams)
    # for path in file.transitive_imports
    #     push!(upstreams, path)
    # end
    for path in file.implicit_imports
        push!(upstreams, path)
    end
end

struct InterFileResolvingContext <: Parsers.AbstractResolvingContext
    options::Options
    file_map::Dict
    resolved_file::ResolvedProtoFile
end

function resolve_inter_package_references!(file_map, options)
    for file in values(file_map)
        rctx = InterFileResolvingContext(options, file_map, file)
        for definition in values(file.proto_file.definitions)
            Parsers._postprocess_type!(definition, rctx)
        end
    end
end

_maybe_top_namespace(p) = isempty(namespace(p)) ? nothing : first(namespace(p))
function Parsers._postprocess_reference!(t::ReferencedType, rctx::InterFileResolvingContext, ::String)
    if !t.resolved
        found = false
        ns = namespace(rctx.resolved_file)
        root_namespace = isempty(ns) ? "" : first(ns)
        # We can't import the toplevel module to a leaf module if their names collapse
        # we also need to tweak the import statement in `generate_module_file`
        namespaces_clash = length(ns) > 1 && first(ns) == last(ns)
        for import_path in rctx.resolved_file.transitive_imports
            imported_file = rctx.file_map[import_path].proto_file
            ins = namespace(imported_file)
            package_name_dot = string(join(ins, '.'), '.')
            # If fully qualified
            # When we see type.name == "A.B.C", can it match package A.B for def C and package A for def B.C?
            # No, these definitions would name-clash with module names
            if root_namespace == _maybe_top_namespace(imported_file)
                # Same root package namespace, different leaf package namespace ([[[A.]B.]C.]type x [[[A.]B.]D.]type)
                matched_prefix = Parsers.match_prefix(package_name_dot, t.name)
                name_without_import = @view(t.name[length(matched_prefix)+1:end])
                def = get(imported_file.definitions, name_without_import, nothing)
                isnothing(def) && continue
                t.name = name_without_import
                ins == ns && push!(rctx.resolved_file.implicit_imports, import_path)
                found = true
            elseif startswith(t.name, package_name_dot)
                # Referring to a type from a different package (A.B.C.type x X.Y.Z.type)
                name_without_import = @view(t.name[length(package_name_dot)+1:end])
                def = get(imported_file.definitions, name_without_import, nothing)
                isnothing(def) && continue
                t.name = name_without_import
                found = true
            else
                # The name is not qualified.
                def = get(imported_file.definitions, t.name, nothing)
                isnothing(def) && continue
                if !isempty(ins)
                    # Same package, different file -> no package prefix needed
                    if ns != ins
                        t.package_namespace = namespaces_clash ? _safe_namespace_string(ins) : join(ins, '.')
                    end
                elseif rctx.options.always_use_modules
                    t.package_namespace = replace(proto_script_name(imported_file), ".jl" => "")
                end
                t.package_import_path = import_path
                t.reference_type = Parsers.reference_type(def, t)
                t.resolved = true
                return def
            end
            if found
                # Same package, different file -> no package prefix needed
                if ns != ins
                    t.package_namespace = namespaces_clash ? _safe_namespace_string(ins) : join(ins, '.')
                end
                t.package_import_path = import_path
                t.reference_type = Parsers.reference_type(def, t)
                t.resolved = true
                return def
            end
        end
        throw(error("Couldn't find $(t.name) among $(vcat([rctx.resolved_file.proto_file.filepath], collect(rctx.file_map[i].proto_file.filepath for i in rctx.resolved_file.transitive_imports)))"))
    else
        if isnothing(t.package_import_path)
            return rctx.resolved_file.proto_file.definitions[t.name]
        else
            return rctx.file_map[t.package_import_path].proto_file.definitions[t.name]
        end
    end
end

function _startswith(prefix, path)
    isempty(prefix) && return true
    length(prefix) > length(path) && return false
    i = 1
    while i <= length(prefix)
        @inbounds prefix[i] != path[i] && return false
        i += 1
    end
    return true
end

function _cyclic_defs(p::ProtoFile)
    ncyclic = length(p.cyclic_definitions)
    return @view(p.sorted_definitions[(end-ncyclic+1):end])
end
function _non_cyclic_defs(p::ProtoFile)
    ncyclic = length(p.cyclic_definitions)
    return @view(p.sorted_definitions[begin:(end-ncyclic)])
end

# abstract type ProtoValue end

# struct StringValue <: ProtoValue;     val::String end
# struct DecIntegerValue <: ProtoValue; val::String end
# struct OctIntegerValue <: ProtoValue; val::String end
# struct HexIntegerValue <: ProtoValue; val::String end
# struct FloatValue <: ProtoValue;      val::String end
# struct BoolValue <: ProtoValue;       val::String end
# struct ReferencedValue <: ProtoValue; val::String end

# # TODO: handle +,-... separate inf?
# function parse_value(ps::ParserState)
#     nk = dpeekkind(ps)
#     if nk == Tokens.ENDMARKER
#         return nothing 
#     elseif nk == Tokens.DEC_INT_LIT DecIntegerValue(val(readtoken(ps)))
#     elseif nk == Tokens.OCT_INT_LIT OctIntegerValue(val(readtoken(ps)))
#     elseif nk == Tokens.HEX_INT_LIT HexIntegerValue(val(readtoken(ps)))
#     elseif nk == Tokens.FLOAT_LIT   FloatValue(val(readtoken(ps)))
#     elseif nk == Tokens.STRING_LIT  StringValue(val(readtoken(ps)))
#     # elseif nk == Tokens.BYTES_LIT   
#     elseif nk == Tokens.TRUE        readtoken(ps); BoolValue("true")
#     elseif nk == Tokens.FALSE       readtoken(ps); BoolValue("false")
#     elseif nk == Tokens.IDENTIFIER  ReferencedValue(val(readtoken(ps)))
#     else
#         ps.errored = true
#         error("Unsupported value token $(peektoken(ps)) ($(nk))")
#     end

# end

_max_varint_size(::Type{T}) where {T} = (sizeof(T) + (sizeof(T) >> 2))

_varint_size(x) = cld((8sizeof(x) - leading_zeros(x)), 7)
_varint_size(x::Enum) = _varint_size(reinterpret(UInt32, x))
_varint_size(x::Int32) = x < 0 ? _varint_size(Int64(x)) : _varint_size(reinterpret(UInt32, x))
_varint_size1(x) = max(1, _varint_size(x))

# We don't include the field number and tag into the size, it is the responsibility of the
# per-struct generated methods to account for them.

# For scalars, we can't be sure about their size as they could be omitted completely
# (we're not sending default values over the wire)
_encoded_size(x::Nothing) = 0 # this shouldn't really happen
_encoded_size(x::T) where {T<:Union{Int32,UInt32,Int64,UInt64,Enum}} = _varint_size1(x)
_encoded_size(x::T, ::Type{Val{:zigzag}}) where {T<:Union{UInt32,UInt64}} = _varint_size1(zigzag_encode(x))
_encoded_size(x::T, ::Type{Val{:zigzag}}) where {T<:Union{Int32,Int64}} = _varint_size1(reinterpret(unsigned(T), zigzag_encode(x)))
_encoded_size(x::T) where {T<:Union{Bool,Float64,Float32}} = sizeof(x)
_encoded_size(x::T, ::Type{Val{:fixed}}) where {T<:Union{Int32,UInt32,Int64,UInt64}} = sizeof(x)

# For Length-Delimited fields we don't include the encoded number of bytes
# unless we also provide the field number in which case we encode both the
# tag and length
_with_size(n::Int) = (n + _encoded_size(n))
_encoded_size(x::String) = sizeof(x)

_encoded_size(xs::AbstractVector{T}) where {T<:Union{Int32,UInt32,Int64,UInt64,Enum}} = sum(_varint_size1, xs, init=0)
_encoded_size(xs::AbstractVector{T}, ::Type{Val{:zigzag}}) where {T<:Union{Int32,UInt32,Int64,UInt64}} = sum(x->_encoded_size(x, Val{:zigzag}), xs, init=0)
_encoded_size(xs::AbstractVector{T}) where {T<:Union{UInt8,Bool,Float64,Float32}} = sizeof(xs)
_encoded_size(xs::AbstractVector{T}) where {T<:Union{String,AbstractVector{UInt8}}} = sum(x->_with_size(_encoded_size(x)), xs, init=0)
_encoded_size(xs::AbstractVector{T}, ::Type{Val{:fixed}}) where {T<:Union{Int32,UInt32,Int64,UInt64}} = sizeof(xs)

# Dicts add dummy tags to both keys and values and to each pair
# _encoded_size(::AbstractDict) does not include the "pair" tag and field number
# those are added in the _encoded_size(::AbstractDict, ::Int) methods below because the field number
# is not known at this point
function _encoded_size(d::AbstractDict)
    mapreduce(x->begin
        total_size = _encoded_size(x.first, 1) + _encoded_size(x.second, 2)
        return _varint_size(total_size) + total_size
    end, +, d, init=0)
end
_encoded_size(xs::AbstractDict, i::Int)  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs)

for T in (:(:fixed), :(:zigzag))
    @eval _encoded_size(d::AbstractDict, ::Type{Val{Tuple{$(T),Nothing}}}) = mapreduce(x->begin
        total_size = _encoded_size(x.first, 1, Val{$(T)}) + _encoded_size(x.second, 2)
        return _varint_size(total_size) + total_size
    end, +, d, init=0)
    @eval _encoded_size(xs::AbstractDict, i::Int, ::Type{Val{Tuple{$(T),Nothing}}})  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs, Val{Tuple{$(T),Nothing}})

    @eval _encoded_size(d::AbstractDict, ::Type{Val{Tuple{Nothing,$(T)}}}) = mapreduce(x->begin
        total_size = _encoded_size(x.first, 1) + _encoded_size(x.second, 2, Val{$(T)})
        return _varint_size(total_size) + total_size
    end, +, d, init=0)
    @eval _encoded_size(xs::AbstractDict, i::Int, ::Type{Val{Tuple{Nothing,$(T)}}})  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs, Val{Tuple{Nothing,$(T)}})

    @eval _encoded_size(xs::AbstractVector, i::Int, ::Type{Val{$(T)}}) = _encoded_size(i << 3) + _with_size(_encoded_size(xs, Val{$(T)}))
    @eval _encoded_size(xs::Union{Int32,Int64,UInt64,UInt32}, i::Int, ::Type{Val{$(T)}}) = _encoded_size(i << 3) + _encoded_size(xs, Val{$(T)})
end

for T in (:(:fixed), :(:zigzag)), S in (:(:fixed), :(:zigzag))
    @eval _encoded_size(d::AbstractDict, ::Type{Val{Tuple{$(T),$(S)}}}) = mapreduce(x->begin
        total_size = _encoded_size(x.first, 1, Val{$(T)}) + _encoded_size(x.second, 2, Val{$(S)})
        return _varint_size(total_size) + total_size
    end, +, d, init=0)
    @eval _encoded_size(xs::AbstractDict, i::Int, ::Type{Val{Tuple{$(T),$(S)}}})  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs, Val{Tuple{$(T),$(S)}})
end

# These methods handle fields that refer to messages/groups
_encoded_size(xs, i::Int)                      = _encoded_size(i << 3) + _with_size(_encoded_size(xs))
_encoded_size(xs, i::Int, ::Type{Val{:group}}) = _encoded_size(i << 3) + _encoded_size(xs) + 2

# These methods handle vectors of messages, these (like strings and bytes) are not "packed"
_encoded_size(xs::AbstractArray)          = sum(x->_with_size(_encoded_size(x)), xs, init=0)
_encoded_size(xs::AbstractArray, i::Int)  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs)

_encoded_size(xs::AbstractArray, ::Type{Val{:group}})          = sum(x->_encoded_size(x) + 2, xs, init=0)
_encoded_size(xs::AbstractArray, i::Int, ::Type{Val{:group}})  = _encoded_size(i << 3) * length(xs) + _encoded_size(xs, Val{:group})

_encoded_size(xs::Union{AbstractString,AbstractVector{UInt8}}, i::Int) = _encoded_size(i << 3) + _with_size(_encoded_size(xs))
function _encoded_size(xs::AbstractVector{T}, i::Int) where {T<:Union{Float64,Float32,Int32,Int64,UInt64,UInt32,Bool,Enum}}
    return _encoded_size(i << 3) + _with_size(_encoded_size(xs))
end
function _encoded_size(xs::Union{Float64,Float32,Int32,Int64,UInt64,UInt32,Bool,Enum}, i::Int)
    return _encoded_size(i << 3) + _encoded_size(xs)
end

using ProtoBuf: Lexers
using .Lexers: Tokens
using Test

const KEYWORDS_AND_TYPES = Dict{String, Tokens.Kind}()
@test allunique(Lexers._PROTOBUF_TYPES_AND_KEYWORDS)
for k in instances(Tokens.Kind)
    if Tokens.is_reserved_word(k) || k == Tokens.TRUE || k == Tokens.FALSE
        KEYWORDS_AND_TYPES[lowercase(string(k))] = k
    end
end
@test isempty(symdiff(keys(KEYWORDS_AND_TYPES), Lexers._PROTOBUF_TYPES_AND_KEYWORDS))


function lexer_test(s, k::Union{Tokens.Kind, Tokens.TokenError}, value=s)
    toks = collect(Lexers.Lexer(IOBuffer(s)))
    pop!(toks) # pop Token.ENDMARKER
    @test length(toks) == 1
    tok = toks[1]
    @testset "Lex $(repr(s)), expected token: $(k), (val: $(repr(value)))" begin
        if isa(k, Tokens.TokenError)
            @test tok.kind == Tokens.ERROR
            @test tok.error == k
        else
            @test tok.kind == k
            @test tok.error == Tokens.NO_ERROR
        end
        @test tok.val == value
    end
end

function lexer_test_first(s, k::Union{Tokens.Kind, Tokens.TokenError}, value=s)
    tok = first(collect(Lexers.Lexer(IOBuffer(s))))
    @testset "Lex $(repr(s)), expected token: $(k), (val: $(repr(value)))" begin
        if isa(k, Tokens.TokenError)
            @test tok.kind == Tokens.ERROR
            @test tok.error == k
        else
            @test tok.kind == k
            @test tok.error == Tokens.NO_ERROR
        end
        @test tok.val == value
    end
end

@testset "Lexers" begin
    @testset "comment" begin
        lexer_test("#", Tokens.COMMENT)
        lexer_test("##", Tokens.COMMENT)
        lexer_test_first("## \n aa", Tokens.COMMENT, "## ")

        lexer_test("//", Tokens.COMMENT)
        lexer_test("///", Tokens.COMMENT)
        lexer_test_first("// \n aa", Tokens.COMMENT, "// ")

        lexer_test("/**/", Tokens.COMMENT)
        lexer_test("/*a\nb*/", Tokens.COMMENT)
        lexer_test("/*/**/*/", Tokens.COMMENT)
        lexer_test("/*/**//**//*/**/*/*/", Tokens.COMMENT)
        lexer_test("/* /* */", Tokens.EOF_MULTICOMMENT)
    end

    @testset "string literals" begin
        lexer_test("\"a\"", Tokens.STRING_LIT)
        lexer_test("'a'", Tokens.STRING_LIT)
        lexer_test("\"proto3\"", Tokens.STRING_LIT)
        lexer_test(raw"'\uffff'", Tokens.STRING_LIT)
        lexer_test(raw"'\xff'", Tokens.STRING_LIT)
        lexer_test(raw"'\777'", Tokens.STRING_LIT)
        lexer_test(raw"'\U000fffff'", Tokens.STRING_LIT)
        lexer_test(raw"'\U0010ffff'", Tokens.STRING_LIT)
    end

    @testset "numeric literals" begin
        lexer_test("0", Tokens.DEC_INT_LIT)
        lexer_test("01", Tokens.OCT_INT_LIT)
        lexer_test("123", Tokens.DEC_INT_LIT)
        lexer_test("123E", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123E+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123E-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123E-0", Tokens.FLOAT_LIT)
        lexer_test("123E-1", Tokens.FLOAT_LIT)
        lexer_test("123E-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123E+0", Tokens.FLOAT_LIT)
        lexer_test("123E+1", Tokens.FLOAT_LIT)
        lexer_test("123E+01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123e", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123e+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123e-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123e-0", Tokens.FLOAT_LIT)
        lexer_test("123e-1", Tokens.FLOAT_LIT)
        lexer_test("123e-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123e+0", Tokens.FLOAT_LIT)
        lexer_test("123e+1", Tokens.FLOAT_LIT)
        lexer_test("123e+01", Tokens.INVALID_NUMERIC_CONSTANT)

        lexer_test("0.0", Tokens.FLOAT_LIT)
        lexer_test("0.456", Tokens.FLOAT_LIT)
        lexer_test_first("01.456", Tokens.OCT_INT_LIT, "01")
        lexer_test("123.4", Tokens.FLOAT_LIT)
        lexer_test("123.456", Tokens.FLOAT_LIT)
        lexer_test("51.5", Tokens.FLOAT_LIT)
        lexer_test_first("123E.456", Tokens.INVALID_NUMERIC_CONSTANT, "123E")
        lexer_test("123.456E", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456E+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456E-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456E-0", Tokens.FLOAT_LIT)
        lexer_test("123.456E-1", Tokens.FLOAT_LIT)
        lexer_test("123.456E-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456E+0", Tokens.FLOAT_LIT)
        lexer_test("123.456E+1", Tokens.FLOAT_LIT)
        lexer_test("123.456E+01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456e", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456e+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456e-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456e-0", Tokens.FLOAT_LIT)
        lexer_test("123.456e-1", Tokens.FLOAT_LIT)
        lexer_test("123.456e-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.456e+0", Tokens.FLOAT_LIT)
        lexer_test("123.456e+1", Tokens.FLOAT_LIT)
        lexer_test("123.456e+01", Tokens.INVALID_NUMERIC_CONSTANT)

        lexer_test("0.", Tokens.FLOAT_LIT)
        lexer_test_first("01.", Tokens.OCT_INT_LIT, "01")
        lexer_test("123.", Tokens.FLOAT_LIT)
        lexer_test_first("123E.", Tokens.INVALID_NUMERIC_CONSTANT, "123E")
        lexer_test("123.E", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.E+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.E-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.E-0", Tokens.FLOAT_LIT)
        lexer_test("123.E-1", Tokens.FLOAT_LIT)
        lexer_test("123.E-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.E+0", Tokens.FLOAT_LIT)
        lexer_test("123.E+1", Tokens.FLOAT_LIT)
        lexer_test("123.E+01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.e", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.e+", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.e-", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.e-0", Tokens.FLOAT_LIT)
        lexer_test("123.e-1", Tokens.FLOAT_LIT)
        lexer_test("123.e-01", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("123.e+0", Tokens.FLOAT_LIT)
        lexer_test("123.e+1", Tokens.FLOAT_LIT)
        lexer_test("123.e+01", Tokens.INVALID_NUMERIC_CONSTANT)

        lexer_test("0x", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("0x0123456789abcdefABCDEF", Tokens.HEX_INT_LIT)
        lexer_test_first("0xG", Tokens.INVALID_NUMERIC_CONSTANT, "0x")
        lexer_test_first("0x1G", Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION, "0x1")
        lexer_test("0X", Tokens.INVALID_NUMERIC_CONSTANT)
        lexer_test("0X0123456789abcdefABCDEF", Tokens.HEX_INT_LIT)
        lexer_test_first("0X1G", Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION, "0X1")

        lexer_test("01234567", Tokens.OCT_INT_LIT)
        lexer_test_first("08", Tokens.INVALID_NUMERIC_CONSTANT, "0")
        lexer_test_first("01G", Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION, "01")
        lexer_test_first("0G", Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION, "0")
    end

    @testset "single letter lexical items" begin
        lexer_test("{", Tokens.LBRACE, "")
        lexer_test("}", Tokens.RBRACE, "")
        lexer_test(">", Tokens.GREATER, "")
        lexer_test("<", Tokens.LESS, "")
        lexer_test(",", Tokens.COMMA, "")
        lexer_test(".", Tokens.DOT, "")
        lexer_test("(", Tokens.LPAREN, "")
        lexer_test(")", Tokens.RPAREN, "")
        lexer_test("[", Tokens.LBRACKET, "")
        lexer_test("]", Tokens.RBRACKET, "")
        lexer_test("+", Tokens.PLUS, "")
        lexer_test("-", Tokens.MINUS, "")
        lexer_test(":", Tokens.COLON, "")
        lexer_test("=", Tokens.EQ, "")
        lexer_test(";", Tokens.SEMICOLON, "")
        lexer_test("\\", Tokens.BACKWARD_SLASH, "")
        lexer_test("/", Tokens.FORWARD_SLASH, "")
    end

    @testset "test quotes" begin
        lexer_test("\"\\\\\"", Tokens.STRING_LIT)
        lexer_test("\"\\a\"", Tokens.STRING_LIT)
        lexer_test("\"\\b\"", Tokens.STRING_LIT)
        lexer_test("\"\\f\"", Tokens.STRING_LIT)
        lexer_test("\"\\n\"", Tokens.STRING_LIT)
        lexer_test("\"\\r\"", Tokens.STRING_LIT)
        lexer_test("\"\\t\"", Tokens.STRING_LIT)
        lexer_test("\"\\v\"", Tokens.STRING_LIT)
        lexer_test("\"\\'\"", Tokens.STRING_LIT, "\"'\"")
        lexer_test("\"\\0\"", Tokens.STRING_LIT)
        lexer_test("\"'\"", Tokens.STRING_LIT)

        lexer_test("'\\\\'", Tokens.STRING_LIT)
        lexer_test("'\\a'", Tokens.STRING_LIT)
        lexer_test("'\\b'", Tokens.STRING_LIT)
        lexer_test("'\\f'", Tokens.STRING_LIT)
        lexer_test("'\\n'", Tokens.STRING_LIT)
        lexer_test("'\\r'", Tokens.STRING_LIT)
        lexer_test("'\\t'", Tokens.STRING_LIT)
        lexer_test("'\\v'", Tokens.STRING_LIT)
        lexer_test("'\\''", Tokens.STRING_LIT, "'''")
        lexer_test("'\\0'", Tokens.STRING_LIT)
        lexer_test("'\"'", Tokens.STRING_LIT)

        lexer_test("\"Hello\\\"World\\\"\"", Tokens.STRING_LIT)
        lexer_test("\"\\0\\001\\a\\b\\f\\n\\r\\t\\v\\\\\\'\\\"\\xfe\"", Tokens.STRING_LIT, "\"\\0\\001\\a\\b\\f\\n\\r\\t\\v\\\\'\\\"\\xfe\"")
        lexer_test("\"\\?\"", Tokens.STRING_LIT, "\"?\"")
        lexer_test("\"\${\"", Tokens.STRING_LIT, "\"\\\${\"")
        lexer_test("'Hello\\\"World\\\"'", Tokens.STRING_LIT)
        lexer_test("'\\0\\001\\a\\b\\f\\n\\r\\t\\v\\\\\\'\\\"\\xfe'", Tokens.STRING_LIT, "'\\0\\001\\a\\b\\f\\n\\r\\t\\v\\\\'\\\"\\xfe'")
        lexer_test("'\\?'", Tokens.STRING_LIT, "'?'")
        lexer_test("'\${'", Tokens.STRING_LIT, "'\\\${'")
    end

    @testset "identifiers" begin
        lexer_test("abc", Tokens.IDENTIFIER)
        lexer_test("a.b.c", Tokens.IDENTIFIER)
        lexer_test(".a.b.c", Tokens.IDENTIFIER)
    end

    @testset "keywords and types" begin
        for w in Lexers._PROTOBUF_TYPES_AND_KEYWORDS
            lexer_test(w, KEYWORDS_AND_TYPES[w])
        end
    end
end

# using SnoopCompileCore
# import ProtoBuf as PB
# tinf = @snoopi tmin=0.005 PB.protojl("test_protos/google/protobuf/unittest.proto", ["./test/", "./test/test_protos/"], "dev/tst2")
# tinf = @snoopi tmin=0.005 PB.protojl("datasets/google_message3/benchmark_message3.proto", ["./test/test_protos/benchmarks"], "dev/tst2")
# tinf = @snoopi tmin=0.005 PB.protojl("datasets/google_message4/benchmark_message4.proto", ["./test/test_protos/benchmarks"], "dev/tst2")

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    @assert precompile(Lexers.next_token, (Lexers.Lexer{IOBuffer},))

    @assert precompile(CodeGenerators._protojl, (String, Vector{String}, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (String, String, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (String, Vector{String}, Nothing, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (String, String, Nothing, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (String, Nothing, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (String, Nothing, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, Vector{String}, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, String, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, Vector{String}, Nothing, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, String, Nothing, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, Nothing, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators._protojl, (Vector{String}, Nothing, String, CodeGenerators.Options))
    @assert precompile(CodeGenerators.codegen, (IOStream, Parsers.MessageType, CodeGenerators.Context))
    @assert precompile(CodeGenerators.codegen, (IOStream, Parsers.EnumType, CodeGenerators.Context))
    @assert precompile(CodeGenerators.generate_struct_field, (IOStream, Parsers.FieldType{Parsers.ReferencedType}, CodeGenerators.Context, Dict{String, CodeGenerators.ParamMetadata}))
    @assert precompile(CodeGenerators.jl_typename, (Parsers.ReferencedType, CodeGenerators.Context))
    @assert precompile(CodeGenerators.print_field_encode_expr, (IOStream, Parsers.FieldType{Parsers.StringType}, CodeGenerators.Context))
    # mktempdir() do tmpdir
    #     protojl("google/protobuf/unittest.proto", joinpath("test", "test_protos"), tmpdir; add_kwarg_constructors=true)
    # end
end

using BenchmarkTools
using ProtoBuf
using EnumX

using ProtoBuf.Codecs: BufferedVector, LENGTH_DELIMITED


@enumx TestEnum a b c d e

Base.rand(::Type{TestEnum.T}) = TestEnum.T(rand(Int(TestEnum.a):Int(TestEnum.e)))
Base.rand(::Type{TestEnum.T}, n::Int) = TestEnum.T.(rand(Int(TestEnum.a):Int(TestEnum.e), n))

const N = (1, 63, 256)
const W = LENGTH_DELIMITED

SUITE = BenchmarkGroup()
SUITE["encode"] = BenchmarkGroup()
SUITE["encode"]["scalar"] = BenchmarkGroup()
SUITE["encode"]["repeated"] = BenchmarkGroup()
SUITE["decode"] = BenchmarkGroup()
SUITE["decode"]["scalar"] = BenchmarkGroup()
SUITE["decode"]["repeated"] = BenchmarkGroup()

function setup_decoder(x)
    io = IOBuffer()
    d = ProtoDecoder(io)
    e = ProtoEncoder(io)
    encode(e, 1, x)
    seekstart(io)
    ProtoBuf.Codecs.decode_tag(d)
    return d
end

function setup_decoder(x, V)
    io = IOBuffer()
    d = ProtoDecoder(io)
    e = ProtoEncoder(io)
    encode(e, 1, x, V)
    seekstart(io)
    ProtoBuf.Codecs.decode_tag(d)
    return d
end


for (field_type, jl_type) in (
        ("uint32", UInt32), ("uint64", UInt64), ("int32", Int32), ("int64", Int64),
        ("float", Float32), ("double", Float64), ("enum", TestEnum.T),
    )
    SUITE["encode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["encode"]["scalar"][field_type] = @benchmarkable encode(e, 1, x) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type))
    for n in N
        SUITE["encode"]["repeated"][field_type][n] = @benchmarkable encode(e, 1, x) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type, $n))
    end
end

for (field_type, jl_type) in (("sint32", Int32), ("sint64", Int64),)
    SUITE["encode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["encode"]["scalar"][field_type] = @benchmarkable encode(e, 1, x, $(Val{:zigzag})) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type))
    for n in N
        SUITE["encode"]["repeated"][field_type][n] = @benchmarkable encode(e, 1, x, $(Val{:zigzag})) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type, $n))
    end
end

for (field_type, jl_type) in (("sfixed32", Int32), ("sfixed64", Int64), ("fixed32", UInt32), ("fixed64", UInt64))
    SUITE["encode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["encode"]["scalar"][field_type] = @benchmarkable encode(e, 1, x, $(Val{:fixed})) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type))
    for n in N
        SUITE["encode"]["repeated"][field_type][n] = @benchmarkable encode(e, 1, x, $(Val{:fixed})) evals=1 samples=50000 setup=(e=ProtoEncoder(IOBuffer()); x = rand($jl_type, $n))
    end
end


for (field_type, jl_type) in (
    ("uint32", UInt32), ("uint64", UInt64), ("int32", Int32), ("int64", Int64),
    ("float", Float32), ("double", Float64), ("enum", TestEnum.T),
)
    SUITE["decode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["decode"]["scalar"][field_type] = @benchmarkable decode(d, $(jl_type)) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type)))
    for n in N
        SUITE["decode"]["repeated"][field_type][n] = @benchmarkable decode!(d, W, b) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type, $n)); b = $(BufferedVector{jl_type}()))
    end
end

for (field_type, jl_type) in (("sint32", Int32), ("sint64", Int64),)
    SUITE["decode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["decode"]["scalar"][field_type] = @benchmarkable decode(d, $(jl_type), $(Val{:zigzag})) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type), Val{:zigzag}))
    for n in N
        SUITE["decode"]["repeated"][field_type][n] = @benchmarkable decode!(d, W, b, $(Val{:zigzag})) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type, $n), Val{:zigzag}); b = $(BufferedVector{jl_type}()))
    end
end

for (field_type, jl_type) in (("sfixed32", Int32), ("sfixed64", Int64), ("fixed32", UInt32), ("fixed64", UInt64))
    SUITE["decode"]["repeated"][field_type] = BenchmarkGroup()
    SUITE["decode"]["scalar"][field_type] = @benchmarkable decode(d, $(jl_type), $(Val{:fixed})) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type), Val{:fixed}))
    for n in N
        SUITE["decode"]["repeated"][field_type][n] = @benchmarkable decode!(d, W, b, $(Val{:fixed})) evals=1 samples=50000 setup=(d=setup_decoder(rand($jl_type, $n), Val{:fixed}); b = $(BufferedVector{jl_type}()))
    end
end


# results = run(SUITE, verbose=true, seconds=60);
# BenchmarkTools.save(joinpath(@__DIR__, "tune.json"), params(SUITE));

using JET
using ProtoBuf: Codecs
using .Codecs: vbyte_decode, vbyte_encode, _encoded_size
using Test
using EnumX

@enumx TestEnum DEFAULT OTHER

macro test_noalloc(e)
    s = gensym(:allocs)
    alloc_expr = Expr(:macrocall, Symbol("@allocated"), __source__, e)
    test_expr = Expr(:macrocall, Symbol("@test"), __source__,
        Expr(:call, :(==), s, 0))
    esc(quote
        $s = $alloc_expr
        $s == 0 || ($s = $alloc_expr)
        $s == 0 || ($s = $alloc_expr)
        $s == 0 || ($s = $alloc_expr)
        $test_expr
    end)
end
io = IOBuffer(sizehint=8*1024*1024)

@test_opt vbyte_encode(io, typemax(UInt32))
@test_opt vbyte_encode(io, typemax(UInt64))
@test_opt vbyte_decode(io, UInt32)
@test_opt vbyte_decode(io, UInt64)

# to avoid compilation allocs
vbyte_encode(io, typemax(UInt32))
seekstart(io)
vbyte_decode(io, UInt32)
vbyte_encode(io, typemax(UInt64))
seekstart(io)
vbyte_decode(io, UInt64)

# A vbyte_decode that throws away the value so we don't count the results in the allocation tests
vbyte_decode_and_forget(::Type{T}, io) where {T} = (seekstart(io); vbyte_decode(io, T); nothing)

seekstart(io)
let x = typemax(UInt32)
    vbyte_encode(io, x)
end
vbyte_decode_and_forget(UInt32, io)

let x = typemax(UInt64)
    vbyte_encode(io, x)
end
vbyte_decode_and_forget(UInt64, io)

@enumx TestEnum DEFAULT=0 OTHER=1

struct EmptyMessage end
Codecs._encoded_size(x::EmptyMessage) = 0

abstract type var"##AbstractNonEmptyMessage" end
struct NonEmptyMessage <: var"##AbstractNonEmptyMessage"
    x::UInt32
    self_referential_field::Union{Nothing,NonEmptyMessage}
end
function Codecs._encoded_size(x::NonEmptyMessage)
    encoded_size = 0
    x.x != zero(UInt32) && (encoded_size += _encoded_size(x.x, 1))
    !isnothing(x.self_referential_field) && (encoded_size += _encoded_size(x.self_referential_field, 2))
    return encoded_size
end

# precompile
_encoded_size(UInt8[0xff])
_encoded_size("S")
_encoded_size(typemax(UInt32))
_encoded_size(typemax(UInt64))
_encoded_size(typemax(Int32))
_encoded_size(typemax(Int64))
_encoded_size(true)
_encoded_size(typemax(Int32), Val{:zigzag})
_encoded_size(typemax(Int64), Val{:zigzag})
_encoded_size(typemax(Int32), Val{:zigzag})
_encoded_size(typemax(Int64), Val{:zigzag})
_encoded_size(TestEnum.OTHER)
_encoded_size(typemax(Int32), Val{:fixed})
_encoded_size(typemax(Int64), Val{:fixed})
_encoded_size(typemax(UInt32), Val{:fixed})
_encoded_size(typemax(UInt64), Val{:fixed})
_encoded_size(EmptyMessage())
_encoded_size(NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing)))

_encoded_size([UInt8[0xff]])
_encoded_size(["S"])
_encoded_size([typemax(UInt32)])
_encoded_size([typemax(UInt64)])
_encoded_size([typemax(Int32)])
_encoded_size([typemax(Int64)])
_encoded_size([true])
_encoded_size([typemax(Int32)], Val{:zigzag})
_encoded_size([typemax(Int64)], Val{:zigzag})
_encoded_size([typemax(UInt32)], Val{:zigzag})
_encoded_size([typemax(UInt64)], Val{:zigzag})
_encoded_size([TestEnum.OTHER])
_encoded_size([typemax(Int32)], Val{:fixed})
_encoded_size([typemax(Int64)], Val{:fixed})
_encoded_size([typemax(UInt32)], Val{:fixed})
_encoded_size([typemax(UInt64)], Val{:fixed})
_encoded_size([EmptyMessage()])
_encoded_size([NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))])
_encoded_size(Dict("K" => UInt8[0xff]))
_encoded_size(Dict("K" => "S"))
_encoded_size(Dict("KEY" => "STR"))
_encoded_size(Dict("K" => typemax(UInt32)))
_encoded_size(Dict("K" => typemax(UInt64)))
_encoded_size(Dict("K" => typemax(Int32)))
_encoded_size(Dict("K" => typemax(Int64)))
_encoded_size(Dict("K" => true))
_encoded_size(Dict("K" => typemax(Int32)), Val{Tuple{Nothing,:zigzag}})
_encoded_size(Dict("K" => typemax(Int64)), Val{Tuple{Nothing,:zigzag}})
_encoded_size(Dict("K" => typemin(Int32)), Val{Tuple{Nothing,:zigzag}})
_encoded_size(Dict("K" => typemin(Int64)), Val{Tuple{Nothing,:zigzag}})
_encoded_size(Dict("K" => TestEnum.OTHER))

_encoded_size(Dict("K" => typemax(UInt32)), Val{Tuple{Nothing,:fixed}})
_encoded_size(Dict("K" => typemax(UInt64)), Val{Tuple{Nothing,:fixed}})
_encoded_size(Dict("K" => typemax(Int32)),  Val{Tuple{Nothing,:fixed}})
_encoded_size(Dict("K" => typemax(Int64)),  Val{Tuple{Nothing,:fixed}})

_encoded_size(Dict("K" => EmptyMessage()))
_encoded_size(Dict("K" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))))
_encoded_size(Dict(typemax(UInt32) => "V"))
_encoded_size(Dict(typemax(UInt64) => "V"))
_encoded_size(Dict(typemax(Int32) => "V"))
_encoded_size(Dict(typemax(Int64) => "V"))
_encoded_size(Dict(true => "V"))
_encoded_size(Dict(typemax(Int32) => "V"), Val{Tuple{:zigzag,Nothing}})
_encoded_size(Dict(typemax(Int64) => "V"), Val{Tuple{:zigzag,Nothing}})
_encoded_size(Dict(typemin(Int32) => "V"), Val{Tuple{:zigzag,Nothing}})
_encoded_size(Dict(typemin(Int64) => "V"), Val{Tuple{:zigzag,Nothing}})
_encoded_size(Dict(TestEnum.OTHER => "V"))

_encoded_size(Dict(typemax(UInt32) => "V"), Val{Tuple{:fixed,Nothing}})
_encoded_size(Dict(typemax(UInt64) => "V"), Val{Tuple{:fixed,Nothing}})
_encoded_size(Dict(typemax(Int32) => "V"),  Val{Tuple{:fixed,Nothing}})
_encoded_size(Dict(typemax(Int64) => "V"),  Val{Tuple{:fixed,Nothing}})

_encoded_size(typemax(Float32))
_encoded_size(typemax(Float64))
_encoded_size([typemax(Float32)])
_encoded_size([typemax(Float64)])
_encoded_size(Dict("K" => typemax(Float32)))
_encoded_size(Dict("K" => typemax(Float64)))
_encoded_size(Dict("K" => typemax(Float64)))

module TestDecode
using ProtoBuf: Codecs
import ProtoBuf as PB
using .Codecs: decode, decode!, ProtoDecoder, BufferedVector
using Test
using EnumX: @enumx

const temp_dir = mktempdir()
const test_dir = joinpath(pkgdir(PB), "test")

PB.protojl("test_messages_for_codec.proto", joinpath(test_dir, "test_protos"), temp_dir, always_use_modules=false, parametrize_oneofs=true)
include(joinpath(temp_dir, "test_messages_for_codec_pb.jl"))

TestInner(x::Int) = TestInner(x, nothing) # convenience constructor for a generated struct

const _Varint = Union{UInt32,UInt64,Int64,Int32,Bool,Enum}

wire_type(::Type{<:Union{Int32,Int64}},  V::Type{Val{:zigzag}}) = Codecs.VARINT
wire_type(::Type{<:_Varint},             V::Type{Nothing})      = Codecs.VARINT
wire_type(::Type{<:Union{UInt32,Int32}}, V::Type{Val{:fixed}})  = Codecs.FIXED32
wire_type(::Type{Float32},               V::Type{Nothing})      = Codecs.FIXED32
wire_type(::Type{<:Union{UInt64,Int64}}, V::Type{Val{:fixed}})  = Codecs.FIXED64
wire_type(::Type{Float64},               V::Type{Nothing})      = Codecs.FIXED64
wire_type(::Type{<:AbstractVector},      V::Type)               = Codecs.LENGTH_DELIMITED
wire_type(::Type{<:AbstractDict},        V::Type)               = Codecs.LENGTH_DELIMITED
wire_type(::Type{<:AbstractString},      V::Type)               = Codecs.LENGTH_DELIMITED
wire_type(::Type{<:_Varint})                                    = Codecs.VARINT
wire_type(::Type{Float64})                                      = Codecs.FIXED64
wire_type(::Type{Float32})                                      = Codecs.FIXED32
wire_type(::Type{<:AbstractVector})                             = Codecs.LENGTH_DELIMITED
wire_type(::Type{<:AbstractDict})                               = Codecs.LENGTH_DELIMITED
wire_type(::Type{<:AbstractString})                             = Codecs.LENGTH_DELIMITED

function test_decode(input_bytes, expected, V::Type=Nothing)
    w = wire_type(typeof(expected), V)
    input_bytes = collect(input_bytes)
    if w == Codecs.LENGTH_DELIMITED && !isa(expected, Dict)
        input_bytes = vcat(UInt8(length(input_bytes)), input_bytes)
    end

    e = ProtoDecoder(IOBuffer(input_bytes))
    if V === Nothing
        if eltype(expected) <: Union{String,Vector{UInt8},TestInner}
            skip(e.io, 1)
            x = BufferedVector{eltype(expected)}()
            while !eof(e.io)
                num, tag = PB.decode_tag(e)
                decode!(e, x)
            end
            x = x[]
        elseif isa(expected, Vector)
            x = BufferedVector{eltype(expected)}()
            decode!(e, w, x)
            x = x[]
        elseif isa(expected, Dict)
            x = Dict{keytype(expected), valtype(expected)}()
            while !eof(e.io)
                num, tag = PB.decode_tag(e)
                decode!(e, x)
            end
        else
            x = decode(e, typeof(expected))
        end
    else
        if isa(expected, Vector)
            x = BufferedVector{eltype(expected)}()
            decode!(e, w, x, V)
            x = x[]
        elseif isa(expected, Dict)
            x = Dict{keytype(expected), valtype(expected)}()
            while !eof(e.io)
                num, tag = PB.decode_tag(e)
                decode!(e, x, V)
            end
        else
            x = decode(e, typeof(expected), V)
        end
    end

    @test x == expected
end

function test_decode_message(input_bytes, expected::TestStruct, V=nothing)
    input_bytes = collect(input_bytes)
    e = ProtoDecoder(PipeBuffer(input_bytes))
    if isnothing(V)
        x = decode(e, typeof(expected))
    else
        _, tag = PB.decode_tag(e)
        @assert tag == Codecs.START_GROUP
        x = decode(e, Ref{typeof(expected)}, V)
    end
    @test x.oneof[] == expected.oneof[]
    @test typeof(x) === typeof(expected)
    @test typeof(x.oneof) === typeof(expected.oneof)
end

@testset "decode" begin
    @testset "length delimited" begin
        @testset "bytes" begin
            test_decode(b"123456789", b"123456789")
        end

        @testset "string" begin
            test_decode(b"123456789", "123456789")
        end

        @testset "repeated bytes" begin
            test_decode([0x12, 0x02, 0x31, 0x32, 0x12, 0x02, 0x33, 0x34], [[0x31, 0x32], [0x33, 0x34]])
        end

        @testset "repeated string" begin
            test_decode([0x12, 0x02, 0x31, 0x32, 0x12, 0x02, 0x33, 0x34], ["12", "34"])
        end

        @testset "repeated uint32" begin
            test_decode([0x01, 0x02], UInt32[1, 2])
        end

        @testset "repeated uint64" begin
            test_decode([0x01, 0x02], UInt64[1, 2])
        end

        @testset "repeated int32" begin
            test_decode([0x01, 0x02], Int32[1, 2])
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Int32[-1])
        end

        @testset "repeated enum" begin
            test_decode([0x01, 0x02], [TestEnum.B, TestEnum.C])
        end

        @testset "repeated int64" begin
            test_decode([0x01, 0x02], Int64[1, 2])
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Int64[-1])
        end

        @testset "repeated bool" begin
            test_decode([0x00, 0x01, 0x00], Bool[false, true, false])
        end

        @testset "repeated float64" begin
            test_decode(reinterpret(UInt8, Float64[1.0, 2.0]), Float64[1.0, 2.0])
        end

        @testset "repeated float32" begin
            test_decode(reinterpret(UInt8, Float32[1.0, 2.0]), Float32[1.0, 2.0])
        end

        @testset "repeated sfixed32" begin
            test_decode(reinterpret(UInt8, Int32[1, 2]), Int32[1, 2], Val{:fixed})
        end

        @testset "repeated sfixed64" begin
            test_decode(reinterpret(UInt8, Int64[1, 2]), Int64[1, 2], Val{:fixed})
        end

        @testset "repeated fixed32" begin
            test_decode(reinterpret(UInt8, UInt32[1, 2]), UInt32[1, 2], Val{:fixed})
        end

        @testset "repeated fixed64" begin
            test_decode(reinterpret(UInt8, UInt64[1, 2]), UInt64[1, 2], Val{:fixed})
        end

        @testset "repeated sint32" begin
            test_decode([0x02, 0x04, 0x01, 0x03], Int32[1, 2, -1, -2], Val{:zigzag})
        end

        @testset "repeated sint64" begin
            test_decode([0x02, 0x04, 0x01, 0x03], Int64[1, 2, -1, -2], Val{:zigzag})
        end

        @testset "repeated message" begin
            test_decode([0x12, 0x02, 0x08, 0x03, 0x12, 0x02, 0x08, 0x04], [TestInner(3), TestInner(4)])
        end

        @testset "map" begin
            @testset "string,string" begin test_decode([0x0a, 0x06, 0x0a, 0x01, 0x62, 0x12, 0x01, 0x61], Dict{String,String}("b" => "a")) end

            @testset "multiple string,string" begin test_decode([0x0a, 0x06, 0x0a, 0x01, 0x63, 0x12, 0x01, 0x64, 0x0a, 0x06, 0x0a, 0x01, 0x62, 0x12, 0x01, 0x61], Dict{String,String}("b" => "a", "c" => "d")) end
            @testset "multiple string,string reversed" begin test_decode([0x0a, 0x06, 0x0a, 0x01, 0x62, 0x12, 0x01, 0x61, 0x0a, 0x06, 0x0a, 0x01, 0x63, 0x12, 0x01, 0x64], Dict{String,String}("b" => "a", "c" => "d")) end

            @testset "int32,string" begin test_decode([0x0a, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61], Dict{Int32,String}(1 => "a")) end
            @testset "int64,string" begin test_decode([0x0a, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61], Dict{Int64,String}(1 => "a")) end
            @testset "uint32,string" begin test_decode([0x0a, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61], Dict{UInt32,String}(1 => "a")) end
            @testset "uint64,string" begin test_decode([0x0a, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61], Dict{UInt64,String}(1 => "a")) end
            @testset "bool,string" begin test_decode([0x0a, 0x05, 0x08, 0x01, 0x12, 0x01, 0x61], Dict{Bool,String}(true => "a")) end

            @testset "sfixed32,string" begin test_decode([0x0a, 0x08, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Dict{Int32,String}(1 => "a"), Val{Tuple{:fixed,Nothing}}) end
            @testset "sfixed64,string" begin test_decode([0x0a, 0x0c, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Dict{Int64,String}(1 => "a"), Val{Tuple{:fixed,Nothing}}) end
            @testset "fixed32,string" begin test_decode([0x0a, 0x08, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Dict{UInt32,String}(1 => "a"), Val{Tuple{:fixed,Nothing}}) end
            @testset "fixed64,string" begin test_decode([0x0a, 0x0c, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01, 0x61], Dict{UInt64,String}(1 => "a"), Val{Tuple{:fixed,Nothing}}) end

            @testset "sint32,string" begin test_decode([0x0a, 0x05, 0x08, 0x02, 0x12, 0x01, 0x61], Dict{Int32,String}(1 => "a"), Val{Tuple{:zigzag,Nothing}}) end
            @testset "sint64,string" begin test_decode([0x0a, 0x05, 0x08, 0x02, 0x12, 0x01, 0x61], Dict{Int64,String}(1 => "a"), Val{Tuple{:zigzag,Nothing}}) end

            @testset "string,int32" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01], Dict{String,Int32}("a" => 1)) end
            @testset "string,int64" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01], Dict{String,Int64}("a" => 1)) end
            @testset "string,uint32" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01], Dict{String,UInt32}("a" => 1)) end
            @testset "string,uint64" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01], Dict{String,UInt64}("a" => 1)) end
            @testset "string,bool" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x01], Dict{String,Bool}("a" => true)) end

            @testset "string,sfixed32" begin test_decode([0x0a, 0x08, 0x0a, 0x01, 0x61, 0x15, 0x01, 0x00, 0x00, 0x00], Dict{String,Int32}("a" => 1), Val{Tuple{Nothing,:fixed}}) end
            @testset "string,sfixed64" begin test_decode([0x0a, 0x0c, 0x0a, 0x01, 0x61, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Dict{String,Int64}("a" => 1), Val{Tuple{Nothing,:fixed}}) end
            @testset "string,fixed32" begin test_decode([0x0a, 0x08, 0x0a, 0x01, 0x61, 0x15, 0x01, 0x00, 0x00, 0x00], Dict{String,UInt32}("a" => 1), Val{Tuple{Nothing,:fixed}}) end
            @testset "string,fixed64" begin test_decode([0x0a, 0x0c, 0x0a, 0x01, 0x61, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Dict{String,UInt64}("a" => 1), Val{Tuple{Nothing,:fixed}}) end

            @testset "string,sint32" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x02], Dict{String,Int32}("a" => 1), Val{Tuple{Nothing,:zigzag}}) end
            @testset "string,sint64" begin test_decode([0x0a, 0x05, 0x0a, 0x01, 0x61, 0x10, 0x02], Dict{String,Int64}("a" => 1), Val{Tuple{Nothing,:zigzag}}) end


            @testset "sfixed32,sfixed32" begin test_decode([0x0a, 0x0a, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x15, 0x01, 0x00, 0x00, 0x00], Dict{Int32,Int32}(1 => 1), Val{Tuple{:fixed,:fixed}}) end
            @testset "sfixed64,sfixed64" begin test_decode([0x0a, 0x12, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Dict{Int64,Int64}(1 => 1), Val{Tuple{:fixed,:fixed}}) end
            @testset "fixed32,fixed32" begin test_decode([0x0a, 0x0a, 0x0d, 0x01, 0x00, 0x00, 0x00, 0x15, 0x01, 0x00, 0x00, 0x00], Dict{UInt32,UInt32}(1 => 1), Val{Tuple{:fixed,:fixed}}) end
            @testset "fixed64,fixed64" begin test_decode([0x0a, 0x12, 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], Dict{UInt64,UInt64}(1 => 1), Val{Tuple{:fixed,:fixed}}) end

            @testset "sint32,sint32" begin test_decode([0x0a, 0x04, 0x08, 0x02, 0x10, 0x02], Dict{Int32,Int32}(1 => 1), Val{Tuple{:zigzag,:zigzag}}) end
            @testset "sint64,sint64" begin test_decode([0x0a, 0x04, 0x08, 0x02, 0x10, 0x02], Dict{Int64,Int64}(1 => 1), Val{Tuple{:zigzag,:zigzag}}) end
        end

        @testset "message" begin
            test_decode_message([0x0a, 0x03, 0x31, 0x32, 0x33], TestStruct(PB.OneOf(:bytes, collect(b"123"))))
            test_decode_message([0x10, 0x02], TestStruct(PB.OneOf(:enum, TestEnum.C)))
            test_decode_message([0x1a, 0x02, 0x08, 0x02], TestStruct(PB.OneOf(:var"#struct", TestInner(2))))
            test_decode_message([0x1a, 0x06, 0x08, 0x02, 0x12, 0x02, 0x08, 0x03], TestStruct(PB.OneOf(:var"#struct", TestInner(2, TestInner(3)))))
        end

        @testset "group message" begin
            test_decode_message([0x03, 0x0a, 0x03, 0x31, 0x32, 0x33, 0x04], TestStruct(PB.OneOf(:bytes, collect(b"123"))), Val{:group})
            test_decode_message([0x03, 0x10, 0x02, 0x04], TestStruct(PB.OneOf(:enum, TestEnum.C)), Val{:group})
            test_decode_message([0x03, 0x1a, 0x02, 0x08, 0x02, 0x04], TestStruct(PB.OneOf(:var"#struct", TestInner(2))), Val{:group})
            test_decode_message([0x03, 0x1a, 0x06, 0x08, 0x02, 0x12, 0x02, 0x08, 0x03, 0x04], TestStruct(PB.OneOf(:var"#struct", TestInner(2, TestInner(3)))), Val{:group})
        end
    end

    @testset "varint" begin
        @testset "uint32" begin
            test_decode([0x02], UInt32(2))
        end

        @testset "uint64" begin
            test_decode([0x02], UInt64(2))
        end

        @testset "int32" begin
            test_decode([0x02], Int32(2))
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Int32(-1))
        end

        @testset "int64" begin
            test_decode([0x02], Int64(2))
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], Int64(-1))
        end

        @testset "bool" begin
            test_decode([0x01], true)
        end

        @testset "sint32" begin
            test_decode([0x04], Int32(2), Val{:zigzag})
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF], typemin(Int32), Val{:zigzag})
            test_decode([0xFE, 0xFF, 0xFF, 0xFF, 0xFF], typemax(Int32), Val{:zigzag})
        end

        @testset "sint64" begin
            test_decode([0x04], Int64(2), Val{:zigzag})
            test_decode([0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], typemin(Int64), Val{:zigzag})
            test_decode([0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x01], typemax(Int64), Val{:zigzag})
        end

        @testset "enum" begin
            test_decode([0x02], TestEnum.C)
        end

        @testset "unknown enum member" begin
            test_decode([0x10], Core.bitcast(TestEnum.T, Int32(0x10)))
        end
    end

    @testset "fixed" begin
        @testset "sfixed32" begin
            test_decode(reinterpret(UInt8, [Int32(2)]), Int32(2), Val{:fixed})
        end

        @testset "sfixed64" begin
            test_decode(reinterpret(UInt8, [Int64(2)]), Int64(2), Val{:fixed})
        end

        @testset "fixed32" begin
            test_decode(reinterpret(UInt8, [UInt32(2)]), UInt32(2), Val{:fixed})
        end

        @testset "fixed64" begin
            test_decode(reinterpret(UInt8, [UInt64(2)]), UInt64(2), Val{:fixed})
        end
    end

    @testset "skipping" begin
        io = IOBuffer()
        d = PB.ProtoDecoder(io)
        e = PB.ProtoEncoder(io)
        PB.encode(e, 3, UInt32(42)) # VARINT
        PB.encode(e, 4, [UInt32(42)]) # LENGTH_DELIMITED
        PB.encode(e, 5, Float64(42)) # FIXED64
        PB.encode(e, 6, Float32(42)) # FIXED32
        write(io, 0x03) # START_GROUP
            PB.encode(e, 1, UInt32(42)) # VARINT
            PB.encode(e, 2, [UInt32(42)]) # LENGTH_DELIMITED
            PB.encode(e, 3, Float64(42)) # FIXED64
            PB.encode(e, 4, Float32(42)) # FIXED32
        write(io, 0x04) # END_GROUP
        write(io, 0x03) # START_GROUP
            write(io, 0x03) # START_GROUP
                PB.encode(e, 1, UInt32(42)) # VARINT
                PB.encode(e, 2, [UInt32(42)]) # LENGTH_DELIMITED
                PB.encode(e, 3, Float64(42)) # FIXED64
                PB.encode(e, 4, Float32(42)) # FIXED32
            write(io, 0x04) # END_GROUP
        write(io, 0x04) # END_GROUP
        seekstart(io)

        @test decode(d, TestInner) == TestInner(0)
    end

    @testset "backwards compat" begin
        OlderVersion = include(joinpath(test_dir, "test_protos", "test_decode_backwards_compat.jl"))
        msg = OlderVersion.TestInner(0, OlderVersion.TestInner(1, OlderVersion.TestInner(2, nothing)))
        io = IOBuffer()
        e = PB.ProtoEncoder(io)
        PB.encode(e, msg)
        roundtripped = PB.decode(PB.ProtoDecoder(seekstart(io)), OlderVersion.TestInner)
        @test roundtripped == msg
    end
end
end # module

module TestCompelexProtoFile
using Test
using ProtoBuf
@eval $(Symbol("@il")) = $(Symbol("@invokelatest")) # macro alias

mktempdir() do tmpdir
    @testset "Translate and include complex proto files" begin
        for options in ((;), (parametrize_oneofs = true,))
            @testset "options = $options" begin
                @testset "google/protobuf/unittest.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/unittest.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "protobuf_unittest/protobuf_unittest.jl")) isa Module
                    end
                end

                @testset "google/protobuf/unittest_proto3.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/unittest_proto3.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "proto3_unittest/proto3_unittest.jl")) isa Module
                    end
                end

                @testset "google/protobuf/unittest_well_known_types.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/unittest_well_known_types.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "protobuf_unittest/protobuf_unittest.jl")) isa Module
                    end
                end

                @testset "datasets/google_message3/benchmark_message3.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("datasets/google_message3/benchmark_message3.proto", joinpath(@__DIR__, "test_protos/benchmarks"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "benchmarks/google_message3/google_message3.jl")) isa Module
                    end
                end

                @testset "datasets/google_message4/benchmark_message4.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("datasets/google_message4/benchmark_message4.proto", joinpath(@__DIR__, "test_protos/benchmarks"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "benchmarks/google_message4/google_message4.jl")) isa Module
                    end
                end

                @testset "google/protobuf/test_message_proto2.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/test_messages_proto2.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "protobuf_test_messages/protobuf_test_messages.jl")) isa Module
                    end
                end

                @testset "google/protobuf/test_message_proto3.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/test_messages_proto3.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "protobuf_test_messages/protobuf_test_messages.jl")) isa Module
                    end
                end

                @testset "google/protobuf/unittest_custom_options.proto" begin
                    @testset "translate source" begin
                        @test isnothing(protojl("google/protobuf/unittest_custom_options.proto", joinpath(@__DIR__, "test_protos"), tmpdir; options...))
                    end
                    @testset "include generated" begin
                        @test include(joinpath(tmpdir, "protobuf_unittest/protobuf_unittest.jl")) isa Module
                    end
                end

                @testset "google/protobuf/complex_dependencies/*" begin
                    @testset "translate source" begin
                        test_dir = "test_protos/google/protobuf/complex_dependencies"
                        @test isnothing(protojl(
                            ["da.proto","g.proto","c.proto","d.proto","e.proto"],
                            joinpath(@__DIR__,test_dir),
                            tmpdir;
                            options...
                         ))
                    end
                    @testset "include generated" begin
                        let _mod = Module(gensym())
                            Base.include(_mod, joinpath(tmpdir, "test/test.jl"))
                            test = @il(_mod.test)
                            @test test isa Module
                            @test @il(@il(test.da).A) isa Type
                            @test @il(@il(test.c).C) isa Type
                            @test @il(@il(test.d).D) isa Type
                            @test @il(@il(@il(test.test2).e).Ef) isa Type
                            @test @il(@il(@il(test.test2).g).G) isa Type
                        end
                    end
                end
            end
        end
    end
end
end

module TestComplexMessage
using Test
using ProtoBuf
using BufferedStreams

function roundtrip_iobuffer(input, f_in=identity, f_out=identity)
    io = IOBuffer()
    e = ProtoEncoder(f_in(io))
    encode(e, input)
    seekstart(io)
    d = ProtoDecoder(f_out(io))
    return decode(d, OmniMessage)
end

function roundtrip_iobuffer_maxsize(input, f_in=identity, f_out=identity)
    protosize = ProtoBuf._encoded_size(input)
    buf = zeros(UInt8, protosize)

    wio = IOBuffer(buf, read=false, write=true, maxsize=protosize)
    e = ProtoEncoder(f_in(wio))

    encoded = encode(e, input)

    @assert sizeof(wio.data) == sizeof(buf)
    rio = IOBuffer(wio.data, read=true, write=false)
    d = ProtoDecoder(f_out(rio))

    @test encoded == protosize
    return decode(d, OmniMessage)
end

function roundtrip_iostream(input, f_in=identity, f_out=identity)
    (path, io) = mktemp()
    e = ProtoEncoder(f_in(io))
    encode(e, input)
    close(io)
    io = f_out(open(path, "r"))
    d = ProtoDecoder(io)
    out = decode(d, OmniMessage)
    close(io)
    return out
end

function test_by_field(a, b)
    @testset "$(typeof(a))" begin
        _test_by_field(a, b)
    end
end

function _test_by_field(a, b, name=string(typeof(a)))
    N = fieldcount(typeof(a))
    (N == 0 || a isa AbstractDict || a isa AbstractVector) && return (@testset "$name" begin @test a == b end)
    for (i, n) in zip(1:N, fieldnames(typeof(a)))
        absname = string(name, ".", String(n))
        _test_by_field(getfield(a, i), getfield(b, i), absname)
    end
end

@testset "Translate and roundtrip a complex message" begin
    tmpdir = mktempdir()
    protojl("complex_message.proto", joinpath(@__DIR__, "test_protos/"), tmpdir, always_use_modules=false, parametrize_oneofs=true);
    include(joinpath(tmpdir, "complex_message_pb.jl"))

    msg = OmniMessage(
        UInt8[0xff],
        "S",
        typemax(UInt32),
        typemax(UInt64),
        typemax(Int32),
        typemax(Int64),
        true,
        typemax(Int32),
        typemax(Int64),
        TestEnum.OTHER,
        typemax(Int32),
        typemax(Int64),
        typemax(UInt32),
        typemax(UInt64),
        EmptyMessage(),
        NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing, OneOf(:y, 1), nothing), OneOf(:y, 2), nothing),
        OneOf(:oneof_uint32_field, typemax(UInt32)),

        [UInt8[0xff]],
        ["S"],
        [typemax(UInt32)],
        [typemax(UInt64)],
        [typemax(Int32)],
        [typemax(Int64)],
        [true],
        [typemax(Int32)],
        [typemax(Int64)],
        [TestEnum.OTHER],
        [typemax(Int32)],
        [typemax(Int64)],
        [typemax(UInt32)],
        [typemax(UInt64)],
        [EmptyMessage()],
        [
            NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing, OneOf(:y, 3), nothing), OneOf(:y, 4), nothing),
            NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing, OneOf(:y, 3), nothing), OneOf(:y, 4), CoRecursiveMessage(nothing)),
        ],

        Dict("K" => UInt8[0xff]),
        Dict("K" => "S"),
        Dict("K" => typemax(UInt32)),
        Dict("K" => typemax(UInt64)),
        Dict("K" => typemax(Int32)),
        Dict("K" => typemax(Int64)),
        Dict("K" => true),
        Dict("K" => typemax(Int32)),
        Dict("K" => typemax(Int64)),
        Dict("K" => TestEnum.OTHER),
        Dict("K" => typemax(Int32)),
        Dict("K" => typemax(Int64)),
        Dict("K" => typemax(UInt32)),
        Dict("K" => typemax(UInt64)),
        Dict("K" => EmptyMessage()),
        Dict(
            "K1" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing, OneOf(:y, 5), nothing), OneOf(:y, 6), nothing),
            "K2" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing, OneOf(:y, 5), nothing), OneOf(:y, 6), CoRecursiveMessage(nothing)),

        ),

        Dict(typemax(UInt32) => "V"),
        Dict(typemax(UInt64) => "V"),
        Dict(typemax(Int32) => "V"),
        Dict(typemax(Int64) => "V"),
        Dict(true => "V"),
        Dict(typemax(Int32) => "V"),
        Dict(typemax(Int64) => "V"),
        Dict(typemax(Int32) => "V"),
        Dict(typemax(Int64) => "V"),
        Dict(typemax(UInt32) => "V"),
        Dict(typemax(UInt64) => "V"),

        typemax(Float32),
        typemax(Float64),
        [typemax(Float32)],
        [typemax(Float64)],
        Dict("K" => typemax(Float32)),
        Dict("K" => typemax(Float64)),

        var"OmniMessage.Group"(Int32(42)),
        [var"OmniMessage.Repeated_group"(Int32(43))],

        Float32(-0.0), # Checks that -0.0 is serialized and not confused with the 0.0 default value
        Float64(-0.0),
    )

    @testset "IOBuffer" begin
        test_by_field(roundtrip_iobuffer(msg), msg)
    end
    @testset "IOBuffer preallocated" begin
        test_by_field(roundtrip_iobuffer_maxsize(msg), msg)
    end
    @testset "IOStream" begin
        test_by_field(roundtrip_iostream(msg), msg)
    end

    @testset "Duplicated messages" begin
        io = IOBuffer()
        e = ProtoEncoder(io)
        encode(e, 1, DuplicatedInnerMessage(UInt32(42), UInt32[1, 2], DuplicatedMessage(DuplicatedInnerMessage(UInt32(42), UInt32[1, 2], nothing))))
        encode(e, 1, DuplicatedInnerMessage(UInt32(43), UInt32[3, 4], DuplicatedMessage(DuplicatedInnerMessage(UInt32(43), UInt32[5, 6], nothing))))
        seekstart(io)
        x = decode(ProtoDecoder(io), DuplicatedMessage)
        test_by_field(x, DuplicatedMessage(DuplicatedInnerMessage(UInt32(43), UInt32[1, 2, 3, 4], DuplicatedMessage(DuplicatedInnerMessage(UInt32(43), UInt32[1, 2, 5, 6], nothing)))))
    end
end
end

module TestMappingStruct
using Test
using ProtoBuf

@testset "Roundtrip a dictionary mapping" begin
    tmpdir = mktempdir()
    protojl("pair_struct.proto", joinpath(pkgdir(ProtoBuf), "test", "test_protos"), tmpdir, always_use_modules=false, parametrize_oneofs=true);
    include(joinpath(tmpdir, "pair_struct_pb.jl"))

    function encode_bytes(msg)
        io = IOBuffer()
        e = PB.ProtoEncoder(io)
        PB.encode(e, msg)
        return take!(io)
    end

    function decode_bytes(::Type{T}, bytes) where {T}
        io = IOBuffer(bytes)
        d = PB.ProtoDecoder(io)
        return PB.decode(d, T)
    end

    test_dictionary = Dict{String, Int64}(
        "field1"=>1,
        "field2"=>-5,
        "field3"=>120,
    )

    dict_message = Map(test_dictionary)
    pairs_message = Pairs([ProtoPair(k, v) for (k, v) in test_dictionary])

    encoded_dict = encode_bytes(dict_message)
    encoded_pairs = encode_bytes(pairs_message)

    decoded_dict = decode_bytes(Map, encoded_pairs)
    decoded_pairs = decode_bytes(Pairs, encoded_dict)

    @test encoded_dict == encoded_pairs

    @test typeof(dict_message) == typeof(decoded_dict)
    @test dict_message.map_field == decoded_dict.map_field

    @test typeof(pairs_message) == typeof(decoded_pairs)
    @test pairs_message.map_field == decoded_pairs.map_field
end
end

using ProtoBuf
using ProtoBuf.CodeGenerators: Options, ResolvedProtoFile, translate, namespace, jl_typename
using ProtoBuf.CodeGenerators: import_paths, Context, get_all_transitive_imports!
using ProtoBuf.CodeGenerators: resolve_inter_package_references!, types_needing_params
using ProtoBuf.Parsers: parse_proto_file, ParserState, Parsers
using ProtoBuf.Lexers: Lexer
using Test

function translate_simple_proto(str::String, options=Options())
    buf = IOBuffer()
    l = Lexer(IOBuffer(str), "main")
    p = parse_proto_file(ParserState(l))
    r = ResolvedProtoFile("main", p)
    d = Dict{String, ResolvedProtoFile}("main" => r)
    foreach(p->get_all_transitive_imports!(p, d), values(d))
    resolve_inter_package_references!(d, options)
    translate(buf, r, d, options)
    s = String(take!(buf))
    s = join(filter!(!startswith(r"#|$^"), split(s, '\n')), '\n')
    ncyclic = length(p.cyclic_definitions)
    ctx = Context(
        p, r.import_path, d,
        types_needing_params(@view(p.sorted_definitions[end-ncyclic+1:end]), p, options),
        copy(p.cyclic_definitions),
        Ref(get(p.sorted_definitions, length(p.sorted_definitions), "")),
        r.transitive_imports,
        options
    )
    return s, p, ctx
end

function translate_simple_proto(str::String, deps::Dict{String,String}, options=Options())
    buf = IOBuffer()
    l = Lexer(IOBuffer(str), "main")
    p = parse_proto_file(ParserState(l))
    r = ResolvedProtoFile("main", p)
    d = Dict{String, ResolvedProtoFile}("main" => r)
    for (k, v) in deps
        get!(d, k) do
            l = Lexer(IOBuffer(v), k)
            ResolvedProtoFile(k, parse_proto_file(ParserState(l)))
        end
    end
    foreach(p->get_all_transitive_imports!(p, d), values(d))
    resolve_inter_package_references!(d, options)
    d["main"] =  r
    translate(buf, r, d, options)
    s = String(take!(buf))
    s = join(filter!(!startswith(r"#|$^"), split(s, '\n')), '\n')
    ncyclic = length(p.cyclic_definitions)
    ctx = Context(
        p, r.import_path, d,
        types_needing_params(@view(p.sorted_definitions[end-ncyclic+1:end]), p, options),
        copy(p.cyclic_definitions),
        Ref(get(p.sorted_definitions, length(p.sorted_definitions), "")),
        r.transitive_imports,
        options
    )
    return s, d, ctx
end

@testset "Parsers" begin
    @testset "Single empty message proto file" begin
        s, p, ctx = translate_simple_proto("message A {}")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
    end

    @testset "Single message proto file with single decimal-numbered field" begin
        s, p, ctx = translate_simple_proto("message A { required uint32 b = 1234; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].number == 1234
        @test p.definitions["A"].fields[1].type isa Parsers.UInt32Type
    end

    @testset "Single message proto file with single hex-numbered field" begin
        s, p, ctx = translate_simple_proto("message A { required uint32 b = 0x4321; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].number == 0x4321
        @test p.definitions["A"].fields[1].type isa Parsers.UInt32Type
    end

    @testset "Single enum proto file" begin
        s, p, ctx = translate_simple_proto("enum A { a = 0; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.EnumType
        @test p.definitions["A"].element_names == [:a]
        @test p.definitions["A"].element_values == [0]
    end

    @testset "Trailing semicolon is fine" begin
        s, p, ctx = translate_simple_proto("message A { oneof oneof_field { uint32 u = 1; };}; enum B { b = 0; };")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test haskey(p.definitions, "B")
        @test p.definitions["B"] isa Parsers.EnumType
    end

    @testset "Single enum with `allow_alias = true` proto file" begin
        s, p, ctx = translate_simple_proto("enum A { option allow_alias = true; a = 0; b = 0; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.EnumType
        @test p.definitions["A"].element_names == [:a, :b]
        @test p.definitions["A"].element_values == [0, 0]
    end

    @testset "Single nested empty message proto file" begin
        s, p, ctx = translate_simple_proto("message A { message B {} }")

        @test haskey(p.definitions, "A")
        @test haskey(p.definitions, "A.B")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A.B"] isa Parsers.MessageType
    end

    @testset "Single nested non-empty message proto file with field" begin
        s, p, ctx = translate_simple_proto("message A { message B {}\n optional B b = 1; }")

        @test haskey(p.definitions, "A")
        @test haskey(p.definitions, "A.B")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A.B"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        # the type name is expanded to include the enclosing type
        @test p.definitions["A"].fields[1].type.name == "A.B"
        p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
    end

    @testset "Single nested non-empty message proto file with namespaced field" begin
        s, p, ctx = translate_simple_proto("message A { message B {}\n optional A.B b = 1; }")

        @test haskey(p.definitions, "A")
        @test haskey(p.definitions, "A.B")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A.B"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "A.B"
        @test p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
    end

    @testset "Single nested non-empty message proto file with default value" begin
        s, p, ctx = translate_simple_proto("message A { optional string a = 1 [ default = \"b\" ]; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "a"
        @test p.definitions["A"].fields[1].type isa Parsers.StringType
        @test p.definitions["A"].fields[1].options["default"] == "\"b\""
    end

    @testset "Single nested non-empty message proto file with default value on several lines" begin
        s, p, ctx = translate_simple_proto("message A { optional string a = 1 [ default = \"b;\"\n\t\"\"\n\t\"c\" ]; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "a"
        @test p.definitions["A"].fields[1].type isa Parsers.StringType
        @test p.definitions["A"].fields[1].options["default"] == "\"b;c\""
    end

    @testset "Single self-referential message proto file" begin
        s, p, ctx = translate_simple_proto("message A { optional A a = 1; }")

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test isempty(p.cyclic_definitions) # self references are not considered cyclic, as they don't affect topological sort
        @test p.definitions["A"].fields[1].name == "a"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "A"
    end

    for syntax in (("", "syntax = \"proto2\";", "syntax = \"proto3\";"))
        for (label_name, label) in (("", Parsers.DEFAULT), ("repeated", Parsers.REPEATED), ("optional", Parsers.OPTIONAL))
            syntax in ("", "syntax = \"proto2\";") && label_name == "" && continue
            syntax == "syntax = \"proto3\";" && label_name == "required" && continue
            for (type_name, type) in (
                    (:uint32, Parsers.UInt32Type), (:uint64, Parsers.UInt64Type), (:int32, Parsers.Int32Type), (:int64, Parsers.Int64Type),
                    (:fixed32, Parsers.Fixed32Type), (:fixed64, Parsers.Fixed64Type),  (:sfixed32, Parsers.SFixed32Type), (:sfixed64, Parsers.SFixed64Type),
                    (:sint32, Parsers.SInt32Type), (:sint64, Parsers.SInt64Type),  (:float, Parsers.FloatType), (:double, Parsers.DoubleType),
                    (:string, Parsers.StringType), (:bytes, Parsers.BytesType),
                )

                @testset "Single message with $label_name $type_name field with $(syntax == "syntax = \"proto3\";" ? "proto3" : "proto2") syntax" begin
                    s, p, ctx = translate_simple_proto("$syntax message A { $label_name $type_name a = 1; }")

                    @test haskey(p.definitions, "A")
                    @test p.definitions["A"] isa Parsers.MessageType
                    @test p.definitions["A"].fields[1].name == "a"
                    @test p.definitions["A"].fields[1].number == 1
                    @test p.definitions["A"].fields[1].label == label
                    @test p.definitions["A"].fields[1].type isa type
                end
            end
        end
    end

    @testset "Single message with file-imported field type" begin
        s, d, ctx = translate_simple_proto("""
            import "path/to/a";
            message A { optional B b = 1; }
            """,
            Dict("path/to/a" => "message B {}"),
        )
        p = d["main"].proto_file

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "B"
        # we were able to infer the type of the dependency by finding it among imported modules
        @test p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
    end

    @testset "Single message with package-imported field type" begin
        s, d, ctx = translate_simple_proto("""
            import "path/to/a";
            message A { optional B b = 1; }
            """,
            Dict("path/to/a" => "package P; message B {}"),
        )
        p = d["main"].proto_file

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "B"
        # we were able to infer the type of the dependency by finding it among imported modules
        @test p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
        @test p.definitions["A"].fields[1].type.package_namespace === "P"
    end

    @testset "Single message with package-imported namespaced field type" begin
        s, d, ctx = translate_simple_proto("""
            import "path/to/a";
            message A { optional P.B b = 1; }
            """,
            Dict("path/to/a" => "package P; message B {}"),
        )
        p = d["main"].proto_file

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b"
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "B"
        @test p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
        @test p.definitions["A"].fields[1].type.package_namespace == "P"
        @test p.definitions["A"].fields[1].type.package_import_path == "path/to/a"
    end

    @testset "Message with a field that has to be namespaced to avoid name collision" begin
        s, d, ctx = translate_simple_proto("""
            import "path/to/a";
            message B {}
            message A { optional P.B b_imported = 1; optional B b_local = 2; }
            """,
            Dict("path/to/a" => "package P; message B {}"),
        )
        p = d["main"].proto_file

        @test haskey(p.definitions, "A")
        @test p.definitions["A"] isa Parsers.MessageType
        @test p.definitions["A"].fields[1].name == "b_imported"
        @test p.definitions["A"].fields[1].number == 1
        @test p.definitions["A"].fields[1].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[1].type.name == "B"
        @test p.definitions["A"].fields[1].type.reference_type == Parsers.MESSAGE
        @test p.definitions["A"].fields[1].type.package_namespace == "P"
        @test p.definitions["A"].fields[1].type.package_import_path == "path/to/a"

        @test p.definitions["A"].fields[2].name == "b_local"
        @test p.definitions["A"].fields[2].number == 2
        @test p.definitions["A"].fields[2].type isa Parsers.ReferencedType
        @test p.definitions["A"].fields[2].type.name == "B"
        @test p.definitions["A"].fields[2].type.reference_type == Parsers.MESSAGE
        @test p.definitions["A"].fields[2].type.package_namespace === nothing
        @test p.definitions["A"].fields[2].type.package_import_path === nothing
    end

    @testset "Referenced Types are assumed to refer to messages defined within the parent message" begin
        s, p, ctx = translate_simple_proto(
            """
            message B { }
            message A {
                optional B nested_message = 3;
                oneof oneof_field {
                    B oneof_nested_message = 4;
                }
                map<string, B> map_string_nested_message = 5;
                message B {
                    optional int32 a = 1;
                    optional A corecursive = 2;
                }
            }
            """
        )
        @test p.definitions["A"].fields[1].type.name == "A.B"
        @test p.definitions["A"].fields[2].fields[1].type.name == "A.B"
        @test p.definitions["A"].fields[3].type.valuetype.name == "A.B"
    end

    @testset "Referenced Types are correctly namespaced when nested" begin
        s, p, ctx = translate_simple_proto(
            """
            message A {
                message B {
                    message B {
                        optional B b = 2;
                    }
                    optional A a = 1;
                }
                optional B b = 3;
              }
            """
        )
        @test p.definitions["A"].fields[1].type.name == "A.B"
        @test p.definitions["A"].fields[1].number == 3

        @test p.definitions["A.B"].fields[1].type.name == "A"
        @test p.definitions["A.B"].fields[1].number == 1

        @test p.definitions["A.B.B"].fields[1].type.name == "A.B.B"
        @test p.definitions["A.B.B"].fields[1].number == 2

        s, p, ctx = translate_simple_proto(
            """
            message A {
                message B {
                    oneof oneof_field {
                        C c = 1;
                    }
                }
                optional B b = 3;
                message C {
                    optional uint32 i = 2;
                }
              }
            """
        )
        @test p.definitions["A"].fields[1].type.name == "A.B"
        @test p.definitions["A.B"].fields[1].fields[1].type.name == "A.C"

        @test_throws ErrorException translate_simple_proto(
            """
            message A {
                message B {
                    oneof oneof_field {
                        C c = 1;
                    }
                }
                optional B b = 3;
                message D {
                    message C {
                        optional uint32 i = 2;
                    }
                }
              }
            """
        )
    end

    @testset "Messages are not allowed to name-clash with modules" begin
        @test_throws ErrorException translate_simple_proto("""
            package Foo;

            message Foo {}
            """)

        @test_throws ErrorException translate_simple_proto("""
            import "main2";

            message Foo {}
            """,
            Dict("main2" => "package Foo;"))
    end

    @testset "Leading dot means resolving starts from outermost scope" begin
        s, d, ctx = translate_simple_proto("""
            message A {
                message B {
                    message A {
                        optional A inner = 1;
                        optional .A outer = 2;
                    }
                }
            }
            """)
        @test d.definitions["A.B.A"].fields[1].type.name == "A.B.A"
        @test d.definitions["A.B.A"].fields[2].type.name == "A"

        s, d, ctx = translate_simple_proto("""
            import "main2";
            message T {
                optional G.A.B.A inner = 1;
                optional .G.A outer = 2;
                optional G.A also_outer = 3;
            }
            """,
            Dict("main2" => """
            package G;
            message A {
                message B {
                    message A {
                    }
                }
            }
            """
            ))
        p = d["main"].proto_file
        @test p.definitions["T"].fields[1].type.name == "A.B.A"
        @test p.definitions["T"].fields[2].type.name == "A"
        @test p.definitions["T"].fields[3].type.name == "A"
    end
end

function decode_tag(d::AbstractProtoDecoder)
    b = vbyte_decode(get_stream(d), UInt32)
    field_number = b >> 3
    wire_type = WireType(b & 0x07)
    return field_number, wire_type
end

const _ScalarTypes = Union{Float64,Float32,Int32,Int64,UInt64,UInt32,Bool,String,Vector{UInt8}}
const _ScalarTypesEnum = Union{_ScalarTypes,Enum}

# uint32, uint64
decode(d::AbstractProtoDecoder, ::Type{T}) where {T <: Union{UInt32,UInt64}} = vbyte_decode(get_stream(d), T)
# int32: Negative int32 are encoded in 10 bytes...
# TODO: add check the int is negative if larger than typemax UInt32
decode(d::AbstractProtoDecoder, ::Type{Int32}) = reinterpret(Int32, UInt32(vbyte_decode(get_stream(d), UInt64) % UInt32))
# int64
decode(d::AbstractProtoDecoder, ::Type{Int64}) = reinterpret(Int64, vbyte_decode(get_stream(d), UInt64))
# sfixed32, sfixed64, # fixed32, fixed64
decode(d::AbstractProtoDecoder, ::Type{T}, ::Type{Val{:fixed}}) where {T <: Union{Int32,Int64,UInt32,UInt64}} = read(get_stream(d), T)
# sint32, sint64
function decode(d::AbstractProtoDecoder, ::Type{T}, ::Type{Val{:zigzag}}) where {T <: Union{Int32,Int64}}
    v = vbyte_decode(get_stream(d), unsigned(T))
    z = zigzag_decode(v)
    return reinterpret(T, z)
end
decode(d::AbstractProtoDecoder, ::Type{Bool}) = Bool(read(get_stream(d), UInt8))
function decode(d::AbstractProtoDecoder, ::Type{T}) where {T <: Union{Enum{Int32},Enum{UInt32}}}
    val = vbyte_decode(get_stream(d), UInt32)
    return Core.bitcast(T, reinterpret(Int32, val))
end
decode(d::AbstractProtoDecoder, ::Type{T}) where {T <: Union{Float64,Float32}} = read(get_stream(d), T)
function decode!(d::AbstractProtoDecoder, buffer::Dict{K,V}) where {K,V<:_ScalarTypesEnum}
    io = get_stream(d)
    pair_len = vbyte_decode(io, UInt32)
    pair_end_pos = position(io) + pair_len
    field_number, wire_type = decode_tag(d)
    key = decode(d, K)
    field_number, wire_type = decode_tag(d)
    val = decode(d, V)
    @assert position(io) == pair_end_pos
    buffer[key] = val
    nothing
end

function decode!(d::AbstractProtoDecoder, buffer::Dict{K,V}) where {K,V}
    io = get_stream(d)
    pair_len = vbyte_decode(io, UInt32)
    pair_end_pos = position(io) + pair_len
    field_number, wire_type = decode_tag(d)
    key = decode(d, K)
    field_number, wire_type = decode_tag(d)
    val = decode(d, Ref{V})
    @assert position(io) == pair_end_pos
    buffer[key] = val
    nothing
end

for T in (:(:fixed), :(:zigzag))
    @eval function decode!(d::AbstractProtoDecoder, buffer::Dict{K,V}, ::Type{Val{Tuple{Nothing,$(T)}}}) where {K,V}
        io = get_stream(d)
        pair_len = vbyte_decode(io, UInt32)
        pair_end_pos = position(io) + pair_len
        field_number, wire_type = decode_tag(d)
        key = decode(d, K)
        field_number, wire_type = decode_tag(d)
        val = decode(d, V, Val{$(T)})
        @assert position(io) == pair_end_pos
        buffer[key] = val
        nothing
    end

    @eval function decode!(d::AbstractProtoDecoder, buffer::Dict{K,V}, ::Type{Val{Tuple{$(T),Nothing}}}) where {K,V}
        io = get_stream(d)
        pair_len = vbyte_decode(io, UInt32)
        pair_end_pos = position(io) + pair_len
        field_number, wire_type = decode_tag(d)
        key = decode(d, K, Val{$(T)})
        field_number, wire_type = decode_tag(d)
        val = decode(d, V)
        @assert position(io) == pair_end_pos
        buffer[key] = val
        nothing
    end
end

for T in (:(:fixed), :(:zigzag)), S in (:(:fixed), :(:zigzag))
    @eval function decode!(d::AbstractProtoDecoder, buffer::Dict{K,V}, ::Type{Val{Tuple{$(T),$(S)}}}) where {K,V}
        io = get_stream(d)
        pair_len = vbyte_decode(io, UInt32)
        pair_end_pos = position(io) + pair_len
        field_number, wire_type = decode_tag(d)
        key = decode(d, K, Val{$(T)})
        field_number, wire_type = decode_tag(d)
        val = decode(d, V, Val{$(S)})
        @assert position(io) == pair_end_pos
        buffer[key] = val
        nothing
    end
end

function decode(d::AbstractProtoDecoder, ::Type{String})
    bytelen = vbyte_decode(get_stream(d), UInt32)
    str = Base._string_n(bytelen)
    Base.unsafe_read(get_stream(d), pointer(str), bytelen)
    return str
end
function decode!(d::AbstractProtoDecoder, buffer::BufferedVector{String})
    buffer[] = decode(d, String)
    return nothing
end

function decode(d::AbstractProtoDecoder, ::Type{Vector{UInt8}})
    bytelen = vbyte_decode(get_stream(d), UInt32)
    return read(get_stream(d), bytelen)
end
function decode(d::AbstractProtoDecoder, ::Type{Base.CodeUnits{UInt8, String}})
    bytelen = vbyte_decode(get_stream(d), UInt32)
    return read(get_stream(d), bytelen)
end
function decode!(d::AbstractProtoDecoder, buffer::BufferedVector{Vector{UInt8}})
    buffer[] = decode(d, Vector{UInt8})
    return nothing
end

function decode!(d::AbstractProtoDecoder, w::WireType, buffer::BufferedVector{T}) where {T <: Union{Int32,Int64,UInt32,UInt64,Enum{Int32},Enum{UInt32}}}
    if w == LENGTH_DELIMITED
        io = get_stream(d)
        bytelen = vbyte_decode(io, UInt32)
        endpos = bytelen + position(io)
        while position(io) < endpos
            buffer[] = decode(d, T)
        end
        @assert position(io) == endpos
    else
        buffer[] = decode(d, T)
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, w::WireType, buffer::BufferedVector{T}, ::Type{Val{:zigzag}}) where {T <: Union{Int32,Int64}}
    if w == LENGTH_DELIMITED
        io = get_stream(d)
        bytelen = vbyte_decode(io, UInt32)
        endpos = bytelen + position(io)
        while position(io) < endpos
            buffer[] = decode(d, T, Val{:zigzag})
        end
        @assert position(io) == endpos
    else
        buffer[] = decode(d, T, Val{:zigzag})
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, w::WireType, buffer::BufferedVector{T}, ::Type{Val{:fixed}}) where {T <: Union{Int32,Int64,UInt32,UInt64}}
    if w == LENGTH_DELIMITED
        io = get_stream(d)
        bytelen = vbyte_decode(io, UInt32)
        n_incoming = div(bytelen, sizeof(T))
        n_current = length(buffer.elements)
        resize!(buffer.elements, n_current + n_incoming)
        endpos = bytelen + position(io)
        for i in (n_current+1):(n_current + n_incoming)
            buffer.occupied += 1
            @inbounds buffer.elements[i] = decode(d, T, Val{:fixed})
        end
        @assert position(io) == endpos
    else
        buffer[] = decode(d, T, Val{:fixed})
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, w::WireType, buffer::BufferedVector{T}) where {T <: Union{Bool,Float32,Float64}}
    if w == LENGTH_DELIMITED
        io = get_stream(d)
        bytelen = vbyte_decode(io, UInt32)
        n_incoming = div(bytelen, sizeof(T))
        n_current = length(buffer.elements)
        resize!(buffer.elements, n_current + n_incoming)
        endpos = bytelen + position(io)
        for i in (n_current+1):(n_current + n_incoming)
            buffer.occupied += 1
            @inbounds buffer.elements[i] = decode(d, T)
        end
        @assert position(io) == endpos
    else
        buffer[] = decode(d, T)
    end
    return nothing
end

@noinline function _warn_old_decode_method()
    @warn "You are using code generated by an older version of ProtoBuf.jl, which \
    was deprecated. Please regenerate your protobuf definitions with the current version of \
    ProtoBuf.jl. The new version will allow for defining custom AbstractProtoDecoder variants. \
    This warning is only printed once per session." maxlog=1
    return nothing
end

# This method handles messages decoded as OneOf / repeated. We expect `decode(d, T)`
# to be generated / provided by the user. We do this so that we can conditionally
# eat the length varint (which is not present when decoding a toplevel message).
# We don't reuse the decode!(d::AbstractProtoDecoder, buffer::Base.RefValue{T}) method above
# as with OneOf fields, we can't be sure that the previous OneOf value was also T.
function decode(d::AbstractProtoDecoder, ::Type{Ref{T}}) where {T}
    io = get_stream(d)
    bytelen = vbyte_decode(io, UInt32)
    endpos = bytelen + position(io)
    if hasmethod(decode, Tuple{AbstractProtoDecoder, Type{T}, Int, Bool})
        out = decode(d, T, endpos, false)
    else
        _warn_old_decode_method()
        out = decode(LengthDelimitedProtoDecoder(get_stream(d), endpos), T)
    end
    @assert position(io) == endpos "$(T) decode: expected position $(endpos), got $(position(io))"
    return out
end

function decode!(d::AbstractProtoDecoder, buffer::BufferedVector{T}) where {T}
    buffer[] = decode(d, Ref{T})
    return nothing
end

function decode(d::AbstractProtoDecoder, ::Type{Ref{T}}, ::Type{Val{:group}}) where {T}
    if hasmethod(decode, Tuple{AbstractProtoDecoder, Type{T}, Int, Bool})
        out = decode(d, T, 0, true)
    else
        _warn_old_decode_method()
        out = decode(GroupProtoDecoder(get_stream(d)), T)
    end
    return out
end

function decode!(d::AbstractProtoDecoder, buffer::BufferedVector{T}, ::Type{Val{:group}}) where {T}
    buffer[] = decode(d, Ref{T}, Val{:group})
    return nothing
end

# When the type signature on buffer was Base.RefValue{Union{T,Nothing}} where T,
# Aqua was complaining about an unbound type parameter.
function decode!(d::AbstractProtoDecoder, buffer::Base.RefValue{S}) where {S>:Nothing}
    T = Core.Compiler.typesubtract(S, Nothing, 2)
    if !isnothing(buffer[])
        buffer[] = _merge_structs(getindex(buffer)::T, decode(d, Ref{T}))
    else
        buffer[] = decode(d, Ref{T})
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, buffer::Base.RefValue{T}) where {T}
    if isassigned(buffer)
        buffer[] = _merge_structs(buffer[], decode(d, Ref{T}))
    else
        buffer[] = decode(d, Ref{T})
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, buffer::Base.RefValue{S}, ::Type{Val{:group}}) where {S>:Nothing}
    T = Core.Compiler.typesubtract(S, Nothing, 2)
    if !isnothing(buffer[])
        buffer[] = _merge_structs(getindex(buffer)::T, decode(d, Ref{T}, Val{:group}))
    else
        buffer[] = decode(d, Ref{T}, Val{:group})
    end
    return nothing
end

function decode!(d::AbstractProtoDecoder, buffer::Base.RefValue{T}, ::Type{Val{:group}}) where {T}
    if isassigned(buffer)
        buffer[] = _merge_structs(buffer[], decode(d, Ref{T}, Val{:group}))
    else
        buffer[] = decode(d, Ref{T}, Val{:group})
    end
    return nothing
end

# From docs: Normally, an encoded message would never have more than one instance of a non-repeated field.
# ...
# For embedded message fields, the parser merges multiple instances of the same field, as if with the
# Message::MergeFrom method – that is, all singular scalar fields in the latter instance replace
# those in the former, singular embedded messages are merged, and repeated fields are concatenated.
# The effect of these rules is that parsing the concatenation of two encoded messages
# produces exactly the same result as if you had parsed the two messages separately
# and merged the resulting objects
@generated function _merge_structs(s1::Union{Nothing,T}, s2::T) where {T}
    isbitstype(s1) && return :(return s2)
    # TODO: Error gracefully on unsuported types like Missing, Matrices...
    #       Would be easier if we have a HolyTrait for user defined structs
    merged_values = Tuple(
        (
            type <: _ScalarTypesEnum ? :(s2.$(name)) :
            type <: AbstractVector ? :(vcat(s1.$(name), s2.$(name))) :
            :(_merge_structs(s1.$(name), s2.$(name)))
        )
        for (name, type)
        in zip(fieldnames(T), fieldtypes(T))
    )
    return quote T($(merged_values...)) end
end

@generated function _merge_structs!(s1::Union{Nothing,T}, s2::T) where {T}
    isbitstype(s1) && :(return nothing)
    exprs = Expr[]
    for (name, type) in zip(fieldnames(T), fieldtypes(T))
        (type <: _ScalarTypesEnum) && continue
        if (type <: AbstractVector)
            push!(exprs, :(prepend!(s2.$(name), s1.$(name));))
        else
            push!(exprs, :(_merge_structs!(s1.$(name), s2.$(name));))
        end
    end
    return quote
        $(exprs...)
        return nothing
    end
end

@inline function Base.skip(d::AbstractProtoDecoder, wire_type::WireType)
    io = get_stream(d)
    if wire_type == VARINT
        while read(io, UInt8) >= 0x80 end
    elseif wire_type == FIXED64
        skip(io, 8)
    elseif wire_type == LENGTH_DELIMITED
        bytelen = vbyte_decode(io, UInt32)
        skip(io, bytelen)
    elseif wire_type == START_GROUP
        while peek(io) != UInt8(END_GROUP)
            skip(d, decode_tag(d)[2])
        end
        skip(io, 1)
    elseif wire_type == FIXED32
        skip(io, 4)
    else wire_type == END_GROUP
        error("Encountered END_GROUP wiretype while skipping")
    end
    return nothing
end

function jl_init_value(@nospecialize(field::FieldType), ctx::Context)
    if _is_repeated_field(field)
        return "PB.BufferedVector{$(jl_typename(field.type, ctx))}()"
    else
        return jl_type_init_value(field, ctx::Context)
    end
end

function jl_default_value(@nospecialize(field::FieldType), ctx::Context)
    if _is_repeated_field(field)
        return "Vector{$(jl_typename(field.type, ctx))}()"
    else
        return jl_type_default_value(field, ctx)
    end
end

function _is_optional_referenced_message(field::Union{FieldType{ReferencedType},GroupType}, ctx::Context)
    struct_name = ctx._toplevel_raw_name[]
    (field.type.name == struct_name || field.type.name in ctx._remaining_cyclic_defs) && return true
    if field.label == Parsers.OPTIONAL || field.label == Parsers.DEFAULT
        return !_should_force_required(string(struct_name, ".", jl_fieldname(field)), ctx)
    end
    return false
end

_needs_encoding_condition(field::Union{FieldType{ReferencedType},GroupType}, ctx::Context) = field.label === Parsers.REPEATED || _is_optional_referenced_message(field, ctx)
_needs_encoding_condition(field::FieldType, _::Context) = field.label !== Parsers.REQUIRED

jl_type_default_value(f::FieldType{StringType}, ::Context) = get(f.options, "default", "\"\"")
jl_type_default_value(f::FieldType{BoolType}, ::Context)   = get(f.options, "default", "false")
function jl_type_default_value(@nospecialize(f::FieldType{<:AbstractProtoFloatType}), ctx::Context)
    type_name = jl_typename(f, ctx)
    default = get(f.options, "default", nothing)
    if default === nothing
        return "zero($(jl_typename(f.type, ctx)))"
    end
    ldefault = lowercase(default)
    if ldefault == "inf"
        default = "Inf"
    elseif ldefault == "-inf"
        default = "-Inf"
    elseif ldefault == "nan"
        default = "NaN"
    elseif ldefault == "-nan"
        default = "-NaN"
    elseif ldefault == "+inf"
        default = "+Inf"
    elseif ldefault == "+nan"
        default = "+NaN"
    end
    return string(type_name, '(', default, ')')
end
_jl_parse_default_int(::Union{Int32Type,SInt32Type,SFixed32Type}, s::String) = parse(Int32, s)
_jl_parse_default_int(::Union{Int64Type,SInt64Type,SFixed64Type}, s::String) = parse(Int64, s)
_jl_parse_default_int(::Union{UInt32Type,Fixed32Type}, s::String) = parse(UInt32, s)
_jl_parse_default_int(::Union{UInt64Type,Fixed64Type}, s::String) = parse(UInt64, s)
function jl_type_default_value(@nospecialize(f::FieldType{<:AbstractProtoNumericType}), ctx::Context)
    type_name = jl_typename(f, ctx)
    default = get(f.options, "default", nothing)
    if default === nothing
        return "zero($(jl_typename(f.type, ctx)))"
    end
    return string(type_name, '(', repr(_jl_parse_default_int(f.type, default)), ')')
end
function jl_type_default_value(f::FieldType{BytesType}, ::Context)
    out = get(f.options, "default", nothing)
    return isnothing(out) ? "UInt8[]" : "b$(out)"
end
function jl_type_default_value(f::FieldType{MapType}, ctx::Context)
    return "Dict{$(jl_typename(f.type.keytype, ctx)),$(jl_typename(f.type.valuetype, ctx))}()"
end

function jl_type_init_value(f::FieldType{ReferencedType}, ctx::Context)
    if _is_enum(f.type, ctx)
        default = get(f.options, "default") do
            definition = _get_referenced_type(f.type, ctx)::EnumType
            string(first(definition.element_names))
        end
        return "$(jl_typename(f.type, ctx)[1:end-2]).$(default)"
    else # message
        if _is_optional_referenced_message(f, ctx)
            return "Ref{Union{Nothing,$(jl_typename(f.type, ctx))}}(nothing)"
        end
        return "Ref{$(jl_typename(f.type, ctx))}()"
    end
end

jl_init_value(::OneOfType, ctx::Context) = "nothing"
jl_default_value(::OneOfType, ctx::Context) = "nothing"

function jl_init_value(f::GroupType, ctx::Context)
    if _is_repeated_field(f)
        return "PB.BufferedVector{$(jl_typename(f.type, ctx))}()"
    else
        if _is_optional_referenced_message(f, ctx)
            return "Ref{Union{Nothing,$(jl_typename(f.type, ctx))}}(nothing)"
        end
        return "Ref{$(jl_typename(f.type, ctx))}()"
    end
end

jl_type_init_value(@nospecialize(field), ctx::Context) = jl_type_default_value(field, ctx)

function jl_type_default_value(f::FieldType{ReferencedType}, ctx::Context)
    if _is_enum(f.type, ctx)
        default = get(f.options, "default") do
            definition = _get_referenced_type(f.type, ctx)::EnumType
            string(first(definition.element_names))
        end
        return "$(jl_typename(f.type, ctx)[1:end-2]).$(default)"
    else # message
        if _is_optional_referenced_message(f, ctx)
            return "nothing"
        end
        return nothing
    end
end

function jl_default_value(f::GroupType, ctx::Context)
    if _is_repeated_field(f)
        return "Vector{$(jl_typename(f.type, ctx))}()"
    else
        if _is_optional_referenced_message(f, ctx)
            return "nothing"
        end
        return nothing
    end
end

module Parsers

using ..Lexers: Lexers, Lexer, next_token, filepath
using ..Tokens: Tokens, kind, val
import ..ProtoBuf: _topological_sort, get_upstream_dependencies!

const MAX_FIELD_NUMBER = Int(typemax(UInt32) >> 3)

mutable struct ParserState{IO_t<:IO}
    l::Lexer{IO_t}
    isdone::Bool
    t::Tokens.Token
    nt::Tokens.Token
    nnt::Tokens.Token
    errored::Bool
    is_proto3::Bool
end

function readtoken(ps::ParserState)
    ps.isdone && (return ps.t)

    nnt = Lexers.next_token(ps.l)
    # Eat comments and whitespaces
    while (kind(nnt) == Tokens.COMMENT || kind(nnt) == Tokens.WHITESPACE)
        nnt = Lexers.next_token(ps.l)
    end

    ps.t = ps.nt
    ps.nt = ps.nnt
    ps.nnt = nnt
    ps.isdone = kind(ps.t) == Tokens.ENDMARKER
    return ps.t
end

function ParserState(l::Lexer)
    ps = ParserState(
        l,
        false,
        Tokens.Token(Tokens.UNINIT, Tokens.NO_ERROR, (0,0), (0,0), ""),
        Tokens.Token(Tokens.UNINIT, Tokens.NO_ERROR, (0,0), (0,0), ""),
        Tokens.Token(Tokens.UNINIT, Tokens.NO_ERROR, (0,0), (0,0), ""),
        false,
        false,
    )
    readtoken(ps)
    readtoken(ps)
    return ps
end
ParserState(input::Union{IO,String}) = ParserState(Lexer(input))

Tokens.kind(ps::ParserState) = kind(ps.t)
token(ps::ParserState) = ps.t
peektoken(ps::ParserState) = ps.nt
dpeektoken(ps::ParserState) = (ps.nt, ps.nnt)
peekkind(ps::ParserState) = kind(ps.nt)
dpeekkind(ps::ParserState) = (kind(ps.nt), kind(ps.nnt))

function expect(ps, k::Tokens.Kind)
    t = token(ps)
    if kind(ps) != k
        ps.errored = true
        throw(error("Found $(t) (value: `$(val(t))`), expected $(k) at $(t.startpos)"))
    end
    return token(ps)
end

function expectnext(ps, k::Tokens.Kind)
    t = peektoken(ps)
    if kind(t) != k
        ps.errored = true
        throw(error("Found $(t) (value: `$(val(t))`), expected $(k) at $(t.startpos)"))
    end
    return readtoken(ps)
end

function expectnext(ps, f::Function)
    t = peektoken(ps)
    if !f(kind(t))
        ps.errored = true
        throw(error("Found $(t) (value: `$(val(t))`), expected one of $(kind(t)) at $(t.startpos)"))
    end
    return readtoken(ps)
end

function accept(ps, f::Union{Function,Tokens.Kind,String})
    t = peektoken(ps)
    if isa(f, Function)
        ok = f(t)::Bool
    elseif isa(f, Tokens.Kind)
        ok = kind(t) == f
    else
        ok = val(t) == f
    end
    ok && readtoken(ps)
    return ok
end

function accept_batch(ps, f)
    ok = false
    while accept(ps, f)
        ok = true
    end
    return ok
end

function parse_integer_value(ps)
    nk, nnk = dpeekkind(ps)
    if nk == Tokens.DEC_INT_LIT
        return parse(Int, val(readtoken(ps)))
    elseif nk == Tokens.HEX_INT_LIT
        return parse(Int, val(readtoken(ps))[3:end]; base=16)
    elseif nk == Tokens.OCT_INT_LIT
        return parse(Int, val(readtoken(ps)); base=8)
    elseif nk == Tokens.PLUS && nnk == Tokens.DEC_INT_LIT
        readtoken(ps)
        parse(Int, val(readtoken(ps)))
    elseif nk == Tokens.MINUS && nnk == Tokens.DEC_INT_LIT
        readtoken(ps)
        parse(Int, string("-", val(readtoken(ps))))
    else
        error("Encountered invalid token sequence while parsing integer value: $(dpeektoken(ps))")
    end
end

include("proto_types.jl")

@enum(ImportOption, NONE, PUBLIC, WEAK)

struct ProtoImportedPackage
    import_option::ImportOption
    path::String
end

struct ProtoFilePreamble
    isproto3::Bool
    namespace::Vector{String}
    options::Dict{String,Union{String,Dict{String}}}
    imports::Vector{ProtoImportedPackage}
end

function check_name_collisions(packages, definitions, package_file, definitions_file)
    levels_to_check = length(packages) <= 1 ? @view(packages[1:length(packages)]) : @view(packages[[begin,end]])
    collisions = intersect(levels_to_check, keys(definitions))
    !isempty(collisions) &&
        throw(error(string(
            "Proto package `$(join(packages, '.'))` @ '$(package_file)', clashes with names of ",
            "following top-level definitions $(string.(collisions))",
            package_file == definitions_file ? "." : " from '$(definitions_file)'."
        )))
end

struct ProtoFile
    filepath::String
    preamble::ProtoFilePreamble
    definitions::Dict{String,Union{MessageType, EnumType, ServiceType}}
    sorted_definitions::Vector{String}
    cyclic_definitions::Set{String}
    extends::Vector{ExtendType}
end

include("utils.jl")
include("proto_options.jl")

parse_proto_file(path::String) = parse_proto_file(ParserState(path))
function parse_proto_file(ps::ParserState)
    if accept(ps, Tokens.SYNTAX)
        expectnext(ps, Tokens.EQ)
        proto_version_string = val(expectnext(ps, Tokens.STRING_LIT))[2:end-1] # drop quotes
        @assert (proto_version_string in ("proto3", "proto2"))
        expectnext(ps, Tokens.SEMICOLON)
    else
        proto_version_string = "proto2"
    end
    ps.is_proto3 = proto_version_string == "proto3"

    definitions = Dict{String,Union{MessageType, EnumType, ServiceType}}()
    extends = ExtendType[]
    options = Dict{String,Union{String,Dict{String}}}()
    imported_packages = ProtoImportedPackage[]
    package_identifier = ""

    while !accept(ps, Tokens.ENDMARKER)
        if peekkind(ps) == Tokens.PACKAGE
            if !isempty(package_identifier)
                ps.errored = true
                error("Only a single package identifier permitted")
            end
            readtoken(ps)
            package_identifier = val(expectnext(ps, Tokens.IDENTIFIER))
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.IMPORT)
            import_option = accept(ps, Tokens.PUBLIC) ? PUBLIC : accept(ps, Tokens.WEAK) ? WEAK : NONE
            imported_package_name = val(expectnext(ps, Tokens.STRING_LIT))[2:end-1] # drop quotes
            push!(imported_packages, ProtoImportedPackage(import_option, imported_package_name))
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.EXTEND)
            # we collect top-level extends here
            # Scoped extends are extracted in find_external_references
            push!(extends, parse_extend_type(ps, definitions))
        else
            type = parse_type(ps, definitions)
            if type isa ExtendType
                ps.errored = true
                error("Extend types not expected here")
                # push!(extends, type)
            elseif type isa MapType
                ps.errored = true
                error("Map types cannot appear at top-level scope")
            else
                definitions[type.name] = type
            end
        end
    end
    package_parts = split(package_identifier, '.', keepempty=false)
    preamble = ProtoFilePreamble(
        ps.is_proto3,
        package_parts,
        options,
        imported_packages,
    )
    check_name_collisions(package_parts, definitions, filepath(ps.l), filepath(ps.l))
    external_references = postprocess_types!(definitions, package_identifier)
    # TODO: handle Extensions before we sort, now extensions are completely ignored
    topologically_sorted, cyclic_definitions = _topological_sort(definitions, external_references)
    return ProtoFile(
        filepath(ps.l),
        preamble,
        definitions,
        topologically_sorted,
        cyclic_definitions,
        extends,
    )
end

end # module

using ProtoBuf
using ProtoBuf.CodeGenerators: Options, ResolvedProtoFile, translate, namespace
using ProtoBuf.CodeGenerators: import_paths, Context, codegen
using ProtoBuf.CodeGenerators: generate_struct, codegen_cylic_stub, _generate_struct_alias
using ProtoBuf.CodeGenerators: resolve_inter_package_references!, get_all_transitive_imports!
using ProtoBuf.CodeGenerators: CodeGenerators, types_needing_params
using ProtoBuf.Parsers: parse_proto_file, ParserState, Parsers
using ProtoBuf.Lexers: Lexer
using EnumX
using Test

strify(f, args...) = (io = IOBuffer(); f(io, args...); String(take!(io)))
codegen_str(args...) = strify(codegen, args...)
function generate_struct_str(def, ctx, ; remaining=copy(ctx._remaining_cyclic_defs))
    ctx._toplevel_raw_name[] = def.name
    if def.name in keys(ctx._types_and_oneofs_requiring_type_params)
        original_remaining = copy(ctx._remaining_cyclic_defs)
        empty!(ctx._remaining_cyclic_defs)
        union!(ctx._remaining_cyclic_defs, remaining)
        stub = strify(codegen_cylic_stub, def, ctx)
        empty!(ctx._remaining_cyclic_defs) # aliases are printed after all stubs, at which point the remaining defs are empty
        alias = strify(_generate_struct_alias, def, ctx)
        union!(ctx._remaining_cyclic_defs, original_remaining)
        return stub * alias
    else
        strify(generate_struct, def, ctx)
    end
end


function translate_simple_proto(str::String, options=Options())
    buf = IOBuffer()
    l = Lexer(IOBuffer(str), "main")
    p = parse_proto_file(ParserState(l))
    r = ResolvedProtoFile("main", p)
    d = Dict{String, ResolvedProtoFile}("main" => r)
    foreach(p->get_all_transitive_imports!(p, d), values(d))
    resolve_inter_package_references!(d, options)
    translate(buf, r, d, options)
    s = String(take!(buf))
    s = join(filter!(!startswith(r"#|$^"), split(s, '\n')), '\n')
    ncyclic = length(p.cyclic_definitions)
    ctx = Context(
        p, r.import_path, d,
        types_needing_params(@view(p.sorted_definitions[end-ncyclic+1:end]), p, options),
        copy(p.cyclic_definitions),
        Ref(get(p.sorted_definitions, length(p.sorted_definitions), "")),
        r.transitive_imports,
        options
    )
    return s, p, ctx
end

function translate_simple_proto(str::String, deps::Dict{String,String}, options=Options())
    buf = IOBuffer()
    l = Lexer(IOBuffer(str), "main")
    p = parse_proto_file(ParserState(l))
    r = ResolvedProtoFile("main", p)
    d = Dict{String, ResolvedProtoFile}("main" => r)
    for (k, v) in deps
        get!(d, k) do
            l = Lexer(IOBuffer(v), k)
            ResolvedProtoFile(k, parse_proto_file(ParserState(l)))
        end
    end
    d["main"] =  r
    foreach(p->get_all_transitive_imports!(p, d), values(d))
    resolve_inter_package_references!(d, options)
    original_cyclic_definitions = copy(p.cyclic_definitions)
    translate(buf, r, d, options)
    s = String(take!(buf))
    s = join(filter!(!startswith(r"#|$^"), split(s, '\n')), '\n')
    ncyclic = length(original_cyclic_definitions)
    ctx = Context(
        p, r.import_path, d,
        types_needing_params(@view(p.sorted_definitions[end-ncyclic+1:end]), p, options),
        copy(original_cyclic_definitions),
        Ref(get(p.sorted_definitions, length(p.sorted_definitions), "")),
        r.transitive_imports,
        options
    )
    return s, d, ctx
end

@testset "translate" begin
    @testset "Minimal proto file" begin
        s, p, ctx = translate_simple_proto("", Options(always_use_modules=false))
        @test s == """
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx"""

        s, p, ctx = translate_simple_proto("", Options(always_use_modules=true))
        @test s == """
        module main_pb
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx
        end # module"""
    end

    @testset "Minimal proto file with common abstract type" begin
        s, p, ctx = translate_simple_proto("", Options(always_use_modules=false, common_abstract_type=true))
        @test s == """
        import ProtoBuf as PB
        using ProtoBuf: AbstractProtoBufMessage
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx"""
    end

    @testset "Minimal proto file with file imports" begin
        s, p, ctx = translate_simple_proto("import \"path/to/a\";", Dict("path/to/a" => ""), Options(always_use_modules=false))
        @test s == """
        include("a_pb.jl")
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx"""

        s, p, ctx = translate_simple_proto("import \"path/to/a\";", Dict("path/to/a" => ""), Options(always_use_modules=true))
        @test s == """
        module main_pb
        include("a_pb.jl")
        import a_pb
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx
        end # module"""
    end

    @testset "Minimal proto file with package imports" begin
        s, p, ctx = translate_simple_proto("import \"path/to/a\";", Dict("path/to/a" => "package p;"), Options(always_use_modules=false))
        @test s == """
        include("p/p.jl")
        import .p
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx"""

        s, p, ctx = translate_simple_proto("import \"path/to/a\";", Dict("path/to/a" => "package p;"), Options(always_use_modules=true))
        @test s == """
        module main_pb
        include("p/p.jl")
        import .p
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx
        end # module"""
    end

    @testset "`force_required` option makes optional fields required" begin
        s, p, ctx = translate_simple_proto("message A {} message B { optional A a = 1; }", Options(force_required=Dict("main" => Set(["B.a"]))))
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::A
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) === nothing
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{A}()"

        @test contains(s, """
        function PB.encode(e::PB.AbstractProtoEncoder, x::B)
            initpos = position(e.io)
            PB.encode(e, 1, x.a)
            return position(e.io) - initpos
        end
        function PB._encoded_size(x::B)
            encoded_size = 0
            encoded_size += PB._encoded_size(x.a, 1)
            return encoded_size
        end
        """)
    end

    @testset "Struct fields are optional when not marked required" begin
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A {} message B { A a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,A}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        s, p, ctx = translate_simple_proto("message A {} message B { optional A a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,A}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        s, p, ctx = translate_simple_proto("message A {} message B { required A a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::A
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) === nothing
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{A}()"
    end

    @testset "Struct fields are optional when the type is self referential" begin
        s, p, ctx = translate_simple_proto("message B { optional B a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message B { B a = 1; }", Options(force_required=Dict("main" => Set(["B.a"]))))
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        s, p, ctx = translate_simple_proto("message B { required B a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        s, p, ctx = translate_simple_proto("message B { optional B a = 1; }")
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B
            a::Union{Nothing,B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"
    end

    @testset "Struct fields are optional when the type has a mutually recursive dependency" begin
        # A <-> B
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { A a = 1; }")
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Union{Nothing,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        # A <-> B, A is repeated
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { repeated A a = 1; }")
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Vector{var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "Vector{A}()"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "PB.BufferedVector{A}()"

        # A <-> B, B is "required" by the user, but it still has to be optional to break the recursion
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { A a = 1; }", Options(force_required=Dict("main" => Set(["B.a"]))))
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Union{Nothing,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        # A <-> B, A is a required field, but it still has to be optional to break the recursion
        s, p, ctx = translate_simple_proto("message A { optional B b = 1; } message B { required A a = 1; }")
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Union{Nothing,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        # A <-> B, A explicitly optional
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { optional A a = 1; }")
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Union{Nothing,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"
    end

    @testset "Mutually recursive dependency involving a group field" begin
        s, p, ctx = translate_simple_proto("syntax = \"proto2\"; message A { optional B b = 1; } message B { optional group G = 1 { optional A a = 2; }; }")
        @assert p.sorted_definitions == ["A", "B.G", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B.G", "B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B.G"], ctx, remaining=Set{String}(["B.G", "B"])) == """
        struct var"##Stub#B.G"{T1<:var"##Abstract#B"} <: var"##Abstract#B.G"
            a::Union{Nothing,var"##Stub#A"{T1}}
        end
        const var"B.G" = var"##Stub#B.G"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["B.G"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B.G"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            g::Union{Nothing,var"##Stub#B.G"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,var\"B.G\"}}(nothing)"
    end

    @testset "Mutually recursive dependency involving a map field" begin
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { map<string, A> m = 1; }")
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            m::Dict{String,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "Dict{String,A}()"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Dict{String,A}()"
    end

    @testset "Mutually recursive dependency involving where type param is shared with a different dependency" begin
        # Basic message dependencies
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { A a = 1; B b = 2; C c = 3; }
        message B { A a = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """)
        @assert p.sorted_definitions == ["B", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#C"} <: var"##Abstract#A"
            a::Union{Nothing,var"##Stub#A"{T1}}
            b::Union{Nothing,var"##Stub#B"{var"##Stub#A"{T1}}}
            c::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#C"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Ref{Union{Nothing,B}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[3], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[3], ctx) == "Ref{Union{Nothing,C}}(nothing)"

        @testset "generated fieldtypes are concrete" begin
            let _mod = Core.eval(Module(gensym()), Meta.parse(s)).main_pb
                A = Base.@invokelatest _mod.A
                for fieldtype in fieldtypes(A)
                    @assert fieldtype >: Nothing # is a Union{Nothing, ...}
                    non_optional_fieldtype = fieldtype.b === Nothing ? fieldtype.a : fieldtype.b
                    @test isconcretetype(non_optional_fieldtype)
                end
            end
        end

        # Dependencies through maps and parametrized oneofs
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { A a = 1; oneof o { A aa = 2; B b = 3; C c = 4; }; map<string,A> d1 = 5; map<string,B> d2 = 6; map<string,C> d3 = 7; }
        message B { A a = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """, Options(parametrize_oneofs=true, add_kwarg_constructors=true))
        @assert p.sorted_definitions == ["B", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:Union{Nothing,OneOf{<:Union{var"##Abstract#A",var"##Abstract#B",var"##Abstract#C"}}},T2<:var"##Abstract#C"} <: var"##Abstract#A"
            a::Union{Nothing,var"##Stub#A"{<:Union{Nothing,<:OneOf},T2}}
            o::T1
            d1::Dict{String,<:var"##Stub#A"{<:Union{Nothing,<:OneOf},T2}}
            d2::Dict{String,var"##Stub#B"{var"##Stub#A"{<:Union{Nothing,<:OneOf},T2}}}
            d3::Dict{String,T2}
        end
        const A = var"##Stub#A"{<:Union{Nothing,<:OneOf},var"##Stub#C"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[3], ctx) == "Dict{String,A}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[3], ctx) == "Dict{String,A}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[5], ctx) == "Dict{String,C}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[5], ctx) == "Dict{String,C}()"

        @testset "Containers inside oneof-specialized structs are not too narrowly typed" begin
            let _mod = Core.eval(Module(gensym()), Meta.parse(s)).main_pb
                A = Base.@invokelatest _mod.A
                B = Base.@invokelatest _mod.B
                C = Base.@invokelatest _mod.C
                a = invokelatest(A)
                try
                    a.d1["a"] = invokelatest(A)
                    a.d1["aa"] = invokelatest(A; o = OneOf(:a, invokelatest(A)))
                    a.d1["ab"] = invokelatest(A; o = OneOf(:b, invokelatest(B)))
                    a.d1["ac"] = invokelatest(A; o = OneOf(:c, invokelatest(C)))

                    a.d2["baa"] = invokelatest(B; a = invokelatest(A; o = OneOf(:a, invokelatest(A))))
                    a.d2["bab"] = invokelatest(B; a = invokelatest(A; o = OneOf(:b, invokelatest(B))))
                    a.d2["bac"] = invokelatest(B; a = invokelatest(A; o = OneOf(:c, invokelatest(C))))

                    a.d3["caa"] = invokelatest(C; a = invokelatest(A; o = OneOf(:a, invokelatest(A))))
                    a.d3["cab"] = invokelatest(C; a = invokelatest(A; o = OneOf(:b, invokelatest(B))))
                    a.d3["cac"] = invokelatest(C; a = invokelatest(A; o = OneOf(:c, invokelatest(C))))
                    @test true
                catch e
                    @test false
                end
            end
        end

        # dependency only through oneofs
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { oneof o { B b = 3; C c = 4; }; }
        message B { A a = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """)
        @assert p.sorted_definitions == ["B", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#C"} <: var"##Abstract#A"
            o::Union{Nothing,OneOf{<:Union{var"##Stub#B"{var"##Stub#A"{T1}},T1}}}
        end
        const A = var"##Stub#A"{var"##Stub#C"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "nothing"

        # Dependencies through maps and non-parametrized oneofs
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { A a = 1; oneof o { A aa = 2; B b = 3; C c = 4; }; map<string,A> d1 = 5; map<string,B> d2 = 6; map<string,C> d3 = 7; }
        message B { A a = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """)
        @assert p.sorted_definitions == ["B", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#C"} <: var"##Abstract#A"
            a::Union{Nothing,var"##Stub#A"{T1}}
            o::Union{Nothing,OneOf{<:Union{var"##Stub#A"{T1},var"##Stub#B"{var"##Stub#A"{T1}},T1}}}
            d1::Dict{String,var"##Stub#A"{T1}}
            d2::Dict{String,var"##Stub#B"{var"##Stub#A"{T1}}}
            d3::Dict{String,T1}
        end
        const A = var"##Stub#A"{var"##Stub#C"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[3], ctx) == "Dict{String,A}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[3], ctx) == "Dict{String,A}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[5], ctx) == "Dict{String,C}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[5], ctx) == "Dict{String,C}()"
    end

    @testset "Type params through transitive dependencies" begin
        # A will get parametrized on C, but only depends on C through its dependencies, B and D
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { B b = 1; D d = 2; oneof o { B bb = 3; D dd = 4; }; map<string,B> d1 = 5; map<string,D> d2 = 6; }
        message B { C c = 1; }
        message D { C c = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """)
        @assert p.sorted_definitions == ["B", "D", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#C"} <: var"##Abstract#A"
            b::Union{Nothing,var"##Stub#B"{T1}}
            d::Union{Nothing,var"##Stub#D"{T1}}
            o::Union{Nothing,OneOf{<:Union{var"##Stub#B"{T1},var"##Stub#D"{T1}}}}
            d1::Dict{String,var"##Stub#B"{T1}}
            d2::Dict{String,var"##Stub#D"{T1}}
        end
        const A = var"##Stub#A"{var"##Stub#C"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Ref{Union{Nothing,D}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[3], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[3], ctx) == "nothing"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[5], ctx) == "Dict{String,D}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[5], ctx) == "Dict{String,D}()"

        # Parametrized oneof
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { B b = 1; D d = 2; oneof o { B bb = 3; D dd = 4; }; map<string,B> d1 = 5; map<string,D> d2 = 6; }
        message B { C c = 1; }
        message D { C c = 1; }
        message C { A a = 1; B b = 2; C c = 3; }
        """, Options(parametrize_oneofs=true))
        @assert p.sorted_definitions == ["B", "D", "A", "C"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "C"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#C",T2<:Union{Nothing,OneOf{<:Union{var"##Abstract#B",var"##Abstract#D"}}}} <: var"##Abstract#A"
            b::Union{Nothing,var"##Stub#B"{T1}}
            d::Union{Nothing,var"##Stub#D"{T1}}
            o::T2
            d1::Dict{String,var"##Stub#B"{T1}}
            d2::Dict{String,var"##Stub#D"{T1}}
        end
        const A = var"##Stub#A"{var"##Stub#C",<:Union{Nothing,<:OneOf}}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Ref{Union{Nothing,D}}(nothing)"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[3], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[3], ctx) == "nothing"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[4], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[5], ctx) == "Dict{String,D}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[5], ctx) == "Dict{String,D}()"
    end

    @testset "Parametrized OneOfs and subtyping in containers" begin
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { repeated B b = 1; map<string,B> m = 2; }
        message B { oneof o { int32 i = 1; string s = 2; }; }
        """)
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A
            b::Vector{B}
            m::Dict{String,B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"

        # Dependencies with parametrized oneofs need to subtype in containers
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { repeated B b = 1; map<string,B> m = 2; }
        message B { oneof o { int32 i = 1; string s = 2; }; }
        """, Options(parametrize_oneofs=true))
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A
            b::Vector{<:B}
            m::Dict{String,<:B}
        end
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"

        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { repeated B b = 1; map<string,B> m = 2; }
        message B { A a = 1; }
        """)
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Vector{T1}
            m::Dict{String,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"

        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { repeated B b = 1; map<string,B> m = 2; }
        message B { A a = 1; oneof o { int32 i = 1; string s = 2; }; }
        """)
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "B"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Vector{T1}
            m::Dict{String,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"

        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { repeated B b = 1; map<string,B> m = 2; }
        message B { A a = 1; oneof o { int32 i = 1; string s = 2; }; }
        """, Options(parametrize_oneofs=true))
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "B"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Vector{<:T1}
            m::Dict{String,<:T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"{<:Union{Nothing,<:OneOf}}}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{B}()"
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[2], ctx) == "Dict{String,B}()"
    end

    @testset "Different oneof fields shouldn't share type param even their schemas are identical" begin
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { oneof o1 { string s1 = 1; sint32 i1 = 2; }; oneof o2 { string s2 = 3; sint32 i2 = 4; }; }
        """, Options(parametrize_oneofs=true))
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A{T1<:Union{Nothing,OneOf{<:Union{String,Int32}}},T2<:Union{Nothing,OneOf{<:Union{String,Int32}}}}
            o1::T1
            o2::T2
        end
        """
    end

    @testset "Constructors are adding necessary type params to stub definitions" begin
        s, p, ctx = translate_simple_proto("""
        syntax = "proto3";
        message A { oneof o1 { int32 a = 1; }; B b = 2; oneof o2 { uint32 u = 3; }; }
        message B { A a = 1; }
        """, Options(parametrize_oneofs=true, add_kwarg_constructors=true))
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["A", "B"])) == """
        struct var"##Stub#A"{T1<:Union{Nothing,OneOf{Int32}},T2<:var"##Abstract#B",T3<:Union{Nothing,OneOf{UInt32}}} <: var"##Abstract#A"
            o1::T1
            b::Union{Nothing,T2}
            o2::T3
        end
        const A = var"##Stub#A"{<:Union{Nothing,<:OneOf},var"##Stub#B",<:Union{Nothing,<:OneOf}}
        """
        @test strify(CodeGenerators.maybe_generate_constructor_for_type_alias, p.definitions["A"], ctx) == "A(o1, b, o2) = var\"##Stub#A\"{typeof(o1),B,typeof(o2)}(o1, b, o2)\n"
        @test strify(CodeGenerators.maybe_generate_kwarg_constructor_method, p.definitions["A"], ctx) == "A(;o1 = nothing, b = nothing, o2 = nothing) = var\"##Stub#A\"{typeof(o1),B,typeof(o2)}(o1, b, o2)\n"
    end

    @testset "Simple type with a common abstract type" begin
        s, p, ctx = translate_simple_proto("message B { optional int32 b = 1; }", Options(always_use_modules=false, common_abstract_type=true))
        @test generate_struct_str(p.definitions["B"], ctx) == """
        struct B <: AbstractProtoBufMessage
            b::Int32
        end
        """
    end

    @testset "Mutually recursive type with a common abstract type" begin
        s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { B b = 1; } message B { A a = 1; }", Options(always_use_modules=false, common_abstract_type=true))
        @assert p.sorted_definitions == ["A", "B"]
        @test generate_struct_str(p.definitions["A"], ctx, remaining=Set{String}(["B", "A"])) == """
        struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
            b::Union{Nothing,T1}
        end
        const A = var"##Stub#A"{var"##Stub#B"}
        """
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,B}}(nothing)"

        @test generate_struct_str(p.definitions["B"], ctx, remaining=Set{String}(["B"])) == """
        struct var"##Stub#B" <: var"##Abstract#B"
            a::Union{Nothing,var"##Stub#A"{var"##Stub#B"}}
        end
        const B = var"##Stub#B"
        """
        @test CodeGenerators.jl_default_value(p.definitions["B"].fields[1], ctx) == "nothing"
        @test CodeGenerators.jl_init_value(p.definitions["B"].fields[1], ctx) == "Ref{Union{Nothing,A}}(nothing)"
        @test occursin("abstract type var\"##Abstract#A\" <: AbstractProtoBufMessage end", s)
        @test occursin("abstract type var\"##Abstract#B\" <: AbstractProtoBufMessage end", s)
    end

    @testset "Empty struct with common abstract type" begin
        s, p, ctx = translate_simple_proto("message A { }", Options(always_use_modules=false, common_abstract_type=true))
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A <: AbstractProtoBufMessage end
        """
    end

    @testset "Self referential parametrized OneOf with a common abstract type" begin
        s, p, ctx = translate_simple_proto("message A { oneof o { A a = 1; int32 b = 2; } }", Options(always_use_modules=false, parametrize_oneofs=true, common_abstract_type=true))
        @test contains(s, """
        abstract type var"##Abstract#A" <: AbstractProtoBufMessage end
        struct A{T1<:Union{Nothing,OneOf{<:Union{var"##Abstract#A",Int32}}}} <: var"##Abstract#A"
            o::T1
        end
        """)
    end

    @testset "OneOf field codegen" begin
        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; } }", Options(parametrize_oneofs=true))
        @test occursin("""
        struct A{T1<:Union{Nothing,OneOf{Int32}}}
            a::T1
        end""", s)

        # Self-referential parametrized OneOf and duplicate variant types
        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; int32 c = 2; uint32 d = 3; A e = 4; } }", Options(parametrize_oneofs=true))
        @test occursin("""
        struct A{T1<:Union{Nothing,OneOf{<:Union{Int32,UInt32,var"##Abstract#A"}}}} <: var"##Abstract#A"
            a::T1
        end""", s)

        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; int32 c = 2; uint32 d = 3; } }", Options(parametrize_oneofs=true))
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A{T1<:Union{Nothing,OneOf{<:Union{Int32,UInt32}}}}
            a::T1
        end
        """

        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; int32 c = 2; uint32 d = 3; A e = 4; } }", Options(parametrize_oneofs=false))
        @test occursin("""
        struct A
            a::Union{Nothing,OneOf{<:Union{Int32,UInt32,A}}}
        end""", s)

        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; int32 c = 2; uint32 d = 3; } }", Options(parametrize_oneofs=false))
        @test generate_struct_str(p.definitions["A"], ctx) == """
        struct A
            a::Union{Nothing,OneOf{<:Union{Int32,UInt32}}}
        end
        """
    end

    @testset "`force_required` OneOf field" begin
        s, p, ctx = translate_simple_proto("message B { oneof a { int32 a = 1; } }", Options(force_required=Dict("main" => Set(["B.a"]))))
        @test occursin("""
        struct B
            a::OneOf{Int32}
        end""", s)

        s, p, ctx = translate_simple_proto("message B { oneof a { int32 a = 1; uint32 b = 2; } }", Options(force_required=Dict("main" => Set(["B.a"]))))
        @test occursin("""
        struct B
            a::OneOf{<:Union{Int32,UInt32}}
        end""", s)

        s, p, ctx = translate_simple_proto("message B { oneof a { int32 a = 1; } }", Options(force_required=Dict("main" => Set(["B.a"])), parametrize_oneofs=true))
        @test occursin("""
        struct B{T1<:OneOf{Int32}}
            a::T1
        end""", s)

        s, p, ctx = translate_simple_proto("message B { oneof a { int32 a = 1; uint32 b = 2; } }", Options(force_required=Dict("main" => Set(["B.a"])), parametrize_oneofs=true))
        @test occursin("""
        struct B{T1<:OneOf{<:Union{Int32,UInt32}}}
            a::T1
        end""", s)
    end

    @testset "Basic enum codegen" begin
        s, p, ctx = translate_simple_proto("enum A { a = 0; b = 1; }")
        @test codegen_str(p.definitions["A"], ctx) == """
        @enumx A a=0 b=1
        """
    end

    @testset "Basic Types" begin
        s, p, ctx = translate_simple_proto("message A { optional bool a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Bool"
        s, p, ctx = translate_simple_proto("message A { optional uint32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "UInt32"
        s, p, ctx = translate_simple_proto("message A { optional uint64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "UInt64"
        s, p, ctx = translate_simple_proto("message A { optional int32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int32"
        s, p, ctx = translate_simple_proto("message A { optional int64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int64"
        s, p, ctx = translate_simple_proto("message A { optional sint32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int32"
        s, p, ctx = translate_simple_proto("message A { optional sint64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int64"
        s, p, ctx = translate_simple_proto("message A { optional fixed32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "UInt32"
        s, p, ctx = translate_simple_proto("message A { optional fixed64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "UInt64"
        s, p, ctx = translate_simple_proto("message A { optional sfixed32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int32"
        s, p, ctx = translate_simple_proto("message A { optional sfixed64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Int64"
        s, p, ctx = translate_simple_proto("message A { optional float a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Float32"
        s, p, ctx = translate_simple_proto("message A { optional double a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Float64"
        s, p, ctx = translate_simple_proto("message A { optional string a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "String"
        s, p, ctx = translate_simple_proto("message A { optional bytes a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{UInt8}"

        s, p, ctx = translate_simple_proto("message A { repeated bool a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Bool}"
        s, p, ctx = translate_simple_proto("message A { repeated uint32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{UInt32}"
        s, p, ctx = translate_simple_proto("message A { repeated uint64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{UInt64}"
        s, p, ctx = translate_simple_proto("message A { repeated int32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int32}"
        s, p, ctx = translate_simple_proto("message A { repeated int64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int64}"
        s, p, ctx = translate_simple_proto("message A { repeated sint32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int32}"
        s, p, ctx = translate_simple_proto("message A { repeated sint64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int64}"
        s, p, ctx = translate_simple_proto("message A { repeated fixed32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{UInt32}"
        s, p, ctx = translate_simple_proto("message A { repeated fixed64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{UInt64}"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed32 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int32}"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed64 a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Int64}"
        s, p, ctx = translate_simple_proto("message A { repeated float a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Float32}"
        s, p, ctx = translate_simple_proto("message A { repeated double a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Float64}"
        s, p, ctx = translate_simple_proto("message A { repeated string a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{String}"
        s, p, ctx = translate_simple_proto("message A { repeated bytes a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{Vector{UInt8}}"

        s, p, ctx = translate_simple_proto("message A { map<string,sint32> a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Dict{String,Int32}"
        s, p, ctx = translate_simple_proto("message A { map<string,A> a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Dict{String,A}"
        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; int32 c = 2; uint32 d = 3; A e = 4; } }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "OneOf{Union{Int32,UInt32,A}}"
        s, p, ctx = translate_simple_proto("message A { repeated A a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{A}"
        s, p, ctx = translate_simple_proto("message B { repeated A a = 1; } message A { repeated B b = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{B}"
        s, p, ctx = translate_simple_proto("message B { oneof o { int32 b = 1; int32 c = 2; uint32 d = 3; A e = 4; } } message A { repeated B b = 1; }", Options(parametrize_oneofs=true))
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Vector{<:B}"
        s, p, ctx = translate_simple_proto("message B { repeated A a = 1; } message A { map<string,B> a = 1; }")
        @test CodeGenerators.jl_typename(p.definitions["A"].fields[1], ctx) == "Dict{String,B}"
    end

    @testset "Default values" begin
        s, p, ctx = translate_simple_proto("message A { optional bool a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "false"
        s, p, ctx = translate_simple_proto("message A { optional uint32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(UInt32)"
        s, p, ctx = translate_simple_proto("message A { optional uint64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(UInt64)"
        s, p, ctx = translate_simple_proto("message A { optional int32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional int64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"
        s, p, ctx = translate_simple_proto("message A { optional sint32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional sint64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"
        s, p, ctx = translate_simple_proto("message A { optional fixed32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(UInt32)"
        s, p, ctx = translate_simple_proto("message A { optional fixed64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(UInt64)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"

        s, p, ctx = translate_simple_proto("message A { optional float a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Float32)"
        # Test that we compare floats with triple equals to always serialize negative zero
        @test contains(s, """
        function PB.encode(e::PB.AbstractProtoEncoder, x::A)
            initpos = position(e.io)
            x.a !== zero(Float32) && PB.encode(e, 1, x.a)
            return position(e.io) - initpos
        end
        function PB._encoded_size(x::A)
            encoded_size = 0
            x.a !== zero(Float32) && (encoded_size += PB._encoded_size(x.a, 1))
            return encoded_size
        end
        """)
        s, p, ctx = translate_simple_proto("message A { optional double a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "zero(Float64)"
        # Test that we compare floats with triple equals to always serialize negative zero
        @test contains(s, """
        function PB.encode(e::PB.AbstractProtoEncoder, x::A)
            initpos = position(e.io)
            x.a !== zero(Float64) && PB.encode(e, 1, x.a)
            return position(e.io) - initpos
        end
        function PB._encoded_size(x::A)
            encoded_size = 0
            x.a !== zero(Float64) && (encoded_size += PB._encoded_size(x.a, 1))
            return encoded_size
        end
        """)

            s, p, ctx = translate_simple_proto("""
            syntax = "proto2";
            message A { repeated int32 c = 3; repeated B f = 6; }
            message B {}
            """)

        @testset "Required fields are sent over the wire uncoditionally" begin
            s, p, ctx = translate_simple_proto("""
            syntax = "proto2";
            message A {
                required int32 req_int = 1;
                optional int32 opt_int = 2;
                repeated int32 rep_int = 3;
                optional B     opt_msg = 4;
                required B     req_msg = 5;
                repeated B     rep_msg = 6;
            }
            message B {}
            """)
            @test contains(s, """
            struct A
                req_int::Int32
                opt_int::Int32
                rep_int::Vector{Int32}
                opt_msg::Union{Nothing,B}
                req_msg::B
                rep_msg::Vector{B}
            end
            """)
            @test contains(s, """
            function PB.encode(e::PB.AbstractProtoEncoder, x::A)
                initpos = position(e.io)
                PB.encode(e, 1, x.req_int)
                x.opt_int != zero(Int32) && PB.encode(e, 2, x.opt_int)
                !isempty(x.rep_int) && PB.encode(e, 3, x.rep_int)
                !isnothing(x.opt_msg) && PB.encode(e, 4, x.opt_msg)
                PB.encode(e, 5, x.req_msg)
                !isempty(x.rep_msg) && PB.encode(e, 6, x.rep_msg)
                return position(e.io) - initpos
            end
            function PB._encoded_size(x::A)
                encoded_size = 0
                encoded_size += PB._encoded_size(x.req_int, 1)
                x.opt_int != zero(Int32) && (encoded_size += PB._encoded_size(x.opt_int, 2))
                !isempty(x.rep_int) && (encoded_size += PB._encoded_size(x.rep_int, 3))
                !isnothing(x.opt_msg) && (encoded_size += PB._encoded_size(x.opt_msg, 4))
                encoded_size += PB._encoded_size(x.req_msg, 5)
                !isempty(x.rep_msg) && (encoded_size += PB._encoded_size(x.rep_msg, 6))
                return encoded_size
            end
            """)

            s, p, ctx = translate_simple_proto("""
            syntax = "proto3";
            message A {
                         int32 def_int = 1;
                optional int32 opt_int = 2;
                repeated int32 rep_int = 3;
                         B     def_msg = 4;
                optional B     opt_msg = 5;
                repeated B     rep_msg = 6;
            }
            message B {}
            """)
            @test contains(s, """
            struct A
                def_int::Int32
                opt_int::Int32
                rep_int::Vector{Int32}
                def_msg::Union{Nothing,B}
                opt_msg::Union{Nothing,B}
                rep_msg::Vector{B}
            end
            """)
            @test contains(s, """
            function PB.encode(e::PB.AbstractProtoEncoder, x::A)
                initpos = position(e.io)
                x.def_int != zero(Int32) && PB.encode(e, 1, x.def_int)
                x.opt_int != zero(Int32) && PB.encode(e, 2, x.opt_int)
                !isempty(x.rep_int) && PB.encode(e, 3, x.rep_int)
                !isnothing(x.def_msg) && PB.encode(e, 4, x.def_msg)
                !isnothing(x.opt_msg) && PB.encode(e, 5, x.opt_msg)
                !isempty(x.rep_msg) && PB.encode(e, 6, x.rep_msg)
                return position(e.io) - initpos
            end
            function PB._encoded_size(x::A)
                encoded_size = 0
                x.def_int != zero(Int32) && (encoded_size += PB._encoded_size(x.def_int, 1))
                x.opt_int != zero(Int32) && (encoded_size += PB._encoded_size(x.opt_int, 2))
                !isempty(x.rep_int) && (encoded_size += PB._encoded_size(x.rep_int, 3))
                !isnothing(x.def_msg) && (encoded_size += PB._encoded_size(x.def_msg, 4))
                !isnothing(x.opt_msg) && (encoded_size += PB._encoded_size(x.opt_msg, 5))
                !isempty(x.rep_msg) && (encoded_size += PB._encoded_size(x.rep_msg, 6))
                return encoded_size
            end
            """)
        end

        s, p, ctx = translate_simple_proto("message A { optional string a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "\"\""
        s, p, ctx = translate_simple_proto("message A { optional bytes a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "UInt8[]"

        s, p, ctx = translate_simple_proto("message A { optional bool a = 1 [default=true]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "true"
        s, p, ctx = translate_simple_proto("message A { optional uint32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "UInt32(0x00000001)"
        s, p, ctx = translate_simple_proto("message A { optional uint64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "UInt64(0x0000000000000001)"
        s, p, ctx = translate_simple_proto("message A { optional int32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional int64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional sint32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional sint64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional fixed32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "UInt32(0x00000001)"
        s, p, ctx = translate_simple_proto("message A { optional fixed64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "UInt64(0x0000000000000001)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional float a = 1 [default=1.0]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Float32(1.0)"
        s, p, ctx = translate_simple_proto("message A { optional double a = 1  [default=1.0]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Float64(1.0)"
        s, p, ctx = translate_simple_proto("message A { optional string a = 1 [default=\"1\"]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "\"1\""
        s, p, ctx = translate_simple_proto("message A { optional bytes a = 1 [default=\"1\"]; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "b\"1\""

        s, p, ctx = translate_simple_proto("message A { repeated bool a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Bool}()"
        s, p, ctx = translate_simple_proto("message A { repeated uint32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{UInt32}()"
        s, p, ctx = translate_simple_proto("message A { repeated uint64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{UInt64}()"
        s, p, ctx = translate_simple_proto("message A { repeated int32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated int64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated sint32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated sint64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated fixed32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{UInt32}()"
        s, p, ctx = translate_simple_proto("message A { repeated fixed64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{UInt64}()"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed32 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed64 a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated float a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Float32}()"
        s, p, ctx = translate_simple_proto("message A { repeated double a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Float64}()"
        s, p, ctx = translate_simple_proto("message A { repeated string a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{String}()"
        s, p, ctx = translate_simple_proto("message A { repeated bytes a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{Vector{UInt8}}()"

        s, p, ctx = translate_simple_proto("message A { map<string,sint32> a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Dict{String,Int32}()"
        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; } }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
        s, p, ctx = translate_simple_proto("message A { repeated A a = 1; }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "Vector{A}()"
        s, p, ctx = translate_simple_proto("message A { optional group Aa = 1 { optional int32 b = 1; } }")
        @test CodeGenerators.jl_default_value(p.definitions["A"].fields[1], ctx) == "nothing"
    end

    @testset "Initial values" begin
        s, p, ctx = translate_simple_proto("message A { optional bool a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "false"
        s, p, ctx = translate_simple_proto("message A { optional uint32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(UInt32)"
        s, p, ctx = translate_simple_proto("message A { optional uint64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(UInt64)"
        s, p, ctx = translate_simple_proto("message A { optional int32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional int64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"
        s, p, ctx = translate_simple_proto("message A { optional sint32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional sint64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"
        s, p, ctx = translate_simple_proto("message A { optional fixed32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(UInt32)"
        s, p, ctx = translate_simple_proto("message A { optional fixed64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(UInt64)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int32)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Int64)"
        s, p, ctx = translate_simple_proto("message A { optional float a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Float32)"
        s, p, ctx = translate_simple_proto("message A { optional double a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "zero(Float64)"
        s, p, ctx = translate_simple_proto("message A { optional string a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "\"\""
        s, p, ctx = translate_simple_proto("message A { optional bytes a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "UInt8[]"

        s, p, ctx = translate_simple_proto("message A { optional bool a = 1 [default=true]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "true"
        s, p, ctx = translate_simple_proto("message A { optional uint32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "UInt32(0x00000001)"
        s, p, ctx = translate_simple_proto("message A { optional uint64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "UInt64(0x0000000000000001)"
        s, p, ctx = translate_simple_proto("message A { optional int32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional int64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional sint32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional sint64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional fixed32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "UInt32(0x00000001)"
        s, p, ctx = translate_simple_proto("message A { optional fixed64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "UInt64(0x0000000000000001)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed32 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int32(1)"
        s, p, ctx = translate_simple_proto("message A { optional sfixed64 a = 1 [default=1]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Int64(1)"
        s, p, ctx = translate_simple_proto("message A { optional float a = 1 [default=1.0]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Float32(1.0)"
        s, p, ctx = translate_simple_proto("message A { optional double a = 1  [default=1.0]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Float64(1.0)"
        s, p, ctx = translate_simple_proto("message A { optional string a = 1 [default=\"1\"]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "\"1\""
        s, p, ctx = translate_simple_proto("message A { optional bytes a = 1 [default=\"1\"]; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "b\"1\""

        s, p, ctx = translate_simple_proto("message A { repeated bool a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Bool}()"
        s, p, ctx = translate_simple_proto("message A { repeated uint32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{UInt32}()"
        s, p, ctx = translate_simple_proto("message A { repeated uint64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{UInt64}()"
        s, p, ctx = translate_simple_proto("message A { repeated int32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated int64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated sint32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated sint64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated fixed32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{UInt32}()"
        s, p, ctx = translate_simple_proto("message A { repeated fixed64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{UInt64}()"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed32 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int32}()"
        s, p, ctx = translate_simple_proto("message A { repeated sfixed64 a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Int64}()"
        s, p, ctx = translate_simple_proto("message A { repeated float a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Float32}()"
        s, p, ctx = translate_simple_proto("message A { repeated double a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Float64}()"
        s, p, ctx = translate_simple_proto("message A { repeated string a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{String}()"
        s, p, ctx = translate_simple_proto("message A { repeated bytes a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{Vector{UInt8}}()"

        s, p, ctx = translate_simple_proto("message A { repeated A a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "PB.BufferedVector{A}()"
        s, p, ctx = translate_simple_proto("message A { map<string,sint32> a = 1; }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Dict{String,Int32}()"
        s, p, ctx = translate_simple_proto("message A { oneof a { int32 b = 1; } }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "nothing"
        s, p, ctx = translate_simple_proto("message A { optional group Aa = 1 { optional int32 b = 1; } }")
        @test CodeGenerators.jl_init_value(p.definitions["A"].fields[1], ctx) == "Ref{Union{Nothing,var\"A.Aa\"}}(nothing)"
    end

    @testset "Metadata methods" begin
        @testset "metadata_methods have generic fallback" begin
            s, p, ctx = translate_simple_proto("message A { } enum Foo { }")
            @test strify(CodeGenerators.maybe_generate_reserved_fields_method, p.definitions["A"]) == ""
            @test strify(CodeGenerators.maybe_generate_reserved_fields_method, p.definitions["Foo"]) == ""
            @test strify(CodeGenerators.maybe_generate_extendable_field_numbers_method, p.definitions["A"]) == ""
            @test strify(CodeGenerators.maybe_generate_default_values_method, p.definitions["A"], ctx) == ""
            @test strify(CodeGenerators.maybe_generate_oneof_field_types_method, p.definitions["A"], ctx) == ""
            @test strify(CodeGenerators.maybe_generate_field_numbers_method, p.definitions["A"]) == ""

            let _mod = Core.eval(Module(gensym()), Meta.parse(s)).main_pb
                A = Base.@invokelatest(_mod.A)
                Foo_T = Base.@invokelatest(Base.@invokelatest(_mod.Foo).T)
                @test reserved_fields(A) == (names = String[], numbers = Union{Int,UnitRange{Int}}[])
                @test reserved_fields(Foo_T) == (names = String[], numbers = Union{Int,UnitRange{Int}}[])
                @test extendable_field_numbers(A) == Union{Int,UnitRange{Int}}[]
                @test default_values(A) == (;)
                @test oneof_field_types(A) == (;)
                @test field_numbers(A) == (;)
            end
        end

        @testset "metadata_methods are generated when needed" begin
            s, p, ctx = translate_simple_proto("syntax = \"proto3\"; message A { reserved \"b\"; reserved 2; extensions 4 to max; A a = 1; oneof o { sfixed32 s = 3 [default = -1]; }}", Options(add_kwarg_constructors=true))
            @test strify(CodeGenerators.maybe_generate_reserved_fields_method,          p.definitions["A"])      == "PB.reserved_fields(::Type{A}) = (names = [\"b\"], numbers = Union{Int,UnitRange{Int}}[2])\n"
            @test strify(CodeGenerators.maybe_generate_extendable_field_numbers_method, p.definitions["A"])      == "PB.extendable_field_numbers(::Type{A}) = Union{Int,UnitRange{Int}}[4:536870911]\n"
            @test strify(CodeGenerators.maybe_generate_default_values_method,           p.definitions["A"], ctx) == "PB.default_values(::Type{A}) = (;a = nothing, s = Int32(-1))\n"
            @test strify(CodeGenerators.maybe_generate_oneof_field_types_method,        p.definitions["A"], ctx) == "PB.oneof_field_types(::Type{A}) = (;\n    o = (;s=Int32),\n)\n"
            @test strify(CodeGenerators.maybe_generate_field_numbers_method,            p.definitions["A"])      == "PB.field_numbers(::Type{A}) = (;a = 1, s = 3)\n"
            @test strify(CodeGenerators.maybe_generate_kwarg_constructor_method,        p.definitions["A"], ctx) == "A(;a = nothing, o = nothing) = A(a, o)\n"
        end

        @testset "reserved fields are available for enums" begin
            s, p, ctx = translate_simple_proto("""
            enum Foo {
                reserved 2, 15, 9 to 11, 40 to max;
                reserved "FOO", "BAR";
             }
            """)
            @test strify(CodeGenerators.maybe_generate_reserved_fields_method, p.definitions["Foo"]) =="PB.reserved_fields(::Type{Foo.T}) = (names = [\"FOO\", \"BAR\"], numbers = Union{Int,UnitRange{Int}}[2, 15, 9:11, 40:536870911])\n"
        end
    end

    @testset "Imports within a leaf module which name-clashes with top module" begin
        s, d, ctx = translate_simple_proto(
            """
            package A.A;
            import \"main2\";
            message FromA {
                optional FromB f = 1;
           }
            """,
            Dict(
                "main2" => """package A.B; message FromB {}""",
            ),
        );
        @test  d["main"].proto_file.definitions["FromA"].fields[1].type.package_namespace == "var\"#A\".B"
    end

    @testset "Services are excluded from exports without handlers registered" begin
        s, p, ctx = translate_simple_proto("""
        message A {}
        service S { rpc foo(A) returns (A); }
        """)
        @test contains(s, strip("""
        import ProtoBuf as PB
        using ProtoBuf: OneOf
        using ProtoBuf.EnumX: @enumx
        export A
        struct A end
        function PB.decode(d::PB.AbstractProtoDecoder, ::Type{<:A}, _endpos::Int=0, _group::Bool=false)
            while !PB.message_done(d, _endpos, _group)
                field_number, wire_type = PB.decode_tag(d)
                Base.skip(d, wire_type)
            end
            return A()
        end
        function PB.encode(e::PB.AbstractProtoEncoder, x::A)
            initpos = position(e.io)
            return position(e.io) - initpos
        end
        function PB._encoded_size(x::A)
            encoded_size = 0
            return encoded_size
        end
        end # module
        """))
    end

    @testset "Services code generation handlers work" begin
        try
            import_cb(io, ctx, definitions) = println(io, "import gRPCClient")
            service_cb(io, t, ctx) = println(io, "gRPCServiceClient = nothing")

            ProtoBuf.CodeGenerators.register_external_codegen_handler("ProtoBuf.jl"; import_cb=import_cb, service_cb=service_cb)

            s, p, ctx = translate_simple_proto("""
            message A {}
            service S { rpc foo(A) returns (A); }
            """)

            @test contains(s, "\nimport gRPCClient\n")
            @test contains(s, "\ngRPCServiceClient = nothing\n")
        finally
            empty!(ProtoBuf.CodeGenerators._external_codegen_handlers)
        end
    end
end

const JULIA_RESERVED_KEYWORDS = Set{String}([
    "abstract",
    "AbstractProtoBufMessage",
    "Any",
    "Array",
    "baremodule",
    "Base",
    "begin",
    "bitstype",
    "break",
    "catch",
    "ccall",
    "const",
    "continue",
    "DataType",
    "Dict",
    "do",
    "else",
    "elseif",
    "end",
    "Enum",
    "export",
    "Expr",
    "false",
    "finally",
    "for",
    "function",
    "global",
    "if",
    "immutable",
    "import",
    "importall",
    "let",
    "local",
    "macro",
    "Method",
    "module",
    "OneOf",
    "quote",
    "return",
    "Set",
    "struct",
    "true",
    "try",
    "type",
    "Type",
    "typealias",
    "Union",
    "using",
    "Vector",
    "while",
])

_get_name(t::AbstractProtoType) = t.name

safename(t::AbstractProtoType) = _safename(_get_name(t))

function _safename(name::AbstractString)
    dot_pos = findfirst(==('.'), name)
    if name in JULIA_RESERVED_KEYWORDS
        return string("var\"#", name, '"')
    elseif isnothing(dot_pos) && !('#' in name)
        return name
    else
        return string("var\"", name, '"')
    end
end

abstract_type_name(name::AbstractString) = string("var\"##Abstract#", name, "\"")

jl_fieldname(@nospecialize(f::AbstractProtoFieldType)) = _safename(f.name)
jl_fieldname(f::GroupType) = _safename(f.field_name)

_safe_namespace_string(ns::AbstractVector{<:AbstractString}) = string("var\"#$(first(ns))\"", '.', join(@view(ns[2:end]), '.'))

stub_type_name(x) = string("var\"##Stub#", x, "\"")

# JET
@test_opt _encoded_size(UInt8[0xff])
@test_opt _encoded_size("S")
@test_opt _encoded_size(typemax(UInt32))
@test_opt _encoded_size(typemax(UInt64))
@test_opt _encoded_size(typemax(Int32))
@test_opt _encoded_size(typemax(Int64))
@test_opt _encoded_size(true)
@test_opt _encoded_size(typemax(Int32), Val{:zigzag})
@test_opt _encoded_size(typemax(Int64), Val{:zigzag})
@test_opt _encoded_size(typemax(UInt32), Val{:zigzag})
@test_opt _encoded_size(typemax(UInt64), Val{:zigzag})
@test_opt _encoded_size(TestEnum.OTHER)
@test_opt _encoded_size(typemax(Int32), Val{:fixed})
@test_opt _encoded_size(typemax(Int64), Val{:fixed})
@test_opt _encoded_size(typemax(UInt32), Val{:fixed})
@test_opt _encoded_size(typemax(UInt64), Val{:fixed})
@test_opt _encoded_size(EmptyMessage())
@test_opt _encoded_size(NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing)))

@test_opt _encoded_size([UInt8[0xff]])
@test_opt _encoded_size(["S"])
@test_opt _encoded_size([typemax(UInt32)])
@test_opt _encoded_size([typemax(UInt64)])
@test_opt _encoded_size([typemax(Int32)])
@test_opt _encoded_size([typemax(Int64)])
@test_opt _encoded_size([true])
@test_opt _encoded_size([typemax(Int32)], Val{:zigzag})
@test_opt _encoded_size([typemax(Int64)], Val{:zigzag})
@test_opt _encoded_size([typemax(UInt32)], Val{:zigzag})
@test_opt _encoded_size([typemax(UInt64)], Val{:zigzag})
@test_opt _encoded_size([TestEnum.OTHER])
@test_opt _encoded_size([typemax(Int32)], Val{:fixed})
@test_opt _encoded_size([typemax(Int64)], Val{:fixed})
@test_opt _encoded_size([typemax(UInt32)], Val{:fixed})
@test_opt _encoded_size([typemax(UInt64)], Val{:fixed})
@test_opt _encoded_size([EmptyMessage()])
@test_opt _encoded_size([NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))])
@test_opt _encoded_size(Dict("K" => UInt8[0xff]))
@test_opt _encoded_size(Dict("K" => "S"))
@test_opt _encoded_size(Dict("KEY" => "STR"))
@test_opt _encoded_size(Dict("K" => typemax(UInt32)))
@test_opt _encoded_size(Dict("K" => typemax(UInt64)))
@test_opt _encoded_size(Dict("K" => typemax(Int32)))
@test_opt _encoded_size(Dict("K" => typemax(Int64)))
@test_opt _encoded_size(Dict("K" => true))
@test_opt _encoded_size(Dict("K" => typemax(Int32)), Val{Tuple{Nothing,:zigzag}})
@test_opt _encoded_size(Dict("K" => typemax(Int64)), Val{Tuple{Nothing,:zigzag}})
@test_opt _encoded_size(Dict("K" => typemin(Int32)), Val{Tuple{Nothing,:zigzag}})
@test_opt _encoded_size(Dict("K" => typemin(Int64)), Val{Tuple{Nothing,:zigzag}})
@test_opt _encoded_size(Dict("K" => TestEnum.OTHER))

@test_opt _encoded_size(Dict("K" => typemax(UInt32)), Val{Tuple{Nothing,:fixed}})
@test_opt _encoded_size(Dict("K" => typemax(UInt64)), Val{Tuple{Nothing,:fixed}})
@test_opt _encoded_size(Dict("K" => typemax(Int32)),  Val{Tuple{Nothing,:fixed}})
@test_opt _encoded_size(Dict("K" => typemax(Int64)),  Val{Tuple{Nothing,:fixed}})

@test_opt _encoded_size(Dict("K" => EmptyMessage()))
@test_opt _encoded_size(Dict("K" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))))
@test_opt _encoded_size(Dict(typemax(UInt32) => "V"))
@test_opt _encoded_size(Dict(typemax(UInt64) => "V"))
@test_opt _encoded_size(Dict(typemax(Int32) => "V"))
@test_opt _encoded_size(Dict(typemax(Int64) => "V"))
@test_opt _encoded_size(Dict(true => "V"))
@test_opt _encoded_size(Dict(typemax(UInt32) => "V"), Val{Tuple{:zigzag,Nothing}})
@test_opt _encoded_size(Dict(typemax(UInt64) => "V"), Val{Tuple{:zigzag,Nothing}})
@test_opt _encoded_size(Dict(typemin(Int32) => "V"), Val{Tuple{:zigzag,Nothing}})
@test_opt _encoded_size(Dict(typemin(Int64) => "V"), Val{Tuple{:zigzag,Nothing}})
@test_opt _encoded_size(Dict(TestEnum.OTHER => "V"))

@test_opt _encoded_size(Dict(typemax(UInt32) => "V"), Val{Tuple{:fixed,Nothing}})
@test_opt _encoded_size(Dict(typemax(UInt64) => "V"), Val{Tuple{:fixed,Nothing}})
@test_opt _encoded_size(Dict(typemax(Int32) => "V"),  Val{Tuple{:fixed,Nothing}})
@test_opt _encoded_size(Dict(typemax(Int64) => "V"),  Val{Tuple{:fixed,Nothing}})

@test_opt _encoded_size(typemax(Float32))
@test_opt _encoded_size(typemax(Float64))
@test_opt _encoded_size([typemax(Float32)])
@test_opt _encoded_size([typemax(Float64)])
@test_opt _encoded_size(Dict("K" => typemax(Float32)))
@test_opt _encoded_size(Dict("K" => typemax(Float64)))

# allocs
seekstart(io)
let x = typemax(UInt32)
    @test_noalloc vbyte_encode(io, x)
end
@test_noalloc vbyte_decode_and_forget(UInt32, io)

let x = typemax(UInt64)
    @test_noalloc vbyte_encode(io, x)
end
@test_noalloc vbyte_decode_and_forget(UInt64, io)


let x = [UInt8[0xff]]; @test_noalloc _encoded_size(x); nothing end
let x = ["S"]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(UInt32)]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(UInt64)]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Int32)]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Int64)]; @test_noalloc _encoded_size(x); nothing end
let x = [true]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Int32)]; @test_noalloc _encoded_size(x, Val{:zigzag}); nothing end
let x = [typemax(Int64)]; @test_noalloc _encoded_size(x, Val{:zigzag}); nothing end
let x = [typemin(UInt32)]; @test_noalloc _encoded_size(x, Val{:zigzag}); nothing end
let x = [typemax(UInt64)]; @test_noalloc _encoded_size(x, Val{:zigzag}); nothing end
let x = [TestEnum.OTHER]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Int32)]; @test_noalloc _encoded_size(x, Val{:fixed}); nothing end
let x = [typemax(Int64)]; @test_noalloc _encoded_size(x, Val{:fixed}); nothing end
let x = [typemax(UInt32)]; @test_noalloc _encoded_size(x, Val{:fixed}); nothing end
let x = [typemax(UInt64)]; @test_noalloc _encoded_size(x, Val{:fixed}); nothing end
let x = [EmptyMessage()]; @test_noalloc _encoded_size(x); nothing end
let x = [NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))]; @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => UInt8[0xff]); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => "S"); @test_noalloc _encoded_size(x); nothing end
let x = Dict("KEY" => "STR"); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(UInt32)); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(UInt64)); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(Int32)); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(Int64)); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => true); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(UInt32)), V=Val{Tuple{Nothing,:zigzag}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemax(UInt64)), V=Val{Tuple{Nothing,:zigzag}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemin(Int32)), V=Val{Tuple{Nothing,:zigzag}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemin(Int64)), V=Val{Tuple{Nothing,:zigzag}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => TestEnum.OTHER); @test_noalloc _encoded_size(x); nothing end

let x = Dict("K" => typemax(UInt32)), V=Val{Tuple{Nothing,:fixed}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemax(UInt64)), V=Val{Tuple{Nothing,:fixed}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemax(Int32)) , V=Val{Tuple{Nothing,:fixed}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict("K" => typemax(Int64)) , V=Val{Tuple{Nothing,:fixed}}; @test_noalloc _encoded_size(x, V); nothing end

let x = Dict("K" => EmptyMessage()); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => NonEmptyMessage(typemax(UInt32), NonEmptyMessage(typemax(UInt32), nothing))); @test_noalloc _encoded_size(x); nothing end
let x = Dict(typemax(UInt32) => "V"); @test_noalloc _encoded_size(x); nothing end
let x = Dict(typemax(UInt64) => "V"); @test_noalloc _encoded_size(x); nothing end
let x = Dict(typemax(Int32) => "V"); @test_noalloc _encoded_size(x); nothing end
let x = Dict(typemax(Int64) => "V"); @test_noalloc _encoded_size(x); nothing end
let x = Dict(true => "V"); @test_noalloc _encoded_size(x); nothing end
let x = Dict(typemax(Int32) => "V"), V=Val{Tuple{:zigzag,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemax(Int64) => "V"), V=Val{Tuple{:zigzag,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemin(UInt32) => "V"), V=Val{Tuple{:zigzag,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemin(UInt64) => "V"), V=Val{Tuple{:zigzag,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(TestEnum.OTHER => "V"); @test_noalloc _encoded_size(x); nothing end

let x = Dict(typemax(UInt32) => "V"), V=Val{Tuple{:fixed,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemax(UInt64) => "V"), V=Val{Tuple{:fixed,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemax(Int32) => "V"), V=Val{Tuple{:fixed,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end
let x = Dict(typemax(Int64) => "V"), V=Val{Tuple{:fixed,Nothing}}; @test_noalloc _encoded_size(x, V); nothing end

let x = typemax(Float32); @test_noalloc _encoded_size(x); nothing end
let x = typemax(Float64); @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Float32)]; @test_noalloc _encoded_size(x); nothing end
let x = [typemax(Float64)]; @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(Float32)); @test_noalloc _encoded_size(x); nothing end
let x = Dict("K" => typemax(Float64)); @test_noalloc _encoded_size(x); nothing end

using Aqua
using JET
using ProtoBuf
using Test

function is_ci()
    get(ENV, "TRAVIS", "") == "true" ||
    get(ENV, "APPVEYOR", "") in ("true", "True") ||
    get(ENV, "CI", "") in ("true", "True")
end

include("unittests.jl")

# Don't run JET on nightly in CI
if Base.VERSION > v"1.7.0" && !(is_ci() && get(VERSION.prerelease, 1, "") == "DEV")
    @testset "JET" begin
        include("jet_test_utils.jl")

        # filter false positives for undefined variable warnings in `copy_chunks!` from Base.BitArray
        jet_frames_to_skip = (
            JETFrameFingerprint(JET.UndefVarErrorReport, :Base, :copy_chunks!, "copy_chunks!(dest::Vector{UInt64}, pos_d::Int64, src::Vector{UInt64}, pos_s::Int64, numbits::Int64)"),
            JETFrameFingerprint(JET.UndefVarErrorReport, :Base, :copy_chunks_rtol!, "copy_chunks_rtol!(chunks::Vector{UInt64}, pos_d::Int64, pos_s::Int64, numbits::Int64)"),
        )

        is_ci() || jet_test_package(ProtoBuf; jet_frames_to_skip)
        # jet_test_file("unittests.jl", ignored_modules=(JET.AnyFrameModule(Test),))
        include("test_perf.jl")
    end
end

@testset "Aqua" begin
    Aqua.test_all(ProtoBuf)
end

#=
using Coverage
using ProtoBuf
pkg_path = pkgdir(ProtoBuf);
coverage = process_folder(joinpath(pkg_path, "src"));
open(joinpath(pkg_path, "lcov.info"), "w") do io
    LCOV.write(io, coverage)
end;
covered_lines, total_lines = get_summary(coverage);
println("Coverage: $(round(100 * covered_lines / total_lines, digits=2))%");
run(`find $pkg_path -name "*.cov" -type f -delete`);
=#

module CodeGenerators


import ..Parsers
import ..Parsers: ProtoFile, DoubleType, FloatType, Int32Type
import ..Parsers: Int64Type, UInt32Type, UInt64Type, SInt32Type, SInt64Type
import ..Parsers: Fixed32Type, Fixed64Type, SFixed32Type, SFixed64Type, BoolType
import ..Parsers: StringType, BytesType
import ..Parsers: GroupType, OneOfType, MapType, FieldType
import ..Parsers: MessageType, EnumType, ServiceType, RPCType, ReferencedType
import ..Parsers: AbstractProtoType, AbstractProtoNumericType, AbstractProtoFixedType
import ..Parsers: AbstractProtoFloatType, AbstractProtoFieldType
import ..ProtoBuf: VENDORED_WELLKNOWN_TYPES_PARENT_PATH, PACKAGE_VERSION
import ..ProtoBuf: _topological_sort, get_upstream_dependencies!

_is_repeated_field(f::AbstractProtoFieldType) = f.label == Parsers.REPEATED
_is_repeated_field(::OneOfType) = false

struct ResolvedProtoFile
    import_path::String
    proto_file::ProtoFile
    implicit_imports::Set{String}
    transitive_imports::Set{String}
end
ResolvedProtoFile(rel_path, p) = ResolvedProtoFile(rel_path, p, Set{String}(), Set{String}())

Base.@kwdef struct Options
    include_vendored_wellknown_types::Bool = true
    always_use_modules::Bool = true
    force_required::Union{Nothing,Dict{String,Set{String}}} = nothing
    add_kwarg_constructors::Bool = false
    parametrize_oneofs::Bool = false
    common_abstract_type::Bool = false
end

struct Context
    proto_file::ProtoFile
    proto_file_path::String
    file_map::Dict{String,ResolvedProtoFile}
    _types_and_oneofs_requiring_type_params::Dict{String,Vector{Tuple{Bool,String}}}
    _remaining_cyclic_defs::Set{String}
    _toplevel_raw_name::Ref{String}
    transitive_imports::Set{String}
    options::Options
end

include("modules.jl")
include("names.jl")
include("types.jl")
include("defaults.jl")
include("decode_methods.jl")
include("encode_methods.jl")
include("metadata_methods.jl")
include("toplevel_definitions.jl")
include("utils.jl")

"""
    protojl(
        relative_paths::Union{String,Vector{String}},
        search_directories::Union{String,Vector{String},Nothing}=nothing,
        output_directory::Union{String,Nothing}=nothing;
        include_vendored_wellknown_types::Bool=true,
        always_use_modules::Bool=true,
        force_required::Union{Nothing,Dict{String,Set{String}}}=nothing,
        add_kwarg_constructors::Bool=false,
        parametrize_oneofs::Bool=false,
        common_abstract_type::Bool=false,
    ) -> Nothing

Generate Julia code for `.proto` files at `relative_paths` within `search_directories` and save it to `output_directory`.

When compiling a `{file_name}.proto` files that do not have a `package` specifier, a `{file_name}_pb.jl` is generated in `output_directory`.
When a `{file_name}.proto` contains e.g. `package foo_bar.baz_grok`, the following directory structure is created:
```bash
root  # `output_directory` arg from from `protojl`
└── foo_bar
    ├── foo_bar.jl  # defines module `foo_bar`, imports `baz_grok`
    └── baz_grok
        ├── {file_name}_pb.jl
        └── baz_grok.jl  # defines module `baz_grok`, includes `{file_name}_pb.jl`
```
You should include the top-level module of a generated package, i.e. `foo_bar.jl` in this example.
All imported `.proto` files are compiled as well; an error is thrown if they cannot be resolved or found within `search_directories`.

# Arguments
- `relative_paths::Union{String,Vector{String}}`: A path or paths to `.proto` files to be compiled.
- `search_directories::Union{String,Vector{String},Nothing}=nothing`: A directory or directories to search for `relative_paths` in. By default, the current directory is used.
- `output_directory::Union{String,Nothing}=nothing`: Path to store the generated Julia source code. When omitted, the translated code is saved to temp directory, the path is shown as a @info log.

# Keywords
- `include_vendored_wellknown_types::Bool=true`: Append `ProtoBuf.VENDORED_WELLKNOWN_TYPES_PARENT_PATH[]` to `search_directories`, making the "well-known" message definitions available.
- `always_use_modules::Bool=true`: Generate julia code in a module even if the `.proto` file doesn't contain a `package` specifier. The module name of `{file_name}.proto` file is `{file_name}_pb`.
- `force_required::Union{Nothing,Dict{String,Set{String}}}=nothing`: Assume `message` and `oneof` fields to be always send over the wire -- then we wouldn't need to `Union` their respective types with `Nothing`. E.g:
```julia
# force_required === nothing
struct MyMessage
    message_field::Union{Nothing,MyOtherMessage}}
end
```
```julia
# force_required === Dict("{file_name}.proto" => Set(["MyMessage.message_field"]))
struct MyMessage
    message_field::MyOtherMessage}
end
```
- `add_kwarg_constructors::Bool=false`: For each message, generate an outer constructor with optional keyword arguments (if a field is a required message, there are no default values and the keyword argument is not optional).
- `parametrize_oneofs::Bool=false`: Add the `OneOf` type as a type parameter to the generated parent struct. I.e. this changes:
```julia
# parametrize_oneofs == false
struct MyMessage
    oneof_field::Union{Nothing, OneOf{<:Union{Int, String}}}
end
```
to
```julia
# parametrize_oneofs == true
struct MyMessage{T1<:Union{Nothing, OneOf{<:Union{Int, String}}}}
    oneof_field::T1
end
- `common_abstract_type::Bool=false`: When `true`, all generated structs will subtype `ProtoBuf.AbstractProtoBufMessage`.
```

# Notes
We use `relative_paths` and `search_directories` instead of absolute paths to resolve proto `import` statements which are using relative paths.
"""
function protojl(
    relative_paths::Union{<:AbstractString,<:AbstractVector{<:AbstractString}},
    search_directories::Union{<:AbstractString,<:AbstractVector{<:AbstractString},Nothing}=nothing,
    output_directory::Union{<:AbstractString,Nothing}=nothing;
    include_vendored_wellknown_types::Bool=true,
    always_use_modules::Bool=true,
    force_required::Union{Nothing,<:Dict{<:AbstractString,<:Set{<:AbstractString}}}=nothing,
    add_kwarg_constructors::Bool=false,
    parametrize_oneofs::Bool=false,
    common_abstract_type::Bool = false,
)
    options = Options(include_vendored_wellknown_types, always_use_modules, force_required, add_kwarg_constructors, parametrize_oneofs, common_abstract_type)
    return _protojl(relative_paths, search_directories, output_directory, options)
end

function _protojl(
    relative_paths::Union{<:AbstractString,<:AbstractVector{<:AbstractString}},
    search_directories::Union{<:AbstractString,<:AbstractVector{<:AbstractString},Nothing},
    output_directory::Union{<:AbstractString,Nothing},
    options::Options,
)
    if isnothing(search_directories)
        search_directories = ["."]
    elseif isa(search_directories, AbstractString)
        search_directories = [search_directories]
    end
    validate_search_directories!(search_directories, options.include_vendored_wellknown_types)

    if isa(relative_paths, AbstractString)
        relative_paths = [relative_paths]
    end
    absolute_paths = validate_proto_file_paths!(relative_paths, search_directories)

    parsed_files = Dict{String,ResolvedProtoFile}()
    _import_paths = Set{String}()
    for (rel_path, abs_path) in zip(relative_paths, absolute_paths)
        p = Parsers.parse_proto_file(abs_path)
        parsed_files[rel_path] = ResolvedProtoFile(rel_path, p)
        union!(_import_paths, import_paths(p))
    end
    resolve_imports!(_import_paths, parsed_files, search_directories)

    if isnothing(output_directory)
        output_directory = mktempdir(tempdir(); prefix="jl_proto_", cleanup=false)
        @info output_directory
    else
        isdir(output_directory) || error("`output_directory` \"$output_directory\" doesn't exist")
        output_directory = abspath(output_directory)
    end

    foreach(p->get_all_transitive_imports!(p, parsed_files), values(parsed_files))
    # Files within the same package could use definitions from different files
    # without fully qualifying their name -- on Julia side, we need to make sure
    # the files are read in order that respect these implicit dependencies.
    resolve_inter_package_references!(parsed_files, options)
    sorted_files, cyclical_imports = _topological_sort(parsed_files)
    !isempty(cyclical_imports) && error(string(
        "Detected cyclical dependency among following imports: $cyclical_imports, ",
        "possibly, the individual files are resolvable, but their `package`s are not."
    ))
    sorted_files = [parsed_files[sorted_file] for sorted_file in sorted_files]
    n = Namespaces(sorted_files, output_directory, parsed_files)
    for m in n.non_namespaced_protos
        dst_path = joinpath(output_directory, proto_script_name(m))
        CodeGenerators.translate(dst_path, m, parsed_files, options)
    end
    for m in values(n.packages)
        generate_package(m, output_directory, parsed_files, options)
    end
    return nothing
end

# Allows other packages to extend code generation
struct ExternalCodeGenHandler
    package_name::String
    # Function(io, ::Context, ::Dict{String, Union{MessageType, ServiceType, EnumType}})
    import_cb::Union{Function, Nothing}
    # Function(io, ::ServiceType, ::Context)
    service_cb::Union{Function, Nothing}
end
package_name(h::ExternalCodeGenHandler) = h.package_name

# Add external import statements after "import ProtoBuf"
function import_cb(
    h::ExternalCodeGenHandler,
    io,
    ctx::Context,
    definitions::Dict{String,Union{MessageType, EnumType, ServiceType}}
)
    isnothing(h.import_cb) && return
    h.import_cb(io, ctx, definitions)
end

# Add external service definitions
function service_cb(h::ExternalCodeGenHandler, io, t::ServiceType, ctx::Context)
    isnothing(h.service_cb) && return
    println(io, "# $(package_name(h)) BEGIN")
    h.service_cb(io, t, ctx)
    println(io, "# $(package_name(h)) END")
end

const _external_codegen_handlers = Dict{String, ExternalCodeGenHandler}()
function register_external_codegen_handler(package_name::String; import_cb=nothing, service_cb=nothing)
    h = ExternalCodeGenHandler(package_name, import_cb, service_cb)
    _external_codegen_handlers[package_name] = h
end


export protojl

end # CodeGenerators

function encode_condition(f::FieldType, ctx::Context)
    if _is_repeated_field(f)
        return "!isempty(x.$(jl_fieldname(f)))"
    else
        return _encode_condition(f, ctx)
    end
end
_encode_condition(@nospecialize(f::FieldType), ctx::Context) = "x.$(jl_fieldname(f)) != $(jl_init_value(f, ctx))"
_encode_condition(f::FieldType{<:AbstractProtoFloatType}, ctx:: Context) = "x.$(jl_fieldname(f)) !== $(jl_init_value(f, ctx))"
_encode_condition(f::FieldType{<:MapType}, ::Context) = "!isempty(x.$(jl_fieldname(f)))"
function _encode_condition(f::FieldType{T}, ctx::Context) where {T<:Union{StringType,BytesType}}
    default = get(f.options, "default", nothing)
    if default === nothing
        return "!isempty(x.$(jl_fieldname(f)))"
    end
    return "x.$(jl_fieldname(f)) != $(jl_init_value(f, ctx))"
end
_encode_condition(f::OneOfType, ::Context) = "!isnothing(x.$(jl_fieldname(f)))"
function _encode_condition(f::FieldType{ReferencedType}, ctx::Context)
    if _is_message(f.type, ctx)
        return "!isnothing(x.$(jl_fieldname(f)))"
    else
        return "x.$(jl_fieldname(f)) != $(jl_init_value(f, ctx))"
    end
end

field_encode_expr(f::GroupType, ::Context) = "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{:group})"
function field_encode_expr(@nospecialize(f::FieldType), ctx::Context)
    if _is_repeated_field(f)
        encoding_val_type = _decoding_val_type(f.type)
        !isempty(encoding_val_type) && (encoding_val_type = ", Val{$encoding_val_type}")
        # TODO: do we want to allow unpacked representation? Docs say that parsers must always handle both cases
        # and since packed is strictly more efficient, currently we don't allow that.
        # is_packed = parse(Bool, get(f.options, "packed", "false"))
        # if is_packed
            return "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f))$(encoding_val_type))"
        # else
        #     return """
        #     for el in x.$(jl_fieldname(f))
        #                 PB.encode(e, $(string(f.number)), el$(encoding_val_type))
        #             end"""
        # end
    else
        return _field_encode_expr(f, ctx)
    end
end

_field_encode_expr(f::FieldType, ::Context) = "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)))"
_field_encode_expr(f::GroupType, ::Context) = "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)))"
_field_encode_expr(f::FieldType{<:AbstractProtoFixedType}, ::Context) = "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{:fixed})"
_field_encode_expr(f::FieldType{<:Union{SInt32Type,SInt64Type}}, ::Context) = "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{:zigzag})"
function _field_encode_expr(f::FieldType{<:MapType}, ::Context)
    K = _decoding_val_type(f.type.keytype)
    V = _decoding_val_type(f.type.valuetype)
    isempty(V) && isempty(K) && return "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)))"
    !isempty(V) && isempty(K) && return "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{Tuple{Nothing,$(V)}})"
    isempty(V) && !isempty(K) && return "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{Tuple{$(K),Nothing}})"
    return "PB.encode(e, $(string(f.number)), x.$(jl_fieldname(f)), Val{Tuple{$(K),$(V)}})"
end

function print_field_encode_expr(io, f::FieldType, ctx::Context)
    print(io, "    ")
    _needs_encoding_condition(f, ctx) && print(io, encode_condition(f, ctx), " && ")
    println(io, field_encode_expr(f, ctx))
end

function print_field_encode_expr(io, f::GroupType, ctx::Context)
    println(io, "    !isnothing(x.$(jl_fieldname(f))) && ", field_encode_expr(f, ctx))
end

function print_field_encode_expr(io, fs::OneOfType, ctx::Context)
    println(io, "    if isnothing(x.$(safename(fs)));")
    for f in fs.fields
        V = _decoding_val_type(f.type)
        V = isempty(V) ? "" : ", Val{$V}"
        println(io, "    elseif ", "x.$(safename(fs)).name === :", jl_fieldname(f))
        println(io, "    " ^ 2, "PB.encode(e, $(string(f.number)), x.$(safename(fs))[]::$(jl_typename(f, ctx))$V)")
    end
    println(io, "    end")
end

function generate_encode_method(io, t::MessageType, ctx::Context)
    println(io, "function PB.encode(e::PB.AbstractProtoEncoder, x::$(safename(t)))")
    println(io, "    initpos = position(e.io)")
    for field in t.fields
        print_field_encode_expr(io, field, ctx)
    end
    println(io, "    return position(e.io) - initpos", )
    println(io, "end")
end


function print_field_encoded_size_expr(io, f::FieldType, ctx::Context)
    print(io, "    ")
    is_optional = _needs_encoding_condition(f, ctx)
    is_optional && print(io, encode_condition(f, ctx), " && (")
    print(io, "encoded_size += ", field_encoded_size_expr(f))
    println(io, is_optional ? ")" : "")
end

function print_field_encoded_size_expr(io, f::GroupType, ::Context)
    println(io, "    !isnothing(x.$(jl_fieldname(f))) && (encoded_size += ", field_encoded_size_expr(f), ")")
end

function print_field_encoded_size_expr(io, fs::OneOfType, ctx::Context)
    println(io, "    if isnothing(x.$(safename(fs)));")
    for f in fs.fields
        V = _decoding_val_type(f.type)
        V = isempty(V) ? "" : ", Val{$V}"
        println(io, "    elseif ", "x.$(safename(fs)).name === :", jl_fieldname(f))
        println(io, "    " ^ 2, "encoded_size += PB._encoded_size(x.$(safename(fs))[]::$(jl_typename(f, ctx)), $(string(f.number))$V)")
    end
    println(io, "    end")
end

field_encoded_size_expr(f::FieldType) = "PB._encoded_size(x.$(jl_fieldname(f)::String), $(string(f.number)))"
field_encoded_size_expr(f::GroupType) = "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)))"
field_encoded_size_expr(f::FieldType{<:AbstractProtoFixedType}) = "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)), Val{:fixed})"
field_encoded_size_expr(f::FieldType{<:Union{SInt32Type,SInt64Type}}) = "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)), Val{:zigzag})"
function field_encoded_size_expr(f::FieldType{<:MapType})
    K = _decoding_val_type(f.type.keytype)
    V = _decoding_val_type(f.type.valuetype)
    isempty(V) && isempty(K) && return "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)))"
    !isempty(V) && isempty(K) && return "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)), Val{Tuple{Nothing,$(V)}})"
    isempty(V) && !isempty(K) && return "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)), Val{Tuple{$(K),Nothing}})"
    return "PB._encoded_size(x.$(jl_fieldname(f)), $(string(f.number)), Val{Tuple{$(K),$(V)}})"
end

function generate__encoded_size_method(io, t::MessageType, ctx::Context)
    println(io, "function PB._encoded_size(x::$(safename(t)))")
    println(io, "    encoded_size = 0")
    for field in t.fields
        print_field_encoded_size_expr(io, field, ctx)
    end
    println(io, "    return encoded_size")
    println(io, "end")
end

function _findfunc(namespace, i, name, from_innermost)
    n = length(namespace)
    if from_innermost
        i > n && return (string(namespace, '.', name), n) # first search
        i == 0 && return ("", -1)                         # not found
        j = something(findprev('.', namespace, i-1), 0)
        j == 0 && i != 0 && return (name, 0)              # last search
        j != 0 && i != 0 && return (string(@view(namespace[1:j]), name), j)
    else
        i < 1 && return (name, 1)                                    # first search
        i == n && return ("", -1)                                    # not found
        j = something(findnext('.', namespace, i+1), n)
        j == n && i != n && return (string(namespace, '.', name), n) # last search
        j != n && i != n && return (string(@view(namespace[1:j]), name), j)
    end
    throw(error("When from_innermost is `true`, i must be >= 0, when from_innermost is `false`, i must be <= length(namespace), got (from_innermost=$from_innermost, i=$i)"))
end

function match_prefix(prefix, name)
    i = length(prefix)
    subprefix = @view prefix[begin:end]
    while true
        startswith(name, subprefix) && return subprefix
        i = findprev('.', prefix, i-1)
        isnothing(i) && return SubString("", 1, 0)
        subprefix = @view prefix[i+1:end]
    end
end

abstract type AbstractResolvingContext end

struct IntraFileResolvingContext <: AbstractResolvingContext
    external_references::Set{String}
    definitions::Dict{String, Union{MessageType, EnumType, ServiceType}}
    package_prefix::String
end

function reference_type(def, t::ReferencedType)
    isa(def, MessageType) ? MESSAGE :
    isa(def, EnumType)    ? ENUM    :
    isa(def, ServiceType) ? SERVICE :
    isa(def, RPCType)     ? RPC     :
    throw(error("Referenced type `$(t.name)` has unsupported type $(typeof(def))"))
end

_postprocess_reference!(type, rctx::AbstractResolvingContext, namespace) = nothing
function _postprocess_reference!(type::ReferencedType, rctx::IntraFileResolvingContext, namespace)
    if !type.resolved
        # Get rid of the package prefix if it coincides with the package of the current file
        matched_prefix = match_prefix(rctx.package_prefix, type.name)
        if !isempty(matched_prefix)
            type.name = type.name[length(matched_prefix)+1:end]
        end
        # We're trying to resolve the reference within our current file
        # if we don't succeed, we'll try to resolve the reference among
        # other proto files later, duing codegen.
        i = type.resolve_from_innermost ? (length(namespace) + 1) : 0
        while true
            (namespaced_name, i) = _findfunc(namespace, i, type.name, type.resolve_from_innermost)
            if i == -1
                push!(rctx.external_references, type.name)
                break
            end
            def = get(rctx.definitions, namespaced_name, nothing)
            if !isnothing(def)
                type.name = namespaced_name
                type.reference_type = reference_type(def, type)
                type.resolved = true
                break
            end
        end
    end
end

_postprocess_field!(f::FieldType{ReferencedType}, rctx, namespace) = _postprocess_reference!(f.type, rctx, namespace)
_postprocess_field!(f::FieldType{MapType}, rctx, namespace)        = _postprocess_reference!(f.type.valuetype, rctx, namespace)
_postprocess_field!(f::FieldType, rctx, namespace) = nothing
function _postprocess_field!(f::OneOfType, rctx, namespace)
    for field in f.fields
        _postprocess_field!(field, rctx, namespace)
    end
    return nothing
end
function _postprocess_field!(f::GroupType, rctx, namespace)
    for field in f.type.fields
        _postprocess_field!(field, rctx, namespace)
    end
    return nothing
end

_postprocess_type!(t::EnumType, rctx::AbstractResolvingContext) = nothing
function _postprocess_type!(t::ServiceType, rctx::AbstractResolvingContext)
    for rpc in t.rpcs
        _postprocess_reference!(rpc.request_type, rctx, t.name)
        _postprocess_reference!(rpc.response_type, rctx, t.name)
    end
    return nothing
end
function _postprocess_type!(t::MessageType, rctx::AbstractResolvingContext)
    for field in t.fields
        _postprocess_field!(field, rctx, t.name)
    end
    return nothing
end

function postprocess_types!(definitions::Dict{String, Union{MessageType, EnumType, ServiceType}}, package_name::String)
    # Traverse all definitions and see which of those referenced are not defined
    # in this module. Create a list of these imported definitions so that we can ignore
    # them when doing the topological sort.
    rctx = IntraFileResolvingContext(Set{String}(), definitions, string(package_name, '.'))
    for definition in values(definitions)
        _postprocess_type!(definition, rctx)
    end
    return rctx.external_references
end

get_type_name(::AbstractProtoType) = nothing
get_type_name(t::ReferencedType)   = t.name
get_type_name(t::MapType)          = get_type_name(t.valuetype) # messages and enums can't be keys

function _is_self_reference!(t::MessageType, field_type_name::Union{Nothing,String})
    isnothing(field_type_name) && return true  # don't push as dependency
    if t.name == field_type_name
        t.is_self_referential[] = true
        return true  # don't push as dependency
    end
    return false # push as dependency
end

function get_upstream_dependencies!(t::ServiceType, out)
    for rpc in t.rpcs
        push!(out, rpc.request_type.name)
        push!(out, rpc.response_type.name)
    end
    return nothing
end
function get_upstream_dependencies!(::EnumType, out)
    return nothing
end
function get_upstream_dependencies!(t::MessageType, out)
    for field in t.fields
        _get_upstream_dependencies!(field, out, t)
    end
    return nothing
end

function _get_upstream_dependencies!(t::OneOfType, out, top_message::Union{Nothing,MessageType}=nothing)
    for field in t.fields
        _get_upstream_dependencies!(field, out, top_message)
    end
    return nothing
end
function _get_upstream_dependencies!(t::FieldType, out, top_message::Union{Nothing,MessageType}=nothing)
    name = get_type_name(t.type)
    !_is_self_reference!(top_message, name) && push!(out, name)
    return nothing
end
function _get_upstream_dependencies!(t::GroupType, out, top_message::Union{Nothing,MessageType}=nothing)
    !_is_self_reference!(top_message, t.name) && push!(out, t.name)
    get_upstream_dependencies!(t.type, out)
    return nothing
end

# to hook in, import and define get_upstream_dependencies! methods for your types
function get_upstream_dependencies!(definition, upstreams)
    throw(MethodError(get_upstream_dependencies!, (typeof(definition), typeof(upstreams))))
end

function _topological_sort(definitions::Dict{K}, ignored_keys::Union{Nothing,Set{K}}=nothing) where {K}
    has_ignored_keys = !isnothing(ignored_keys) && !isempty(ignored_keys)
    number_of_upstream_dependencies = Dict{K,Int}()
    downstream_dependencies = Dict{K,Vector{K}}()
    upstreams = Set{K}()
    topologically_sorted = sizehint!(K[], length(definitions))
    queue = sizehint!(K[], length(definitions))

    for (name, definition) in definitions
        empty!(upstreams)
        get_upstream_dependencies!(definition, upstreams)
        has_ignored_keys && setdiff!(upstreams, ignored_keys)
        if length(upstreams) == 0
            push!(queue, name)
        else
            number_of_upstream_dependencies[name] = length(upstreams)
        end
        get!(downstream_dependencies, name, K[])
        for u in upstreams
            # add current definition as an downstream dependency to it's upstreams
            push!(get!(downstream_dependencies, u, K[]), name)
        end
    end

    while !isempty(queue)
        u = popfirst!(queue)
        push!(topologically_sorted, u)
        D = downstream_dependencies[u]
        while !isempty(D)
            d = pop!(D)
            if (number_of_upstream_dependencies[d] -= 1) == 0
                pop!(number_of_upstream_dependencies, d)
                push!(queue, d)
            end
        end
    end

    cyclic_definitions = upstreams
    empty!(cyclic_definitions)
    if !isempty(number_of_upstream_dependencies)
        @debug "The input is not a DAG."
        for cyclic_definition in map(first, (sort!(collect(number_of_upstream_dependencies), by=p->(last(p), first(p)))))
            push!(cyclic_definitions, cyclic_definition)
            push!(topologically_sorted, cyclic_definition)
        end
    end

    return topologically_sorted, cyclic_definitions
end

module ProtoBuf
import EnumX
import BufferedStreams
using TOML

# TODO:
# - Services & RPC
# - Support proper julia package generation when proto packages share a dependency
# - Preserve docstrings
# - Text Format
# - Vendor proto definitions of common Julia types and dedicated methods for encode/decode
#    * Int8, UInt8, Int16, UInt16, Int128, UInt128, Float16, UUID, Date, DateTime, Rational
# - Add a metadata method to query integer encodings (varint / zigzag / fixed)
# - well-known Any type support
# - configs for protojl:
#    * Allow the user to use inline string for specific message string fields
#    * Make Dicts robust to missing values where possible
# - Extensions

const PACKAGE_VERSION = let
    project = TOML.parsefile(joinpath(@__DIR__, "..", "Project.toml"))
    VersionNumber(project["version"])
end

const VENDORED_WELLKNOWN_TYPES_PARENT_PATH = Ref{String}()
function __init__()
    VENDORED_WELLKNOWN_TYPES_PARENT_PATH[] = dirname(@__FILE__)
    return nothing
end

struct OneOf{T}
    name::Symbol
    value::T
end

Base.getindex(t::OneOf) = t.value
Base.Pair(t::OneOf) = t.name => t.value


include("topological_sort.jl")

include("lexing/Tokens.jl")
include("lexing/Lexers.jl")

include("parsing/Parsers.jl")
include("codegen/CodeGenerators.jl")
include("codec/Codecs.jl")

import .Lexers
import .Parsers
import .CodeGenerators
import .CodeGenerators: protojl
import .Codecs
import .Codecs: decode, decode!, encode, AbstractProtoDecoder, AbstractProtoEncoder, ProtoDecoder, BufferedVector, ProtoEncoder, message_done, decode_tag, skip, _encoded_size

# For codegen/metadata_methods.jl
"""
    reserved_fields(::Type{T}) where T

Return a named tuple of reserved field `names` and `numbers` from the original proto message definition.
The numbers might be individual integers or integer ranges.
"""
function reserved_fields(::Type{T}) where T
    return (names = String[], numbers = Union{Int,UnitRange{Int}}[])
end
"""
    extendable_field_numbers(::Type{T}) where T

Return `extensions` field numbers from the original proto message definition.
The numbers might be individual integers or integer ranges.
"""
function extendable_field_numbers(::Type{T}) where T
    return Union{Int,UnitRange{Int}}[]
end
"""
    oneof_field_types(::Type{T}) where T

Return a named tuple of `oneof` field names to the full NamedTuple type describing the type individual `oneof` options.
Returns an empty named tuple, `(;)`, if the original proto message doesn't contain any `oneof` fields
"""
function oneof_field_types(::Type{T}) where T
    return (;)
end
"""
    field_numbers(::Type{T}) where T

Return a named tuple of fields names to their respective field numbers from the original proto message type.
Fields of `OneOf` types are expanded as they don't map to any single field number.
"""
function field_numbers(::Type{T}) where T
    return (;)
end
"""
    default_values(::Type{T}) where T

Return a named tuple of fields names to their respective default values from the original proto message type.
Fields of `OneOf` types are expanded as they don't map to any single default value.

`required` message-fields do not have a default value and are represented as `Ref{MyFieldMessageType}()`.
"""
function default_values(::Type{T}) where T
    return (;)
end

"""
    decode(d::AbstractProtoDecoder, ::Type{T}) where {T}

Decode a protobuf message from `IO` wrapped by `AbstractProtoDecoder` into s struct of type T.

For general structs, these methods should be generated using the [`protojl`](@ref) function.
"""
function decode(d::AbstractProtoDecoder, ::Type{T}) where {T}
    throw(MethodError(decode, (typeof(d), T)))
end

"""
    encode(d::AbstractProtoDecoder, x::T) where {T}

Encode struct `x` of type `T` as protobuf message to `IO` wrapped by `AbstractProtoEncoder`.

For general structs, these methods should be generated using the [`protojl`](@ref) function.
"""
function encode(e::AbstractProtoEncoder, ::T) where {T}
    throw(MethodError(encode, (typeof(e), T)))
end

abstract type AbstractProtoBufMessage end

export protojl, encode, ProtoEncoder, decode, decode!, ProtoDecoder
export OneOf, AbstractProtoBufMessage
export reserved_fields, extendable_field_numbers, oneof_field_types, field_numbers, default_values

if Base.VERSION >= v"1.4.2"
    include("precompile.jl")
    _precompile_()
end

end # module

function _should_force_required(qualified_name, ctx::Context)
    isnothing(ctx.options.force_required) && return false
    force_required = get(ctx.options.force_required, ctx.proto_file_path, nothing)
    isnothing(force_required) && return false
    return qualified_name in force_required::Set{String}
end

function generate_struct_field(io, @nospecialize(field), ctx::Context, type_params)
    println(io, "    ", jl_fieldname(field)::String, "::", jl_typename(field, ctx)::String)
end

function generate_struct_field(io, field::FieldType{ReferencedType}, ctx::Context, type_params::TypeParams)
    field_name = jl_fieldname(field)
    type_name = _ref_type_or_concrete_stub_or_param(field.type, ctx, type_params)
    type_name = _maybe_union_or_vector_a_type_name(type_name, field, ctx)
    println(io, "    ", field_name, "::", type_name)
end

function generate_struct_field(io, field::GroupType, ctx::Context, type_params::TypeParams)
    field_name = jl_fieldname(field)
    type_name = _ref_type_or_concrete_stub_or_param(field.type, ctx, type_params)
    type_name = _maybe_union_or_vector_a_type_name(type_name, field, ctx)
    println(io, "    ", field_name, "::", type_name)
end

function generate_struct_field(io, field::FieldType{MapType}, ctx::Context, type_params)
    field_name = jl_fieldname(field)

    if field.type.valuetype isa ReferencedType
        value_type_name = _ref_type_or_concrete_stub_or_param(field.type.valuetype, ctx, type_params)
        _maybe_subtype = _needs_subtyping_in_containers(field.type.valuetype, ctx) ? "<:" : ""
        type_name = string("Dict{", jl_typename(field.type.keytype, ctx), ",", _maybe_subtype, value_type_name, "}")
    else
        type_name = jl_typename(field, ctx)
    end
    println(io, "    ", field_name, "::", type_name)
end

function generate_struct_field(io, field::OneOfType, ctx::Context, type_params)
    field_name = jl_fieldname(field)
    type_param = get(type_params.oneofs, field.name, nothing)

    if !isnothing(type_param)
        type_name = type_param.param
    else
        type_name = _get_oneof_type_bound(field, ctx, type_params)
    end
    println(io, "    ", field_name, "::", type_name)
end

function generate_struct(io, t::MessageType, ctx::Context)
    struct_name = safename(t)
    if _needs_abstract_type_for_parametrized_oneofs(t, ctx)
        type_params = get_type_params_for_non_cyclic(t, ctx)
        params_string = get_type_param_string(type_params)
        maybe_subtype = t.is_self_referential[] ?
            string(" <: ", abstract_type_name(t.name)) :
            ctx.options.common_abstract_type ?
                " <: AbstractProtoBufMessage" :
                ""
    else
        type_params = EMPTY_TYPE_PARAMS
        params_string = ""
        maybe_subtype = ctx.options.common_abstract_type ?
            " <: AbstractProtoBufMessage" :
            ""
    end
    print(io, "struct ", struct_name, params_string, maybe_subtype)
    # new line if there are fields, otherwise ensure that we have space before `end`
    length(t.fields) > 0 ? println(io) : print(io, ' ')
    for field in t.fields
        generate_struct_field(io, field, ctx, type_params)
    end
    println(io, "end")
end

codegen(t::AbstractProtoType, ctx::Context) = codegen(stdout, t, ctx::Context)

function codegen(io, t::MessageType, ctx::Context)
    generate_struct(io, t, ctx)
    maybe_generate_kwarg_constructor_method(io, t, ctx)
    maybe_generate_deprecation(io, t)
    maybe_generate_reserved_fields_method(io, t )
    maybe_generate_extendable_field_numbers_method(io, t)
    maybe_generate_oneof_field_types_method(io, t, ctx)
    maybe_generate_default_values_method(io, t, ctx)
    maybe_generate_field_numbers_method(io, t)
    println(io)
    generate_decode_method(io, t, ctx)
    println(io)
    generate_encode_method(io, t, ctx)
    generate__encoded_size_method(io, t, ctx)
end
# If a MessageType is not topologically sort-able, we forward-declare a "stub" version of it.
# This stub is a struct that has a type param for each of its type dependencies, that were also
# not topologically sort-able. Each non-topologically sort-able type also has a custom abstract
# type defined for it, which is used as a type bound for the type param of the stub struct.
# Each stub can refer to itself and all previous stubs, which allows us to break the dependency
# cycles. After we're done with defining all the stubs, we generate type aliases that point to the
# concretized stub definitions (i.e. definitions where all the type params are provided using the
# the stubs). E.g.:
#=
```proto
message A { B b = 1; }
message B { A a = 1; }
```
would generate the following types and aliases:
```julia
abstract type var"##Abstract#A" end
abstract type var"##Abstract#B" end

struct var"##Stub#A"{T1<:var"##Abstract#B"} <: var"##Abstract#A"
    b::T1
end
struct var"##Stub#B" <: var"##Abstract#B"
    a::var"##Stub#A"{var"##Stub#B"}
end
const A = var"##Stub#A"{var"##Stub#B"} # <- This is fully concrete type
const B = var"##Stub#B"                # <- This is fully concrete type
```
=#
function codegen_cylic_stub(io, t::MessageType, ctx::Context)
    @assert t.name in keys(ctx._types_and_oneofs_requiring_type_params)
    # After we're done with this struct, all the subsequent definitions can use it
    # so we pop it from the list of cyclic definitions.
    abstract_base_name = pop!(ctx._remaining_cyclic_defs, t.name, "")
    type_params = get_type_params_for_cyclic(t, ctx)
    params_string = get_type_param_string(type_params)

    print(io, "struct ", stub_type_name(t.name), length(t.fields) > 0 ? params_string : " ", _maybe_subtype(abstract_base_name, ctx.options))
    # new line if there are fields, otherwise ensure that we have space before `end`
    length(t.fields) > 0 ? println(io) : print(io, ' ')
    for field in t.fields
        generate_struct_field(io, field, ctx, type_params)
    end
    println(io, "end")
end
# After all the stubs are defined (see above), we generate a type alias to the concretized version
# of the corresponding stub and then we proceed defining all the metadata and codec methods
# as we do for non-cyclic types.
function codegen_cylic_rest(io, t::MessageType, ctx::Context)
    _generate_struct_alias(io, t, ctx)
    # We must define the constructor after the const is set, otherwise we get an error
    maybe_generate_constructor_for_type_alias(io, t, ctx)
    maybe_generate_kwarg_constructor_method(io, t, ctx)
    maybe_generate_deprecation(io, t)
    maybe_generate_reserved_fields_method(io, t )
    maybe_generate_extendable_field_numbers_method(io, t)
    maybe_generate_oneof_field_types_method(io, t, ctx)
    maybe_generate_default_values_method(io, t, ctx)
    maybe_generate_field_numbers_method(io, t)
    println(io)
    generate_decode_method(io, t, ctx)
    println(io)
    generate_encode_method(io, t, ctx)
    generate__encoded_size_method(io, t, ctx)
end

function codegen(io, t::EnumType, ::Context)
    name = safename(t)
    print(io, "@enumx ", name)
    for (k, n) in zip(t.element_names, t.element_values)
        print(io, " $k=$n")
    end
    println(io)
    maybe_generate_deprecation(io, t)
    maybe_generate_reserved_fields_method(io, t)
end


function codegen(io, t::ServiceType, ctx::Context)
    if isempty(_external_codegen_handlers)
        println(io, "# SERVICE: No codegen handlers registered")
        println(io, "#    ", safename(t))
        return
    end

    map(h->service_cb(h, io, t, ctx), values(_external_codegen_handlers))
    nothing
end

function translate(path::String, rp::ResolvedProtoFile, file_map::Dict{String,ResolvedProtoFile}, options)
    open(path, "w") do io
        translate(io, rp, file_map, options)
    end
end

function Parsers.check_name_collisions(p::ProtoFile, file_map::Dict)
    for import_path in import_paths(p)
        i = file_map[import_path].proto_file
        Parsers.check_name_collisions(
            namespace(i), p.definitions, i.filepath, p.filepath
        )
    end
end

translate(rp::ResolvedProtoFile, file_map::Dict{String,ResolvedProtoFile}, options) = translate(stdout, rp, file_map, options)
function translate(io, rp::ResolvedProtoFile, file_map::Dict{String,ResolvedProtoFile}, options)
    p = rp.proto_file
    Parsers.check_name_collisions(p, file_map)
    println(io, "# Autogenerated using ProtoBuf.jl v$(PACKAGE_VERSION)")
    println(io, "# original file: ", rp.import_path," (proto", p.preamble.isproto3 ? '3' : '2', " syntax)")
    println(io)

    # TODO: cleanup here, we probably don't need a reference to rp.transitive_imports in ctx?
    ctx = Context(
        p,
        rp.import_path,
        file_map,
        types_needing_params(_cyclic_defs(p), p, options),
        copy(p.cyclic_definitions),
        Ref{String}(),
        rp.transitive_imports,
        options,
    )

    if !is_namespaced(p)
        options.always_use_modules && println(io, "module $(replace(proto_script_name(p), ".jl" => ""))")
        options.always_use_modules && println(io)
        # if current file is not namespaced, it will not live in a module
        # and will need to import its dependencies directly.
        for path in import_paths(p)
            dependency = file_map[path]
            if !is_namespaced(dependency)
                # if the dependency is also not namespaced, we can just include it
                println(io, "include(", _include_stmt_format(proto_script_name(dependency)), ")")
                options.always_use_modules && println(io, "import $(replace(proto_script_name(dependency), ".jl" => ""))")
            else
                # otherwise we need to import it trough a module
                import_pkg_name = namespaced_top_import(dependency)
                println(io, "include(", _include_stmt_format(namespaced_top_include(dependency)), ")")
                println(io, "import $(import_pkg_name)")
            end
        end
    end # Otherwise all includes will happen in the enclosing module
    println(io, "import ProtoBuf as PB")

    # Allow for doing things like "import gRPCClient" or "import gRPCServer" exactly one time per file
    map(h->import_cb(h, io, ctx, p.definitions), values(_external_codegen_handlers))

    options.common_abstract_type && println(io, "using ProtoBuf: AbstractProtoBufMessage")
    println(io, "using ProtoBuf: OneOf")
    println(io, "using ProtoBuf.EnumX: @enumx")
    if (is_namespaced(p) || options.always_use_modules) && !isempty(p.definitions)
        len = 93
        for name in p.sorted_definitions
            p.definitions[name] isa ServiceType && continue # TODO: Services are not currently generated
            safename = _safename(name)
            if len + length(safename) + 2 >= 92
                print(io, "\nexport ")
                len = 7
            else
                print(io, ", ")
                len += 2
            end
            print(io, safename)
            len += length(safename)
        end
    end

    println(io)

    if options.parametrize_oneofs
        for name in _non_cyclic_defs(p)
            def = p.definitions[name]
            if def isa MessageType && _needs_abstract_type_for_parametrized_oneofs(def, ctx)
                println(io, "abstract type ", abstract_type_name(name), options.common_abstract_type ? " <: AbstractProtoBufMessage" : "", " end")
            end
        end
    end
    for name in p.cyclic_definitions
        println(io, "abstract type ", abstract_type_name(name), options.common_abstract_type ? " <: AbstractProtoBufMessage" : "", " end")
    end

    println(io)

    for def_name in _non_cyclic_defs(p)
        println(io)
        ctx._toplevel_raw_name[] = def_name
        codegen(io, p.definitions[def_name], ctx)
    end

    length(_cyclic_defs(p)) > 0 && print(io, "\n# Stub definitions for cyclic types")
    for def_name in _cyclic_defs(p)
        println(io)
        ctx._toplevel_raw_name[] = def_name
        codegen_cylic_stub(io, p.definitions[def_name], ctx)
    end

    for def_name in _cyclic_defs(p)
        println(io)
        ctx._toplevel_raw_name[] = def_name
        codegen_cylic_rest(io, p.definitions[def_name], ctx)
    end

    options.always_use_modules && !is_namespaced(p) && println(io, "end # module")
end

using ProtoBuf
using ProtoBuf: _topological_sort
using ProtoBuf.CodeGenerators: ResolvedProtoFile
using ProtoBuf.CodeGenerators: Options
using ProtoBuf.CodeGenerators: Namespaces
using ProtoBuf.CodeGenerators: generate_module_file
using ProtoBuf.Parsers: parse_proto_file, ParserState
using ProtoBuf.Lexers: Lexer
using Test

function simple_namespace_from_protos(str::String, deps::Dict{String,String}=Dict{String, String}(), pkg::String="", options::Options=Options())
    l = Lexer(IOBuffer(str), "main")
    p = parse_proto_file(ParserState(l))
    r = ResolvedProtoFile("main", p)
    d = Dict{String, ResolvedProtoFile}("main" => r)
    io = IOBuffer()
    for (k, v) in deps
        get!(d, k) do
            l = Lexer(IOBuffer(v), k)
            ResolvedProtoFile(k, parse_proto_file(ParserState(l)))
        end
    end
    d["main"] = r
    sorted_files = _topological_sort(d, Set{String}())[1]
    sorted_files = [d[sorted_file] for sorted_file in sorted_files]
    n = Namespaces(sorted_files, "out", d)
    !isempty(pkg) && generate_module_file(io, n.packages[pkg], "out", d, options, 1)
    return String(take!(io)), d, n
end

@testset "Non-packaged proto imports packaged proto" begin
    s, d, n = simple_namespace_from_protos(
        "import \"path/to/a\";",
        Dict("path/to/a" => "package P;"),
    );
    @test length(n.non_namespaced_protos) == 1
    @test n.non_namespaced_protos[1].import_path == "main"
    @test length(n.packages) == 1
    @test haskey(n.packages, "P")
    @test n.packages["P"].name == "P"
    @test n.packages["P"].proto_files[1].import_path == "path/to/a"
end

@testset "Packaged proto imports non-packaged proto" begin
    s, d, n = simple_namespace_from_protos(
        "package P; import \"path/to/a\";",
        Dict("path/to/a" => ""),
    );
    @test length(n.non_namespaced_protos) == 1
    @test n.non_namespaced_protos[1].import_path == "path/to/a"
    @test length(n.packages) == 1
    @test haskey(n.packages, "P")
    @test n.packages["P"].nonpkg_imports == Set(["a_pb"])
    @test n.packages["P"].name == "P"
    @test n.packages["P"].proto_files[1].import_path == "main"
end

@testset "Non-packaged proto imports non-packaged proto" begin
    s, d, n = simple_namespace_from_protos(
        "import \"path/to/a\";",
        Dict("path/to/a" => ""),
    );
    @test length(n.non_namespaced_protos) == 2
    @test sort([p.import_path for p in n.non_namespaced_protos]) == ["main", "path/to/a"]
    @test isempty(n.packages)
end

@testset "Packaged proto imports packaged proto" begin
    s, d, n = simple_namespace_from_protos(
        "package A.B; import \"path/to/a\";",
        Dict("path/to/a" => "package B.A;"),
    );
    @test isempty(n.non_namespaced_protos)
    @test haskey(n.packages, "A")
    @test haskey(n.packages, "B")
    @test n.packages["A"].name == "A"
    @test isempty(n.packages["A"].nonpkg_imports)
    @test n.packages["A"].external_imports == Set([("../B/B.jl")])
    @test n.packages["A"].submodules[["A", "B"]].name == "B"
    @test n.packages["A"].submodules[["A", "B"]].proto_files[1].import_path == "main"
    @test n.packages["B"].name == "B"
    @test n.packages["B"].submodules[["B", "A"]].name == "A"
    @test n.packages["B"].submodules[["B", "A"]].proto_files[1].import_path == "path/to/a"
end

@testset "External dependencies are imported in in the topmost module where all downstreams can reach it" begin
    s, d, n = simple_namespace_from_protos(
        "package A.B.C.D.E; import \"path/to/a\"; import \"path/to/b\";",
        Dict(
            "main2" => "package A.B.C; import \"path/to/a\";",
            "path/to/a" => "package B.A;",
            "path/to/b" => "package B.A;",
        ),
        "A"
    );
    @test n.packages["A"].external_imports == Set(["../B/B.jl"])
    @test n.packages["A"].submodules[["A", "B"]].external_imports == Set{String}()
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "C"]].external_imports == Set(["...B"])
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "C"]].submodules[["A", "B", "C", "D"]].external_imports == Set{String}()
    @test s == """
    module A

    include("../B/B.jl")

    include("B/B.jl")

    end # module A
    """

    s, d, n = simple_namespace_from_protos(
        "package A.B.C.D.E; import \"path/to/a\"; import \"path/to/b\";",
        Dict(
            "main2" => "package A.B.C; import \"path/to/a\";",
            "path/to/a" => "",
            "path/to/b" => "",
        ),
        "A"
    );
    @test n.packages["A"].nonpkg_imports == Set(["a_pb", "b_pb"])
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "C"]].external_imports == Set(["...a_pb"])
    @test s == """
    module A

    include("../a_pb.jl")
    include("../b_pb.jl")

    include("B/B.jl")

    end # module A
    """
end

@testset "Imported non-namespaced protos are put in artificial modules internally" begin
    s, d, n = simple_namespace_from_protos(
        "package A.B.C.D.E; import \"path/to/a\"; import \"path/to/b\";",
        Dict(
            "main2" => "package A.B.C; import \"path/to/a\";",
            "path/to/a" => "",
            "path/to/b" => "",
        ),
        "A",
        Options(always_use_modules=false)
    );
    @test n.packages["A"].nonpkg_imports == Set(["a_pb", "b_pb"])
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "C"]].external_imports == Set(["...a_pb"])
    @test s == """
    module A

    module a_pb
        include("../a_pb.jl")
    end
    module b_pb
        include("../b_pb.jl")
    end

    include("B/B.jl")

    end # module A
    """
end

@testset "Repeated julia module names are made unique" begin
    s, d, n = simple_namespace_from_protos(
        "package A.B.A.D.B.A;",
    );
    @test haskey(n.packages, "A")
    @test n.packages["A"].name == "A"
    @test n.packages["A"].submodules[["A", "B"]].name == "B"
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "A"]].name == "A"
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "A"]].submodules[["A", "B", "A", "D"]].name == "D"
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "A"]].submodules[["A", "B", "A", "D"]].submodules[["A", "B", "A", "D", "B"]].name == "B"
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "A"]].submodules[["A", "B", "A", "D"]].submodules[["A", "B", "A", "D", "B"]].submodules[["A", "B", "A", "D", "B", "A"]].name == "A"
end

@testset "Relative internal imports" begin
    s, d, n = simple_namespace_from_protos(
        "package A.B.C; import \"main2\";",
        Dict(
            "main2" => "package A.B.C.D;",
        ),
        "A",
    );
    @test n.packages["A"].submodules[["A", "B"]].submodules[["A", "B", "C"]].internal_imports == Set([["A", "B", "C", "D"]])

    s, d, n = simple_namespace_from_protos(
        "package A.B; import \"main2\";",
        Dict(
            "main2" => "package A.B.C.D;",
        ),
        "A",
    );
    @test n.packages["A"].submodules[["A", "B"]].internal_imports == Set([["A", "B", "C", "D"]])
    @test n.packages["A"].submodules[["A", "B"]].name == "B"
end

@testset "Imports within a leaf module which name-clashes with top module" begin
    s, d, n = simple_namespace_from_protos(
        """
        package A.A;
        import \"main2\";
        message FromA {
            optional FromB f = 1;
        }
        """,
        Dict(
            "main2" => """package A.B; message FromB {}""",
        ),
        "A",
    );
    @test s == """
    module A

    import .A as var"#A"

    include("main_pb.jl")
    include("B/B.jl")

    end # module A
    """
end

using Documenter
using ProtoBuf

makedocs(
    sitename = "ProtoBuf.jl",
    format = Documenter.HTML(
        prettyurls = get(ENV, "CI", nothing) == "true"
    ),
    pages = [
        "Home" => "index.md",
        "Reference" => "reference.md",
        "FAQ" => "faq.md",
    ],
)

deploydocs(
    repo = "github.com/JuliaIO/ProtoBuf.jl.git",
    push_preview = true,
)

# If we have a Dict or Vector of a message type that is parametrized on a OneOf, we cannot type
# the container concretely. In this case we prepend a `<:` to the eltype.
_needs_subtyping_in_containers(t::AbstractProtoType, ctx::Context) = false
function _needs_subtyping_in_containers(t::ReferencedType, ctx::Context)
    !_is_message(t, ctx) && return false
    if ctx.options.parametrize_oneofs
        return (_get_referenced_type(t, ctx)::MessageType).has_oneof_field
    end
    return false
end

# If we parametrize oneofs and the message is self referential, we can't use the type name
# in the type param constraint, i.e.:
# This is legal definition:
# struct A
#     x::Union{Nothing,A}
# end
# This isn't:
# struct A{T1<:Union{Nothing,A}}
#     x::T1
# end
function _needs_abstract_type_for_parametrized_oneofs(t::MessageType, ctx::Context)
    # Note that the abstract type might not be needed if the self-reference does not come
    # from a oneof field, but this is okay.
    return ctx.options.parametrize_oneofs && t.has_oneof_field
end

# jl_typename is used to get the name of a Julia type corresponding to messages, its fields, enums...
# BUT for types that require parametrization and "stub" types to get around cyclic dependencies, we need
# to go through a more complicated route that calls to _ref_type_or_concrete_stub_or_param.
function jl_typename(f::AbstractProtoFieldType, ctx)
    type_name = jl_typename(f.type, ctx)
    if _is_repeated_field(f)
        return string("Vector{", _needs_subtyping_in_containers(f.type, ctx) ? "<:" : "", type_name, "}")
    end
    return type_name
end

function jl_typename(t::MapType, ctx::Context)
    key_type = jl_typename(t.keytype, ctx)
    val_type = jl_typename(t.valuetype, ctx)
    return string("Dict{", key_type, ',', _needs_subtyping_in_containers(t.valuetype, ctx) ? "<:" : "", val_type,"}")
end
jl_typename(::DoubleType, ::Context)   = "Float64"
jl_typename(::FloatType, ::Context)    = "Float32"
jl_typename(::Int32Type, ::Context)    = "Int32"
jl_typename(::Int64Type, ::Context)    = "Int64"
jl_typename(::UInt32Type, ::Context)   = "UInt32"
jl_typename(::UInt64Type, ::Context)   = "UInt64"
jl_typename(::SInt32Type, ::Context)   = "Int32"
jl_typename(::SInt64Type, ::Context)   = "Int64"
jl_typename(::Fixed32Type, ::Context)  = "UInt32"
jl_typename(::Fixed64Type, ::Context)  = "UInt64"
jl_typename(::SFixed32Type, ::Context) = "Int32"
jl_typename(::SFixed64Type, ::Context) = "Int64"
jl_typename(::BoolType, ::Context)     = "Bool"
jl_typename(::StringType, ::Context)   = "String"
jl_typename(::BytesType, ::Context)    = "Vector{UInt8}"
jl_typename(t::MessageType, ::Context) = safename(t)
# Note that proper handling of references is done in _ref_type_or_concrete_stub_or_param, which takes care
# of stub types and type parametrizations. It calls this method in the regular case.
function jl_typename(t::ReferencedType, ctx::Context)
    # Assessing the type makes sure we search for the reference in imports
    # and populate the resolved_package field.
    @assert t.resolved "Reference to $(t.name) not resolved."
    name = safename(t)
    if !isnothing(t.package_namespace)
        name = string(t.package_namespace, '.', name)
    end
    # References to enum types need to have a `.T` suffix as were using EnumX.jl
    _is_enum(t, ctx) && (name = string(name, ".T"))
    return name
end

function jl_typename(t::OneOfType, ctx::Context)
    return string("OneOf{", _jl_oneof_inner_typename(t, ctx), "}")
end

function _jl_oneof_inner_typename(t::OneOfType, ctx::Context)
    union_types = unique!([jl_typename(f.type, ctx) for f in t.fields])
    return length(union_types) == 1 ? only(union_types) : string("Union{", join(union_types, ','), '}')
end

# TODO: should we store the definition within the referenced type itself?
# we need this to find the first value of enums...
function _get_referenced_type(t::ReferencedType, ctx::Context)
    @assert t.resolved "Reference to $(t.name) not resolved."
    if isnothing(t.package_import_path)
        return ctx.proto_file.definitions[t.name]
    else
        return ctx.file_map[t.package_import_path].proto_file.definitions[t.name]
    end
end

_is_message(t::MessageType, ctx::Context)    = true
_is_message(t::ReferencedType, ctx::Context) = t.reference_type == Parsers.MESSAGE
_is_enum(t::ReferencedType, ctx::Context)    = t.reference_type == Parsers.ENUM

# Return a mapping from type names to a list of dependencies that require type params, each
# having an indicator whether the string is a name of a oneof field that we need the type
# param for, or a cyclical type reference if it's false.
function types_needing_params(cyclical_names::AbstractVector{String}, proto_file, options)
    field_types_requiring_type_params = Dict{String,Vector{Tuple{Bool,String}}}()
    isempty(cyclical_names) && return field_types_requiring_type_params
    _seen = Set{Tuple{Bool,String}}()
    _cyclical_set = Set{String}(cyclical_names)
    for c in cyclical_names
        deps = Tuple{Bool,String}[]
        _types_needing_params!(deps, field_types_requiring_type_params, proto_file.definitions[c], _cyclical_set, options, c, _seen)
        empty!(_seen)
        pop!(_cyclical_set, c) # remove the current name from the set since it will be defined for all remaining cyclic definitions
        field_types_requiring_type_params[c] = deps
    end
    return field_types_requiring_type_params
end

_types_needing_params!(out, lookup, t::AbstractProtoType,         _cyclical_set, options, self_name, _seen) = nothing
_types_needing_params!(out, lookup, t::FieldType{ReferencedType}, _cyclical_set, options, self_name, _seen) = _types_needing_params!(out, lookup, t.type, _cyclical_set, options, self_name, _seen)
_types_needing_params!(out, lookup, t::MessageType,               _cyclical_set, options, self_name, _seen) = foreach(f->_types_needing_params!(out, lookup, f, _cyclical_set, options, self_name, _seen), t.fields)
_types_needing_params!(out, lookup, t::GroupType,                 _cyclical_set, options, self_name, _seen) = foreach(f->_types_needing_params!(out, lookup, f, _cyclical_set, options, self_name, _seen), t.type.fields)
_types_needing_params!(out, lookup, t::FieldType{MapType},        _cyclical_set, options, self_name, _seen) = _types_needing_params!(out, lookup, t.type.valuetype, _cyclical_set, options, self_name, _seen)
function _types_needing_params!(out, lookup, t::OneOfType, _cyclical_set, options, self_name, _seen)
    if options.parametrize_oneofs
        get!(_seen.dict, (true, t.name)) do
            push!(out, (true, t.name))
            return nothing
        end
    else
        foreach(f->_types_needing_params!(out, lookup, f.type, _cyclical_set, options, self_name, _seen), t.fields)
    end
end
function _types_needing_params!(out, lookup, t::ReferencedType, _cyclical_set, options, self_name, _seen)
    __types_needing_params!(out, lookup, t.name, _cyclical_set, options, self_name, _seen)
end
function __types_needing_params!(out, lookup, tname, _cyclical_set, options, self_name, _seen)
    tname == self_name && return nothing # self-references do not need type params, they just work
    if tname in _cyclical_set
        get!(_seen.dict, (false, tname)) do
            push!(out, (false, tname))
            return nothing
        end
    elseif tname in keys(lookup)
        foreach(f->__types_needing_params!(out, lookup, f[2], _cyclical_set, options, self_name, _seen), lookup[tname])
    end
    return nothing
end

function _maybe_subtype(name, options)
    isempty(name) && return options.common_abstract_type ? " <: AbstractProtoBufMessage" : ""
    return string(" <: ", abstract_type_name(name))
end

struct ParamMetadata
    param::String # like T1, T2, T3, ...
    bound::String # like var"##Abstract#A", Union{Nothing,Int}... used to bound the type param within struct parametrization
end
struct TypeParams
    references::Dict{String,ParamMetadata} # breaking dependency cycles
    oneofs::Dict{String,ParamMetadata}     # specializing on oneof fields, if requested
end
const EMPTY_TYPE_PARAMS = TypeParams(Dict{String,ParamMetadata}(), Dict{String,ParamMetadata}())

# Type bounds used in parametrizations -- for OneOfs we're constructing the union type, for
# the other cases we're only referring to predeclared abstract types.
function _get_oneof_type_bound(f::OneOfType, ctx::Context, type_params::TypeParams=EMPTY_TYPE_PARAMS)
    seen = Set{String}()
    union_types = String[]
    struct_name = ctx._toplevel_raw_name[]
    for o in f.fields
        type_name = jl_typename(o.type, ctx)
        get!(seen.dict, type_name) do
            if o.type isa ReferencedType
                _raw_name = o.type.name
                is_cyclic = _raw_name in keys(ctx._types_and_oneofs_requiring_type_params)
                is_self_ref = _raw_name == struct_name
                # This is legal definition:
                # struct A
                #     x::Union{Nothing,A}
                # end
                # This isn't:
                # struct A{T1<:Union{Nothing,A}}
                #     x::T1
                # end
                # So we need to use the abstract type if we're specializing on OneOf that refer
                # to struct itself.
                needs_abstract = ctx.options.parametrize_oneofs && (is_cyclic || is_self_ref)

                name_in_oneof_union = needs_abstract ?
                    abstract_type_name(_raw_name) :
                    _ref_type_or_concrete_stub_or_param(o.type, ctx, type_params)
            else
                name_in_oneof_union = type_name
            end
            push!(union_types, name_in_oneof_union)
            return nothing
        end
    end
    should_force_required = _should_force_required(string(struct_name, ".", f.name), ctx)
    if length(union_types) == 1
        type = string("OneOf{", only(union_types), '}')
    else
        type = string("OneOf{<:Union{", join(union_types, ','), "}}")
    end
    if !should_force_required
        type = string("Union{Nothing,", type, '}')
    end
    return type
end

# Parametrizing oneofs is the only way a non-cyclic definitions might need type params
function get_type_params_for_non_cyclic(t::MessageType, ctx::Context)
    i = 0
    !(ctx.options.parametrize_oneofs || t.has_oneof_field) && return EMPTY_TYPE_PARAMS
    type_params = TypeParams(EMPTY_TYPE_PARAMS.references, Dict{String,ParamMetadata}())
    for field in t.fields
        !(field isa OneOfType) && continue
        i += 1
        param_meta = ParamMetadata(
            string("T", i),
            _get_oneof_type_bound(field, ctx),
        )
        type_params.oneofs[field.name] = param_meta
    end
    return type_params
end

function get_type_params_for_cyclic(t::MessageType, ctx::Context)
    i = 0
    type_params = TypeParams(Dict{String,ParamMetadata}(), Dict{String,ParamMetadata}())
    deps = get(ctx._types_and_oneofs_requiring_type_params, t.name, Tuple{Bool,String}[]) # bool is true for oneofs

    fields_scan_position = 1 # to only scan the fields once when looking for oneofs as the deps are ordered
    for (isoneof, dep) in deps
        i += 1
        param = string("T", i)
        if isoneof
            for (offset, field) in enumerate(@view(t.fields[fields_scan_position:end]))
                if field.name == dep
                    bound = _get_oneof_type_bound(field, ctx)
                    type_param = ParamMetadata(param, bound)
                    type_params.oneofs[dep] = type_param
                    fields_scan_position += offset
                    break
                end
            end
        else
            bound = abstract_type_name(dep)
            type_param = ParamMetadata(param, bound)
            type_params.references[dep] = type_param
        end
    end
    return type_params
end

# Struct parametrization with cycles and/or specialized oneof fields
function get_type_param_string(type_params::TypeParams)
    isempty(type_params.references) && isempty(type_params.oneofs) && return ""
    io = IOBuffer()
    buf = String[]
    for p in values(type_params.references)
        push!(buf, string(p.param, "<:", p.bound))
    end
    for p in values(type_params.oneofs)
        push!(buf, string(p.param, "<:", p.bound))
    end
    sort!(buf) # Params are T1, T2, T3, ... so this is easily sorteable
    print(io, "{")
    join(io, buf, ',')
    print(io, "}")
    return String(take!(io))
end

# NOTE: In case of topologically sort-able types, parametrization due to oneof fields are handled
# in the generate_struct method, here we only care about the type params for cyclic definitions, which
# complicate things further by also parametrizing on stub types to resolve dependency cycles.
function reconstruct_parametrized_stub_type_name(t::Union{MessageType,ReferencedType}, ctx::Context, type_params::TypeParams=EMPTY_TYPE_PARAMS)
    type_name = t.name
    _types_and_oneofs_requiring_type_params = ctx._types_and_oneofs_requiring_type_params
    _remaining_cyclic_defs = ctx._remaining_cyclic_defs
    deps = get(_types_and_oneofs_requiring_type_params, type_name, nothing)
    # If there are no dependencies requiring type params, this means that the type is not cyclic
    # and doesn't have a parametrized oneof fields.
    isnothing(deps) && return _safename(type_name)
    # If the set of dependencies exists but is empty, this means that all there were mutually recursive
    # dependencies, but all corresponding stub definitions have already been generated at this point.
    # This means that we're talking about a stub type that doesn't have to be parametrized.
    isempty(deps) && return stub_type_name(type_name)

    # Otherwise, we need to generate a parametrized stub type name
    io = IOBuffer()
    print(io, stub_type_name(type_name))
    print(io, "{")
    _reconstruct_parametrized_stub_type_name(io, t.name, _types_and_oneofs_requiring_type_params, _remaining_cyclic_defs, type_params)
    print(io, "}")

    return String(take!(io))
end

function _reconstruct_parametrized_stub_type_name(io, name::String, _types_and_oneofs_requiring_type_params, _remaining_cyclic_defs, type_params=EMPTY_TYPE_PARAMS)
    @assert name in keys(_types_and_oneofs_requiring_type_params)
    deps = _types_and_oneofs_requiring_type_params[name]
    _first = true
    for (isoneof, dep) in deps
        !_first && print(io, ',')
        if dep in _remaining_cyclic_defs                            # dep not defined yet -> use type param
            print(io, type_params.references[dep].param)
        elseif dep in keys(_types_and_oneofs_requiring_type_params) # dep is cyclic -> use stubbed name and recurse
            dep_has_params = !isempty(_types_and_oneofs_requiring_type_params[dep])
            if dep_has_params
                print(io, stub_type_name(dep), "{")
                _reconstruct_parametrized_stub_type_name(io, dep, _types_and_oneofs_requiring_type_params, _remaining_cyclic_defs, type_params)
                print(io, '}')
            else
                print(io, stub_type_name(dep))
            end
        else
            print(io, "<:Union{Nothing,<:OneOf}")
        end
        _first = false
    end
end

# Since we're potentially mixing type params used to forward declare cyclic deps and type params for oneofs,
# and since all are potentially optional, we must tell the constructor what is the type of the forward declared
# type even if we get a default value like 'nothing'. And since we're specializing on OneOfs, we'll make sure
# to use the concrete type of the OneOf union by calling `typeof` on the provided value (which is always
# named the same as the field itself).
function _maybe_parametrize_constructor_to_handle_oneofs(io, t::MessageType, ctx::Context)
    if t.has_oneof_field && ctx.options.parametrize_oneofs
        i = 1
        if t.name in keys(ctx._types_and_oneofs_requiring_type_params)
            print(io, stub_type_name(t.name), "{")
            for (isoneof, name) in ctx._types_and_oneofs_requiring_type_params[t.name]
                i > 1 && print(io, ",")
                isoneof ? print(io, "typeof(", _safename(name), ")") : print(io, _safename(name))
                i += 1
            end
        else
            print(io, jl_typename(t, ctx), "{")
            for field in t.fields
                field isa OneOfType || continue
                i > 1 && print(io, ",")
                print(io, "typeof(", _safename(field.name), ")")
                i += 1
            end
        end

        print(io, "}")
    else
        print(io, jl_typename(t, ctx))
    end
end

# If T is is a type name as determined from the reference to a message type, then we need to
# use the rest of the info from the field to know if this is a repeated field and if not,
# we need to decide whether we need to make it optional or not. Usually fields are optional
# unless they are specifically asked by the user as required or marked as required field in
# proto2 syntax. Cyclical definitions are always optional.
function _maybe_union_or_vector_a_type_name(type_name::String, field::Union{GroupType,FieldType{ReferencedType}}, ctx::Context)
    struct_name = ctx._toplevel_raw_name[] # must be set by the caller!
    is_repeated = _is_repeated_field(field)

    if is_repeated
        maybe_subtype = _needs_subtyping_in_containers(field.type, ctx) ? "<:" : ""
        return string("Vector{", maybe_subtype, type_name, "}")
    end

    appears_in_cycle = field.type.name in keys(ctx._types_and_oneofs_requiring_type_params)
    is_self_referential = field.type.name == struct_name
    should_force_required = _should_force_required(string(struct_name, ".", field.name), ctx)
    optional_label = (field.label == Parsers.OPTIONAL || field.label == Parsers.DEFAULT)

    needs_union = (is_self_referential || appears_in_cycle) || (!should_force_required && optional_label)

    if needs_union && _is_message(field.type, ctx)
        type_name = string("Union{Nothing,", type_name,"}")
    end
    return type_name
end

# Type is MessageType if we got here from GroupType or ReferencedType if we got here from FieldType{ReferencedType} or a MapType
# This is where we decide where the field param would refer to a type param of the struct,
# a stubbed type name, or the actual type name.
function _ref_type_or_concrete_stub_or_param(type::Union{MessageType,ReferencedType}, ctx::Context, type_params::TypeParams)
    struct_name = ctx._toplevel_raw_name[] # must be set by the caller!
    appears_in_cycle = type.name in keys(ctx._types_and_oneofs_requiring_type_params)
    is_self_referential = type.name == struct_name

    if type.name in ctx._remaining_cyclic_defs # Cyclic reference that has not yet been defined
        # We need to specialize on the type of this field, either because the user requested
        # specialization on a OneOf member, or because the field is part of a cyclic definition
        type_name = type_params.references[type.name].param
    elseif appears_in_cycle || is_self_referential
        # Cyclic reference that has been defined already
        type_name = reconstruct_parametrized_stub_type_name(type, ctx, type_params)
    else
        # Regular field
        type_name = jl_typename(type, ctx)
    end
    return type_name
end

# The type alias pointing to the concretized stub definition, used to break out dependency cycles
function _generate_struct_alias(io, t::MessageType, ctx::Context)
    struct_name = safename(t)
    type = reconstruct_parametrized_stub_type_name(t, ctx)
    println(io, "const ", struct_name, " = ", type)
end

_decoding_val_type(t::AbstractProtoType) = ""
_decoding_val_type(t::AbstractProtoFixedType) = ":fixed"
_decoding_val_type(t::T) where {T<:Union{SInt32Type,SInt64Type}} = ":zigzag"

jl_type_decode_expr(f::FieldType{<:AbstractProtoType}, ctx::Context) = "$(jl_fieldname(f)) = PB.decode(d, $(jl_typename(f.type, ctx)))"
jl_type_decode_expr(f::FieldType{SFixed32Type}, ::Context) = "$(jl_fieldname(f)) = PB.decode(d, Int32, Val{:fixed})"
jl_type_decode_expr(f::FieldType{SFixed64Type}, ::Context) = "$(jl_fieldname(f)) = PB.decode(d, Int64, Val{:fixed})"
jl_type_decode_expr(f::FieldType{Fixed32Type}, ::Context)  = "$(jl_fieldname(f)) = PB.decode(d, UInt32, Val{:fixed})"
jl_type_decode_expr(f::FieldType{Fixed64Type}, ::Context)  = "$(jl_fieldname(f)) = PB.decode(d, UInt64, Val{:fixed})"
jl_type_decode_expr(f::FieldType{SInt32Type}, ::Context)   = "$(jl_fieldname(f)) = PB.decode(d, Int32, Val{:zigzag})"
jl_type_decode_expr(f::FieldType{SInt64Type}, ::Context)   = "$(jl_fieldname(f)) = PB.decode(d, Int64, Val{:zigzag})"
function jl_type_decode_expr(f::FieldType{MapType}, ::Context)
    K = _decoding_val_type(f.type.keytype)
    V = _decoding_val_type(f.type.valuetype)
    isempty(V) && isempty(K)  && return "PB.decode!(d, $(jl_fieldname(f)))"
    !isempty(V) && isempty(K) && return "PB.decode!(d, $(jl_fieldname(f)), Val{Tuple{Nothing,$(V)}})"
    isempty(V) && !isempty(K) && return "PB.decode!(d, $(jl_fieldname(f)), Val{Tuple{$(K),Nothing}})"
    return "PB.decode!(d, $(jl_fieldname(f)), Val{Tuple{$(K),$(V)}})"
end

function jl_type_decode_repeated_expr(f::FieldType{T}, ::Context) where {T<:Union{StringType,BytesType}}
    return "PB.decode!(d, $(jl_fieldname(f)))"
end
function jl_type_decode_repeated_expr(f::FieldType{T}, ::Context) where {T<:AbstractProtoNumericType}
    return "PB.decode!(d, wire_type, $(jl_fieldname(f)))"
end
function jl_type_decode_repeated_expr(f::FieldType{T}, ::Context) where {T<:AbstractProtoFixedType}
    return "PB.decode!(d, wire_type, $(jl_fieldname(f)), Val{:fixed})"
end
function jl_type_decode_repeated_expr(f::FieldType{T}, ::Context) where {T<:Union{SInt32Type,SInt64Type}}
    return "PB.decode!(d, wire_type, $(jl_fieldname(f)), Val{:zigzag})"
end
function jl_type_decode_repeated_expr(f::FieldType{ReferencedType}, ctx::Context)
    _is_message(f.type, ctx) && return "PB.decode!(d, $(jl_fieldname(f)))"
    return "PB.decode!(d, wire_type, $(jl_fieldname(f)))"
end
function jl_type_decode_expr(f::FieldType{ReferencedType}, ctx::Context)
    _is_message(f.type, ctx) && return "PB.decode!(d, $(jl_fieldname(f)))"
    return "$(jl_fieldname(f)) = PB.decode(d, $(jl_typename(f.type, ctx)))"
end

function field_decode_expr(io, f::FieldType, i, ctx::Context)
    if _is_repeated_field(f)
        decode_expr = jl_type_decode_repeated_expr(f, ctx)
    else
        decode_expr = jl_type_decode_expr(f, ctx)
    end
    println(io, "    " ^ 2, i == 1 ? "if " : "elseif ", "field_number == ", string(f.number))
    println(io, "    " ^ 3, decode_expr)
    return nothing
end

jl_type_oneof_decode_expr(f::FieldType, ctx::Context) = "OneOf(:$(jl_fieldname(f)), PB.decode(d, $(jl_typename(f.type, ctx))))"
jl_type_oneof_decode_expr(f::GroupType, ctx::Context) = "OneOf(:$(jl_fieldname(f)), PB.decode(d, Ref{$(jl_typename(f.type, ctx))}, Val{:group}))"
jl_type_oneof_decode_expr(f::FieldType{SFixed32Type}, ::Context) = "OneOf(:$(jl_fieldname(f)), PB.decode(d, Int32, Val{:fixed}))"
jl_type_oneof_decode_expr(f::FieldType{SFixed64Type}, ::Context) = "OneOf(:$(jl_fieldname(f)), PB.decode(d, Int64, Val{:fixed}))"
jl_type_oneof_decode_expr(f::FieldType{Fixed32Type}, ::Context)  = "OneOf(:$(jl_fieldname(f)), PB.decode(d, UInt32, Val{:fixed}))"
jl_type_oneof_decode_expr(f::FieldType{Fixed64Type}, ::Context)  = "OneOf(:$(jl_fieldname(f)), PB.decode(d, UInt64, Val{:fixed}))"
jl_type_oneof_decode_expr(f::FieldType{SInt32Type}, ::Context)   = "OneOf(:$(jl_fieldname(f)), PB.decode(d, Int32, Val{:zigzag}))"
jl_type_oneof_decode_expr(f::FieldType{SInt64Type}, ::Context)   = "OneOf(:$(jl_fieldname(f)), PB.decode(d, Int64, Val{:zigzag}))"
function jl_type_oneof_decode_expr(f::FieldType{ReferencedType}, ctx::Context)
      _is_message(f.type, ctx) && return "OneOf(:$(jl_fieldname(f)), PB.decode(d, Ref{$(jl_typename(f.type, ctx))}))"
      return "OneOf(:$(jl_fieldname(f)), PB.decode(d, $(jl_typename(f.type, ctx))))"
end
function field_decode_expr(io, field::OneOfType, i, ctx::Context)
    field_name = jl_fieldname(field)
    for (j, case) in enumerate(field.fields)
        j += i
        println(io, "    " ^ 2, j == 2 ? "if " : "elseif ", "field_number == ", string(case.number))
        println(io, "    " ^ 3, field_name, " = ", jl_type_oneof_decode_expr(case, ctx))
    end
    return nothing
end

function field_decode_expr(io, field::GroupType, i, ::Context)
    field_name = jl_fieldname(field)
    println(io, "    " ^ 2, i == 1 ? "if " : "elseif ", "field_number == ", string(field.number))
    println(io, "    " ^ 3, "PB.decode!(d, ", field_name, ", Val{:group})")
    return nothing
end

jl_fieldname_deref(f, ::Context) = _is_repeated_field(f) ? "$(jl_fieldname(f))[]" : jl_fieldname(f)
function jl_fieldname_deref(f::FieldType{ReferencedType}, ctx::Context)
    should_deref = _is_repeated_field(f) | _is_message(f.type, ctx)
    return should_deref ? "$(jl_fieldname(f))[]" : jl_fieldname(f)
end
jl_fieldname_deref(f::GroupType, ::Context) = "$(jl_fieldname(f))[]"


function generate_decode_method(io, t::MessageType, ctx::Context)
    println(io, "function PB.decode(d::PB.AbstractProtoDecoder, ::Type{<:$(safename(t))})")
    n = length(t.fields)
    has_fields = n > 0
    for field in t.fields
        println(io, "    ", jl_fieldname(field)::String, " = ", jl_init_value(field, ctx)::String)
    end
    println(io, "    while !PB.message_done(d)")
    println(io, "        field_number, wire_type = PB.decode_tag(d)")
    for (i, field) in enumerate(t.fields)
        field_decode_expr(io, field, i, ctx)
    end
    has_fields && println(io, "        else")
    println(io, "    " ^ (3 - !has_fields), "Base.skip(d, wire_type)")
    has_fields && println(io, "        end")
    println(io, "    end")
    print(io, "    return ")
    _maybe_parametrize_constructor_to_handle_oneofs(io, t, ctx)
    print(io, "(")
    for (i, field) in enumerate(t.fields)
        print(io, jl_fieldname_deref(field, ctx))
        i < n && (print(io, ", "))
    end
    println(io, ")")
    println(io, "end")
end

using Test
import ProtoBuf

@testset "ProtoBuf" begin
    include("test_lexers.jl")
    include("test_vbyte.jl")
    include("test_encode.jl")
    include("test_decode.jl")
    include("test_parser.jl")
    include("test_modules.jl")
    include("test_codegen.jl")
    include("test_protojl.jl")
end

abstract type AbstractProtoType end
abstract type AbstractProtoNumericType <: AbstractProtoType end
abstract type AbstractProtoFixedType <: AbstractProtoNumericType end
abstract type AbstractProtoFloatType <: AbstractProtoNumericType end
abstract type AbstractProtoFieldType <: AbstractProtoType end

struct DoubleType   <: AbstractProtoFloatType end
struct FloatType    <: AbstractProtoFloatType end
struct Int32Type    <: AbstractProtoNumericType end
struct Int64Type    <: AbstractProtoNumericType end
struct UInt32Type   <: AbstractProtoNumericType end
struct UInt64Type   <: AbstractProtoNumericType end
struct SInt32Type   <: AbstractProtoNumericType end
struct SInt64Type   <: AbstractProtoNumericType end
struct Fixed32Type  <: AbstractProtoFixedType end
struct Fixed64Type  <: AbstractProtoFixedType end
struct SFixed32Type <: AbstractProtoFixedType end
struct SFixed64Type <: AbstractProtoFixedType end
struct BoolType     <: AbstractProtoNumericType end
struct StringType <: AbstractProtoType end
struct BytesType  <: AbstractProtoType end
struct MapType <: AbstractProtoType
    keytype::AbstractProtoType
    valuetype::AbstractProtoType
end

@enum(TypeOfReference, UNKNOWN, MESSAGE, ENUM, SERVICE, RPC)
# NOTE: mutable so we can figure out the actual type being referenced later
#       when the rest of the file (and other, imported files) are parsed.
mutable struct ReferencedType <: AbstractProtoType
    name::String
    package_namespace::Union{Nothing,String}
    package_import_path::Union{Nothing,String}
    reference_type::TypeOfReference
    resolve_from_innermost::Bool
    resolved::Bool
end

function ReferencedType(name::String)
    if startswith(name, '.')
        return ReferencedType(name[2:end], nothing, nothing, UNKNOWN, false, false)
    else
        return ReferencedType(name, nothing, nothing, UNKNOWN, true, false)
    end
end
struct RPCType <: AbstractProtoType
    name::String
    request_stream::Bool
    request_type::ReferencedType
    response_stream::Bool
    response_type::ReferencedType
    options::Dict{String,Union{String,Dict{String}}}
end

function lowercase_first(s)
    b = IOBuffer()
    i = Iterators.Stateful(s)
    print(b, lowercase(popfirst!(i)))
    for c in i
        print(b, c)
    end
    return String(take!(b))
end

_dot_join(prefix, s) = isempty(prefix) ? s : string(prefix, '.', s)

@enum(FieldLabel, DEFAULT, REQUIRED, OPTIONAL, REPEATED)

# We're reusing the same FieldType for both Message and OneOf fields
# OneOf fields don't use the label field
struct FieldType{T<:AbstractProtoType} <: AbstractProtoFieldType
    label::FieldLabel
    type::AbstractProtoType # T
    name::String
    number::Int
    options::Dict{String,Union{String,Dict{String}}}
end

struct OneOfType <: AbstractProtoFieldType
    name::String
    fields::Vector{AbstractProtoFieldType}
    options::Dict{String,Union{String,Dict{String}}}
end

struct ExtendType <: AbstractProtoFieldType
    type::ReferencedType
    field_extensions::Vector{AbstractProtoFieldType}
end

struct MessageType <: AbstractProtoType
    name::String
    fields::Vector{AbstractProtoFieldType}
    options::Dict{String,Union{String,Dict{String}}}
    reserved_nums::Vector{Union{Int,UnitRange{Int}}}
    reserved_names::Vector{String}
    extensions::Vector{Union{Int,UnitRange{Int}}}
    extends::Vector{ExtendType}
    has_oneof_field::Bool
    is_self_referential::Base.RefValue{Bool}
end

struct GroupType <: AbstractProtoFieldType
    label::FieldLabel
    name::String
    field_name::String
    type::MessageType
    number::Int
end

struct ServiceType <: AbstractProtoType
    name::String
    rpcs::Vector{RPCType}
    options::Dict{String,Union{String,Dict{String}}}
end

struct EnumType <: AbstractProtoType
    name::String
    element_names::Vector{Symbol}
    element_values::Vector{Int}
    options::Dict{String,Union{String,Dict{String}}}
    reserved_nums::Vector{Union{Int,UnitRange{Int}}}
    reserved_names::Vector{String}
    field_options::Dict{String,Union{String,Dict{String}}}
end

function unsafe_name(ps)
    pk = peekkind(ps)
    if Tokens.isident(pk) || Tokens.is_reserved_word(pk)
        return val(readtoken(ps))
    else
        ps.errored = true
        error("Invalid name token $(peektoken(ps))")
    end
end

function parse_label(ps)
    return accept(ps, Tokens.REPEATED) ? REPEATED :
           accept(ps, Tokens.OPTIONAL) ? OPTIONAL :
           accept(ps, Tokens.REQUIRED) ? REQUIRED :
                                         DEFAULT
end
# Called in parse_oneof_type, parse_message_type and parse_extend_type
# after we handled GROUP, EXTEND, OPTION, RESERVED and EXTENSIONS
function parse_field(ps::ParserState, labelable::Bool=true)
    label = labelable ? parse_label(ps) : Parsers.DEFAULT
    type = parse_type(ps)
    labelable = labelable & !isa(type, MapType)
    name = unsafe_name(ps)
    labelable && ps.is_proto3 && label == REQUIRED && (ps.errored = true) && error("Field `$(name)` has a `required` label which is not supported in proto3 syntax.")
    labelable && !ps.is_proto3 && label == DEFAULT && (ps.errored = true) && error("Field `$(name)` is missing a label (`required`, `optional` or `repeated`), this is not supported in proto2 syntax.")
    expectnext(ps, Tokens.EQ)
    number = parse(Int, val(expectnext(ps, kind -> (kind == Tokens.DEC_INT_LIT || kind == Tokens.HEX_INT_LIT))))
    if !(1 <= number <= MAX_FIELD_NUMBER) || (19000 <= number <= 19999)
        ps.errored = true
        error("Invalid field number $number for field $name")
    end

    options = Dict{String,Union{String,Dict{String}}}()
    if label == REPEATED && type isa AbstractProtoNumericType
        options["packed"] = "true"
    end
    accept(ps, Tokens.LBRACKET) && parse_field_options!(ps, options)
    expectnext(ps, Tokens.SEMICOLON)
    return FieldType{typeof(type)}(label, type, name, number, options)
end

function peek_group(ps)
    nk, nnk = dpeekkind(ps)
    return (nk in (Tokens.OPTIONAL, Tokens.REQUIRED, Tokens.REPEATED) && nnk == Tokens.GROUP) ||
           (nk == Tokens.GROUP && (Tokens.isident(nnk) || Tokens.is_reserved_word(nnk)))
end

# Can appear in parse_message_type, parse_oneof_type and parse_extend_type
function parse_group(ps, definitions=Dict{String,Union{MessageType, EnumType, ServiceType}}(), name_prefix="", labelable::Bool=true)
    ps.is_proto3 && (ps.errored = true) && error("`group` fields are not supported in proto3 syntax.")
    label = parse_label(ps)
    expectnext(ps, Tokens.GROUP)
    name = unsafe_name(ps)
    labelable && !ps.is_proto3 && label == DEFAULT && (ps.errored = true) && error("Group field `$(name)` is missing a label (`required`, `optional` or `repeated`), this is not supported in proto2 syntax.")
    !isuppercase(first(name)) && error("Group fields must start with a capital letter, got $name")
    expectnext(ps, Tokens.EQ)
    number = parse(Int, val(expectnext(ps, Tokens.DEC_INT_LIT)))
    message = _parse_message_body(ps, name, definitions, name_prefix)
    return GroupType(label, message.name, lowercase_first(name), message, number)
end

# We consumed RESERVED
function _parse_reserved_statement!(ps::ParserState, nums, names)
    while true
        if accept(ps, Tokens.DEC_INT_LIT)
            num = parse(Int, val(token(ps)))
            if accept(ps, Tokens.TO)
                if peekkind(ps) == Tokens.DEC_INT_LIT
                    num_end = parse(Int, val(readtoken(ps)))
                elseif accept(ps, Tokens.MAX)
                    num_end = MAX_FIELD_NUMBER
                else
                    ps.errored = true
                    error("Unexpected token in `reserved` statement: $(peektoken(ps))")
                end
                push!(nums, num:num_end)
            else
                push!(nums, num)
            end
        elseif accept(ps, Tokens.STRING_LIT)
            push!(names, val(token(ps))[2:end-1])
        else
            ps.errored = true
            error("Unexpected token in `reserved` statement: $(peektoken(ps))")
        end
        accept(ps, Tokens.COMMA) || break
    end
    expectnext(ps, Tokens.SEMICOLON)
end

# We consumed EXTENSIONS
function _parse_extensions_statement!(ps::ParserState, extensions)
    num = parse(Int, val(expectnext(ps, Tokens.DEC_INT_LIT)))
    if accept(ps, Tokens.TO)
        if peekkind(ps) == Tokens.DEC_INT_LIT
            num_end = parse(Int, val(readtoken(ps)))
        elseif accept(ps, Tokens.MAX)
            num_end = MAX_FIELD_NUMBER
        else
            ps.errored = true
            error("Unexpected token in `extensions` statement: $(peektoken(ps))")
        end
        push!(extensions, num:num_end)
    else
        push!(extensions, num)
    end
    expectnext(ps, Tokens.SEMICOLON)
end

# We consumed MAP
function parse_map_type(ps::ParserState)
    expectnext(ps, Tokens.LESS)
    keytype = parse_type(ps)
    expectnext(ps, Tokens.COMMA)
    valuetype = parse_type(ps)
    expectnext(ps, Tokens.GREATER)
    return MapType(keytype, valuetype)
end

# We consumed ONEOF
function parse_oneof_type(ps::ParserState, definitions, name_prefix="")
    name = unsafe_name(ps)

    fields = AbstractProtoFieldType[]
    options = Dict{String,Union{String,Dict{String}}}()

    expectnext(ps, Tokens.LBRACE)
    while !accept(ps, Tokens.RBRACE)
        nk, nnk = dpeekkind(ps)
        if accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        elseif (nk == Tokens.GROUP && (Tokens.isident(nnk) || Tokens.is_reserved_word(nnk)))
            group = parse_group(ps, definitions, _dot_join(name_prefix, name), false)
            push!(fields, group)
            definitions[group.type.name] = group.type
        else
            push!(fields, parse_field(ps, false))
        end
    end
    accept(ps, Tokens.SEMICOLON)
    return OneOfType(name, fields, options)
end

# We consumed ENUM
function parse_enum_type(ps::ParserState, name_prefix="")
    name = unsafe_name(ps)

    options = Dict{String,Union{String,Dict{String}}}()
    reserved_nums = Vector{Union{Int,UnitRange{Int}}}()
    reserved_names = Vector{String}()
    field_options = Dict{String,Union{String,Dict{String}}}()
    element_names = Symbol[]
    element_values = Int[]

    expectnext(ps, Tokens.LBRACE)
    while true
        if accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.IDENTIFIER)
            element_name = val(token(ps))
            push!(element_names, Symbol(element_name))
            expectnext(ps, Tokens.EQ)
            push!(element_values, parse_integer_value(ps))
            if accept(ps, Tokens.LBRACKET)
                parse_field_options!(ps, get!(field_options, element_name, Dict{String,Union{String,Dict{String}}}()))
            end
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.RESERVED)
            _parse_reserved_statement!(ps, reserved_nums, reserved_names)
        else
            expectnext(ps, Tokens.RBRACE)
            break
        end
    end
    accept(ps, Tokens.SEMICOLON)
    if !parse(Bool, get(options, "allow_alias", "false"))
        !allunique(element_values) && (ps.errored = true) && error("Duplicates in enumeration $name. You can allow multiple keys mapping to the same number with `option allow_alias = true;`")
    end
    if ps.is_proto3 && first(element_values) != 0
        ps.errored = true
        error("In proto3, enums' first element must map to zero, $name has `$(first(element_names)) = $(first(element_values))` as first element.")
    end
    # TODO: validate field_numbers
    return EnumType(_dot_join(name_prefix, name), element_names, element_values, options, reserved_nums, reserved_names, field_options)
end

# We consumed EXTEND
function parse_extend_type(ps::ParserState, definitions, name_prefix="")
    type = parse_type(ps, definitions)
    field_extensions = AbstractProtoFieldType[]

    expectnext(ps, Tokens.LBRACE)
    while !accept(ps, Tokens.RBRACE)
        if peek_group(ps)
            group = parse_group(ps, definitions, name_prefix)
            definitions[group.name] = group.type
        else
            push!(field_extensions, parse_field(ps))
        end
    end
    return ExtendType(type, field_extensions)
end

# We consumed MESSAGE
function parse_message_type(ps::ParserState, definitions=Dict{String,Union{MessageType, EnumType, ServiceType}}(), name_prefix="")
    name = unsafe_name(ps)
    return _parse_message_body(ps, name, definitions, name_prefix)
end

function _parse_message_body(ps::ParserState, name, definitions, name_prefix)
    fields = []
    options = Dict{String,Union{String,Dict{String}}}()
    reserved_nums = Vector{Union{Int,UnitRange{Int}}}()
    reserved_names = Vector{String}()
    extensions = Vector{Union{Int,UnitRange{Int}}}()
    extends = Vector{ExtendType}()
    has_oneof_field = false
    is_self_referential = Ref{Bool}(false) # set during topological sort

    name = _dot_join(name_prefix, name)
    expectnext(ps, Tokens.LBRACE)
    while true
        if accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.RESERVED)
            _parse_reserved_statement!(ps, reserved_nums, reserved_names)
        elseif accept(ps, Tokens.EXTENSIONS)
            _parse_extensions_statement!(ps, extensions)
        elseif accept(ps, Tokens.MESSAGE)
            message = parse_message_type(ps, definitions, name)
            definitions[message.name] = message
        elseif accept(ps, Tokens.ENUM)
            enum = parse_enum_type(ps, name)
            definitions[enum.name] = enum
            # ./test/test_protos/protobuf/echo.proto has a trailing SEMICOLON after nested enum
            accept(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.ONEOF)
            push!(fields, parse_oneof_type(ps, definitions, name))
            has_oneof_field = true
        elseif accept(ps, Tokens.EXTEND)
            push!(extends, parse_extend_type(ps, definitions, name))
        elseif peek_group(ps)
            group = parse_group(ps, definitions, name)
            push!(fields, group)
            definitions[group.type.name] = group.type
        elseif accept(ps, Tokens.RBRACE)
            accept(ps, Tokens.SEMICOLON)
            break
        else
            push!(fields, parse_field(ps))
        end
    end
    # TODO: validate field_numbers vs reserved and extensions
    return MessageType(name, fields, options, reserved_nums, reserved_names, extensions, extends, has_oneof_field, is_self_referential)
end

# We consumed RPC
function parse_rpc_type(ps::ParserState)
    name = unsafe_name(ps)
    options = Dict{String,Union{String,Dict{String}}}()

    expectnext(ps, Tokens.LPAREN)
    request_stream = accept(ps, Tokens.STREAM)
    request_type = parse_type(ps)
    expectnext(ps, Tokens.RPAREN)
    expectnext(ps, Tokens.RETURNS)
    expectnext(ps, Tokens.LPAREN)
    response_stream = accept(ps, Tokens.STREAM)
    response_type = parse_type(ps)
    expectnext(ps, Tokens.RPAREN)
    if accept(ps, Tokens.LBRACE)
        while accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        end
        expectnext(ps, Tokens.RBRACE)
        accept(ps, Tokens.SEMICOLON)
    else
        # ./test/test_protos/protobuf/factory_test1.proto end an RPC without a SEMICOLON
        expectnext(ps, Tokens.SEMICOLON)
    end
    return RPCType(name, request_stream, request_type, response_stream, response_type, options)
end

# We consumed SERVICE
function parse_service_type(ps::ParserState)
    name = unsafe_name(ps)
    rpcs = RPCType[]
    options = Dict{String,Union{String,Dict{String}}}()

    expectnext(ps, Tokens.LBRACE)
    while !accept(ps, Tokens.RBRACE)
        if accept(ps, Tokens.OPTION)
            _parse_option!(ps, options)
            expectnext(ps, Tokens.SEMICOLON)
        elseif accept(ps, Tokens.RPC)
            push!(rpcs, parse_rpc_type(ps))
        else
            ps.errored = true
            error("Unexpected token while parsing service definition: $(peektoken(ps))")
        end
    end

    return ServiceType(name, rpcs, options)
end

function parse_type(ps::ParserState)
    nk = peekkind(ps)
    if nk == Tokens.ENUM
        readtoken(ps)
        return parse_enum_type(ps)
    elseif nk == Tokens.SERVICE
        readtoken(ps)
        return parse_service_type(ps)
    elseif nk == Tokens.MAP
        readtoken(ps)
        return parse_map_type(ps)
    elseif nk == Tokens.RPC
        readtoken(ps)
        return parse_rpc_type(ps)
    elseif nk == Tokens.IDENTIFIER
        return ReferencedType(val(readtoken(ps)))
    elseif nk == Tokens.DOUBLE   readtoken(ps); return DoubleType()
    elseif nk == Tokens.FLOAT    readtoken(ps); return FloatType()
    elseif nk == Tokens.INT32    readtoken(ps); return Int32Type()
    elseif nk == Tokens.INT64    readtoken(ps); return Int64Type()
    elseif nk == Tokens.UINT32   readtoken(ps); return UInt32Type()
    elseif nk == Tokens.UINT64   readtoken(ps); return UInt64Type()
    elseif nk == Tokens.SINT32   readtoken(ps); return SInt32Type()
    elseif nk == Tokens.SINT64   readtoken(ps); return SInt64Type()
    elseif nk == Tokens.FIXED32  readtoken(ps); return Fixed32Type()
    elseif nk == Tokens.FIXED64  readtoken(ps); return Fixed64Type()
    elseif nk == Tokens.SFIXED32 readtoken(ps); return SFixed32Type()
    elseif nk == Tokens.SFIXED64 readtoken(ps); return SFixed64Type()
    elseif nk == Tokens.BOOL     readtoken(ps); return BoolType()
    elseif nk == Tokens.STRING   readtoken(ps); return StringType()
    elseif nk == Tokens.BYTES    readtoken(ps); return BytesType()
    else
        ps.errored = true
        error("Unsupported type token $(peektoken(ps)) ($(nk))")
    end
end

function parse_type(ps::ParserState, definitions::Dict{String,Union{MessageType, EnumType, ServiceType}})
    nk = peekkind(ps)
    if nk == Tokens.MESSAGE
        readtoken(ps)
        return parse_message_type(ps, definitions)
    elseif nk == Tokens.ONEOF
        readtoken(ps)
        return parse_oneof_type(ps, definitions)
    elseif nk == Tokens.EXTEND
        readtoken(ps)
        return parse_extend_type(ps, definitions)
    else
        return parse_type(ps)
    end
end

# # https://github.com/golang/protobuf/issues/992#issuecomment-558718772

if Sys.iswindows()
    posixpath(path::String) = replace(path, r"[/\\]+" => "/")
else
    posixpath(path::String) = replace(path, r"/+" => "/")
end

proto_module_file_name(path::AbstractString) = string(proto_module_name(path), ".jl")
proto_module_name(path::AbstractString) = basename(path)
proto_script_name(path::AbstractString) = string(replace(basename(path), ".proto" => ""), "_pb.jl")
proto_script_path(path::AbstractString) = posixpath(joinpath(dirname(path), proto_script_name(path)))

is_namespaced(p::ProtoFile) = !isempty(p.preamble.namespace)
namespace(p::ProtoFile) = p.preamble.namespace
proto_module_file_name(p::ProtoFile) = proto_module_file_name(p.filepath)
proto_module_name(p::ProtoFile) = proto_module_name(p.filepath)
proto_script_name(p::ProtoFile) = proto_script_name(p.filepath)
proto_script_path(p::ProtoFile) = proto_script_path(p.filepath)
import_paths(p::ProtoFile) = (i.path for i in p.preamble.imports)

function namespaced_top_include(p::ProtoFile)
    if is_namespaced(p)
        top = first(namespace(p))
        return posixpath(joinpath(top, proto_module_file_name(top)))
    else
        return proto_script_name(p)
    end
end
namespaced_top_import(p::ProtoFile) = string('.', proto_package_name(p))

is_namespaced(p::ResolvedProtoFile) = is_namespaced(p.proto_file)
namespace(p::ResolvedProtoFile) = namespace(p.proto_file)
proto_module_file_name(p::ResolvedProtoFile) = proto_module_file_name(p.proto_file)
proto_module_name(p::ResolvedProtoFile) = proto_module_name(p.proto_file)
proto_script_name(p::ResolvedProtoFile) = proto_script_name(p.proto_file)
import_paths(p::ResolvedProtoFile) = import_paths(p.proto_file)
namespaced_top_include(p::ResolvedProtoFile) = namespaced_top_include(p.proto_file)
namespaced_top_import(p::ResolvedProtoFile) = namespaced_top_import(p.proto_file)
proto_script_path(p::ResolvedProtoFile) = proto_script_path(p.proto_file)

proto_package_name(p) = first(namespace(p))
rel_import_path(file, root_path) = posixpath(relpath(joinpath(root_path, "..", namespaced_top_include(file)), joinpath(root_path)))

struct ProtoModule
    name::String
    namespace::Vector{String}
    proto_files::Vector{ResolvedProtoFile}
    submodules::Dict{Vector{String},ProtoModule}
    # Dependencies on submodules within the same package, a vector of "namespaces".
    # We are always importing the toplevel package and then using fully qualified names
    # to refer to the imported definitions. But we need all the internal namespaces to
    # topologically sort all internal submodules in order to generate them in correctly.
    internal_imports::Set{Vector{String}}
    # Packages to import, including the leading dots.
    external_imports::Set{String}
    nonpkg_imports::Set{String}
end
namespace(m::ProtoModule) = m.namespace
empty_module(name::AbstractString, namespace_vec) = ProtoModule(name, namespace_vec, [], Dict(),  Set(), Set(), Set())

struct Namespaces
    non_namespaced_protos::Vector{ResolvedProtoFile}
    packages::Dict{String,ProtoModule}
end

function Namespaces(files_in_order::Vector{ResolvedProtoFile}, root_path::String, proto_files::Dict)
    t = Namespaces([], Dict())
    for file in files_in_order
        if !is_namespaced(file)
            push!(t.non_namespaced_protos, file)
        else
            top_namespace = first(namespace(file))
            p = get!(()->empty_module(top_namespace, [top_namespace]), t.packages, top_namespace)
            _add_file_to_package!(p, file, proto_files, root_path)
        end
    end
    return t
end

function _add_file_to_package!(root::ProtoModule, file::ResolvedProtoFile, proto_files::Dict, root_path::String)
    node = root
    depth = 0
    for name in namespace(file)
        depth += 1
        name == node.name && continue
        _ns = namespace(file)[1:depth]
        node = get!(()->empty_module(name, _ns), node.submodules, _ns)
    end
    for ipath in import_paths(file)
        imported_file = proto_files[ipath]
        if !is_namespaced(imported_file)
            # We always wrap the non-namespaced imports into modules internally
            # Sometimes they are forced to be namespaced with `always_use_modules`
            # but it is the responsibility of the root module to make sure there
            # is a importable module in to topmost scope
            depth != 1 && push!(node.external_imports, string("." ^ depth, replace(proto_script_name(imported_file), ".jl" => "")))
            push!(root.nonpkg_imports, replace(proto_script_name(imported_file), ".jl" => ""))
        else
            file_pkg = proto_package_name(imported_file)
            if namespace(file) == namespace(imported_file)
                continue # no need to import from the same module of the same package
            elseif file_pkg == root.name # same package, different submodule
                push!(node.internal_imports, namespace(imported_file))
            else
                depth != 1 && push!(node.external_imports, string("." ^ depth, proto_package_name(imported_file)))
                push!(root.external_imports, rel_import_path(imported_file, root_path))
            end
        end
    end
    push!(node.proto_files, file)
    return nothing
end

_include_stmt_format(path::String) = repr(posixpath(path))

function generate_module_file(io::IO, m::ProtoModule, output_directory::AbstractString, parsed_files::Dict, options::Options, depth::Int)
    println(io, "module $(m.name)")
    println(io)
    has_deps = !isempty(m.internal_imports) || !isempty(m.external_imports) || !isempty(m.nonpkg_imports)
    if depth == 1
        # This is where we include external packages so they are available downstream
        for external_import in m.external_imports
            println(io, "include(", _include_stmt_format(external_import), ')')
        end
        # This is where we include external dependencies that may not be packages.
        # We wrap them in a module to make sure that multiple downstream dependencies
        # can import them safely.
        for nonpkg_import in m.nonpkg_imports
            !options.always_use_modules && print(io, "module $(nonpkg_import)\n    ")
            println(io, "include(", _include_stmt_format(joinpath("..", string(nonpkg_import, ".jl"))), ')')
            !options.always_use_modules && println(io, "end")
        end
    else # depth > 1
        # We're not a top package module, we can import external dependencies
        # from the top package module.
        for external_import in m.external_imports
            println(io, "import ", external_import)
        end
    end

    # We require all files and their parent modules to be inserted in topologically
    # sorted order so we can import the generated Julia code without undefined references.
    # We can't simply topsort files by their imports because this doesn't guarantee that some
    # files within a module (e.g. small files that don't import anything by themselves)
    # would respect the required ordering with respect to modules.
    # To solve this, we topsort the module imports on each module/namespace level.
    if length(m.submodules) > 1
        submodule_namespaces, _ = _topological_sort(m.submodules)
    else
        submodule_namespaces = collect(keys((m.submodules)))
    end

    # This is where we import internal dependencies. We only need to import the toplevel package
    # and then use fully qualified names for the imported definitions.
    if !isempty(m.internal_imports)
        print(io, "import ", string("." ^ length(namespace(m)), first(namespace(m))))
        # We can't import the toplevel module to a leaf module if their names collide
        # we also need to tweak the `package_namespace` field of each imported ReferencedType
        if first(namespace(m)) == last(namespace(m))
            println(io,  " as var\"#", first(namespace(m)), '"')
        else
            println(io)
        end
    end
    has_deps && println(io)
    # Load in imported proto files that are defined in this package (the files ending with `_pb.jl`)
    # In case there is a dependency of some of these files on a submodule, we include that submodule
    # first.
    seen = Set{String}()
    for file in m.proto_files
        for i in import_paths(file)
            imported_file = parsed_files[i]
            if length(namespace(file)) == length(namespace(imported_file)) - 1 && _startswith(namespace(file), namespace(imported_file))
                submodule_name = last(namespace(imported_file))
                get!(seen.dict, submodule_name) do
                    println(io, "include(", _include_stmt_format(joinpath(submodule_name, string(submodule_name, ".jl"))), ")")
                end
            end
        end
        println(io, "include(", _include_stmt_format(proto_script_name(file)), ")")
    end
    # Load in submodules nested in this namespace (the modules ending with `PB`),
    # that is, if we didn't include them above.
    for submodule_namespace in submodule_namespaces
        submodule = m.submodules[submodule_namespace]
        get!(seen.dict, submodule.name) do
            println(io, "include(", _include_stmt_format(joinpath(submodule.name, string(submodule.name, ".jl"))), ")")
        end
    end
    println(io)
    println(io, "end # module $(m.name)")
end

function generate_package(node::ProtoModule, output_directory::AbstractString, parsed_files::Dict, options::Options, depth=1)
    path = joinpath(output_directory, node.name, "")
    !isdir(path) && mkdir(path)
    open(joinpath(path, string(node.name, ".jl")), "w", lock=false) do io
        generate_module_file(io, node, output_directory, parsed_files, options, depth)
    end
    for file in node.proto_files
        dst_path = joinpath(path, proto_script_name(file))
        CodeGenerators.translate(dst_path, file, parsed_files, options)
    end
    for submodule in values(node.submodules)
        generate_package(submodule, path, parsed_files, options, depth+1)
    end
    return nothing
end

function validate_search_directories!(search_directories::Vector{String}, include_vendored_wellknown_types::Bool)
    include_vendored_wellknown_types && push!(search_directories, VENDORED_WELLKNOWN_TYPES_PARENT_PATH[])
    unique!(map!(x->posixpath(joinpath(abspath(x), "")), search_directories, search_directories))
    bad_dirs = filter(!isdir, search_directories)
    !isempty(bad_dirs) && error("`search_directories` $bad_dirs don't exist")
    return nothing
end

function validate_proto_file_paths!(relative_paths::Vector{<:AbstractString}, search_directories)
    isempty(relative_paths) && error("At least one relative path must be provided, received none.")
    unique!(map!(normpath, relative_paths, relative_paths))
    full_paths = copy(relative_paths)
    proto_files_not_within_reach = String[]
    abspaths = String[]
    for (i, proto_file_path) in enumerate(relative_paths)
        if startswith(proto_file_path, '/')
            push!(abspaths, proto_file_path)
            continue
        end
        found = false
        for search_directory in search_directories
            found && continue
            full_path = posixpath(joinpath(search_directory, proto_file_path))
            if isfile(joinpath(search_directory, proto_file_path))
                found = true
                full_paths[i] = full_path
            end
        end
        !found && push!(proto_files_not_within_reach, proto_file_path)
    end
    !isempty(proto_files_not_within_reach) && error("Could not find following proto files: $proto_files_not_within_reach within $search_directories")
    !isempty(abspaths) && error("Paths to proto files must be relative to search_directories; got following absolute paths: $abspaths")
    return full_paths
end

function resolve_imports!(imported_paths::Set{String}, parsed_files, search_directories)
    missing_imports = String[]
    while !isempty(imported_paths)
        found = false
        path = pop!(imported_paths)
        path in keys(parsed_files) && continue
        for dir in search_directories
            found && continue
            full_path = joinpath(dir, path)
            if isfile(full_path)
                q = Parsers.parse_proto_file(full_path)
                parsed_files[path] = ResolvedProtoFile(path, q)
                union!(imported_paths, import_paths(q))
                found = true
            end
        end
        !found && push!(missing_imports, path)
    end
    !isempty(missing_imports) && error("Could not find following imports: $missing_imports within $search_directories")
    return nothing
end

using JET
using Test

onfail(::Function, ::Test.Pass) = nothing
onfail(f::Function, ::Test.Fail) = f()

"""
    JETFrameFingerprint(jet_report_type, module_name, method_name, jet_signature)
    JETFrameFingerprint(frame, jet_report_type, virtual_module_name_dot)

To filter out error reports generated by JET, we need a way to refer their contents.
Each error report contains virtualized stack trace leading to the error, each
element of the stack is a frame containing information about a `MethodInstance`, but
since JET analyzes the code in virtual modules, it is not straightforward to map these
`MethodInstances` to the types in the original module. The virtual modules are not persistent
across JET runs, which makes making references to the frames difficult.

To overcome this issue we summarize each frame by 4 values:
* `jet_report_type` -- the type of the corresponding error report
* `module_name` -- name of the module of the frames' captured `MethodInstance`
* `method_name` -- name of the method in the frames' captured `MethodInstance`
* `jet_signature` -- string representation of the frames' `JET.Signature` with references
to the virtual module removed.

You can generate all the `JETFrameFingerprint`s for current error reports using
`get_reports_filtered` with `verbose=true`.
"""
struct JETFrameFingerprint
    jet_report_type
    module_name::Symbol
    method_name::Symbol
    jet_signature::String
end

function _singnature_string(linfo::Core.MethodInstance, virtual_module_name_dot::String)
    io = IOBuffer()
    m = linfo.def
    if m isa Module
        Base.show_mi(io, linfo, #=from_stackframe=#true)
    else
        Base.StackTraces.show_spec_sig(IOContext(io, :backtrace=>true, :limit=>true), m, linfo.specTypes)
    end
    out = String(take!(io))
    return replace(out, virtual_module_name_dot => "")
end

function JETFrameFingerprint(
    frame::JET.VirtualFrame,
    jet_report_type,
    virtual_module_name_dot::String
)
    @nospecialize
    module_name = Symbol(replace(string(frame.linfo.def.module), virtual_module_name_dot => ""))
    method_name = frame.linfo.def.name
    # For UndefKeywordErrors, the code gets lowered in a way that `frame.linfo.def.name` is
    # `Type##kw`, one way to get the name of the relevant method is to look it up
    # from the call parameters.
    if method_name == Symbol("Type##kw")
        method_name = Symbol(split(string(frame.linfo.specTypes.types[end].parameters[1]), '.')[end])
    end

    # NOTE(tomasd): We extract signature information from frame.linfo.specTypes.
    # We create a string representation of that signature and we remove the references to the virtual module
    # in which the types and methods were defined. This makes this signature consistent
    # across JET runs.
    signature_string = _singnature_string(frame.linfo, virtual_module_name_dot)
    return JETFrameFingerprint(jet_report_type, module_name, method_name, signature_string)
end

# NOTE(tomasd): adapted from https://github.com/aviatesk/JET.jl/blob/v0.5.14/src/JET.jl#L629
"""
    get_reports_filtered(result::JET.JETToplevelResult; ignored_modules, jet_frames_to_skip)

Given a JET error analysis result (i.e. the output of `JET.report_package`), return those reports
that do not come from modules specified in `ignored_modules`, or match `jet_frames_to_skip`.

The modules and signatures to skip should be strings and could be copied from the anaysis results.
"""
function get_reports_filtered(
    result::JET.JETToplevelResult;
    jet_frames_to_skip = (),
    verbose = false,
)
    check_call_stack = !isempty(jet_frames_to_skip)
    # Handle API change in JET 0.11+: actual2virtual is now nothing instead of a Pair
    virtual_module_name_dot = if isnothing(result.res.actual2virtual)
        ""  # JET 0.11+: no virtual module prefix to strip
    else
        string(result.res.actual2virtual.second, '.')  # JET 0.9-0.10
    end
    reports = JET.get_reports(result)

    return filter!(reports) do report
        verbose && println(report)
        if check_call_stack || verbose
            for (depth, frame) in enumerate(report.vst)
                sig = JETFrameFingerprint(
                    frame, typeof(report), virtual_module_name_dot
                )
                if verbose
                    print("    ")
                    @show depth, sig
                end
                sig in jet_frames_to_skip && return false
            end
        end
        return true
    end
end

"""
    jet_test_package(package; ignored_modules = nothing, jet_frames_to_skip = ())

Run `JET.report_package` on `package` and test that there are no error reports
other than those matched by modules or frames provided through kwargs.

See [JETFrameFingerprint](@ref) and [get_reports_filtered](@ref) for more information.
"""
function jet_test_package(package; ignored_modules = nothing, jet_frames_to_skip = (), mode = :typo)
    result = JET.report_package(package; ignored_modules, toplevel_logger=nothing, mode)
    reports = get_reports_filtered(result; jet_frames_to_skip)
    onfail(@test(isempty(reports))) do
        # Handle API change in JET 0.11+
        if isnothing(result.res.actual2virtual)
            # JET 0.11+: simplified API, print result directly
            JET.print_reports(stdout, result)
        else
            # JET 0.9-0.10: use PostProcessor
            JET.print_reports(
                stdout,
                reports,
@static if pkgversion(JET) < v"0.10.7"
                JET.gen_postprocess(result.res.actual2virtual)
else
                JET.PostProcessor(result.res.actual2virtual)
end
            )
        end
        println()
        println("Remaining error reports and their `JETFrameFingerprint`s:")
        get_reports_filtered(result; jet_frames_to_skip, verbose=true)
        return
    end
    return
end

"""
    jet_test_file(file_path; ignored_modules = nothing, jet_frames_to_skip = ())

Run `JET.report_file` at `file_path` and test that there are no error reports
other than those matched by modules or frames provided through kwargs.

See [JETFrameFingerprint](@ref) and [get_reports_filtered](@ref) for more information.
"""
function jet_test_file(file_path; ignored_modules = nothing, jet_frames_to_skip = (), mode = :basic)
    result = JET.report_file(file_path; ignored_modules, toplevel_logger=nothing, mode)
    reports = get_reports_filtered(result; jet_frames_to_skip)
    onfail(@test(isempty(reports))) do
        # Handle API change in JET 0.11+
        if isnothing(result.res.actual2virtual)
            # JET 0.11+: simplified API, print result directly
            JET.print_reports(stdout, result)
        else
            # JET 0.9-0.10: use PostProcessor
            JET.print_reports(
                stdout,
                reports,
@static if pkgversion(JET) < v"0.10.7"
                JET.gen_postprocess(result.res.actual2virtual)
else
                JET.PostProcessor(result.res.actual2virtual)
end
            )
        end
        println()
        println("Remaining error reports and their `JETFrameFingerprint`s:")
        get_reports_filtered(result; jet_frames_to_skip, verbose=true)
        return
    end
    return
end

module Codecs

using BufferedStreams: BufferedOutputStream, BufferedInputStream

@enum(WireType::UInt32, VARINT=0, FIXED64=1, LENGTH_DELIMITED=2, START_GROUP=3, END_GROUP=4, FIXED32=5)

abstract type AbstractProtoDecoder end
abstract type AbstractProtoEncoder end
struct ProtoDecoder{I<:IO,F<:Function} <: AbstractProtoDecoder
    io::I
    message_done::F
end
message_done(d::ProtoDecoder) = d.message_done(d.io)
ProtoDecoder(io::IO) = ProtoDecoder(io, eof)

struct LengthDelimitedProtoDecoder{I<:IO} <: AbstractProtoDecoder
    io::I
    endpos::Int
end
message_done(d::LengthDelimitedProtoDecoder) = d.endpos == position(d.io)

struct GroupProtoDecoder{I<:IO} <: AbstractProtoDecoder
    io::I
end
function message_done(d::GroupProtoDecoder)
    done = peek(d.io) == UInt8(END_GROUP)
    done && skip(d.io, 1)
    return done
end

struct ProtoEncoder{I<:IO} <: AbstractProtoEncoder
    io::I
end

zigzag_encode(x::T) where {T <: Integer} = xor(x << 1, x >> (8 * sizeof(T) - 1))
zigzag_decode(x::T) where {T <: Integer} = xor(x >> 1, -(x & T(1)))

mutable struct BufferedVector{T}
    elements::Vector{T}
    occupied::Int
end
BufferedVector{T}() where {T} = BufferedVector(T[], 0)
BufferedVector(v::Vector{T}) where {T} = BufferedVector{T}(v, length(v))
Base.getindex(x::BufferedVector) = resize!(x.elements, x.occupied)
empty!(buffer::BufferedVector) = buffer.occupied = 0
@inline function Base.setindex!(buffer::BufferedVector{T}, x::T) where {T}
    if length(buffer.elements) == buffer.occupied
        Base._growend!(buffer.elements, _grow_by(T))
    end
    buffer.occupied += 1
    @inbounds buffer.elements[buffer.occupied] = x
end
_grow_by(::Type{T}) where {T<:Union{UInt32,UInt64,Int64,Int32,Enum{Int32},Enum{UInt32}}} = div(128, sizeof(T))
_grow_by(::Type) = 16
_grow_by(::Type{T}) where {T<:Union{Bool,UInt8}} = 64

include("encoded_size.jl")
include("vbyte.jl")
include("decode.jl")
include("encode.jl")

export encode, decode

end # module

module Lexers

import ..Tokens

const EOF_CHAR = typemax(Char)

# Alias to avoid type piracy
@inline iseof(io::IO) = Base.eof(io)
@inline iseof(c::Char) = c == EOF_CHAR

@inline isoctal(c::Char) = c in '0':'7'
@inline isnewline(c::Char) = c in '\n':'\r'
@inline iswhitespace(c::Char) = c == ' ' || c in '\t':'\r'
@inline is_ident_first_char(c::Char) = isletter(c) || c == '_'
@inline is_ident_char(c::Char) = is_ident_first_char(c) || isdigit(c)
@inline is_fully_qualified_ident_char(c::Char) = is_ident_char(c) || c == '.'

mutable struct Lexer{IO_t <: IO}
    io::IO_t
    filepath::String
    # To know where to start from while iterating
    # tokens multiple times
    io_start_pos::Int

    # Start of the Token we're currently constructing
    token_start_row::Int
    token_start_col::Int
    token_start_pos::Int

    # Our current position in the buffer
    current_row::Int
    current_col::Int
    current_pos::Int

    # (current char, next char, the char after next)
    chars::Tuple{Char,Char,Char}
    charspos::Tuple{Int,Int,Int}

    # Should we start reading the contents of io into
    # charstore so that we can then dump it into the Token
    doread::Bool
    charstore::IOBuffer
end

filepath(l::Lexer) = l.filepath
filepath(io::IOStream) = abspath(io.name[7:end-1])
filepath(io::IO) = ""
# TODO: print nicer, clickable token locations with this function, esp for errors.
# How to get the Lexers' IO to the tokens' show method?
function file_location(l::Lexer)
    f = filepath(l)
    f = isempty(f) ? string(typeof(l.io), "(...)") : f
    return join((f, l.token_start_row, l.token_start_col), ':')
end

function Lexer(io::IO_t, path=nothing) where {IO_t}
    c1 = ' '
    p1 = position(io)
    if eof(io)
        c2, p2 = EOF_CHAR, p1
        c3, p3 = EOF_CHAR, p1
    else
        c2 = read(io, Char)
        p2 = position(io)
        if eof(io)
            c3, p3 = EOF_CHAR, p2
        else
            c3 = read(io, Char)
            p3 = position(io)
        end
    end
    path = isnothing(path) ? filepath(io) : abspath(path)
    return Lexer{IO_t}(io, path, p3, 1, 1, p3, 1, 1, p3, (c1,c2,c3), (p1,p2,p3), false, IOBuffer())
end
# Read the whole path at once, should cause no problems size-wise
Lexer(path::AbstractString) = Lexer(IOBuffer(read(path)), path)

Base.seekstart(l::Lexer) = seek(l.io, l.io_start_pos)
Base.position(l::Lexer) = l.charspos[1]
iseof(l::Lexer) = iseof(l.io)
Base.seek(l::Lexer, pos) = seek(l.io, pos)

peekchar(l::Lexer) = l.chars[2]
dpeekchar(l::Lexer) = (l.chars[2], l.chars[3])

readchar(io::IO) = iseof(io) ? EOF_CHAR : read(io, Char)
function readchar(l::Lexer{IO_t}) where {IO_t}
    c = readchar(l.io)
    l.chars = (l.chars[2], l.chars[3], c)
    l.charspos = (l.charspos[2], l.charspos[3], position(l.io))
    if l.doread
        write(l.charstore, l.chars[1])
    end
    if l.chars[1] == '\n'
        l.current_row += 1
        l.current_col = 1
    elseif !iseof(l.chars[1])
        l.current_col += 1
    end
    return l.chars[1]
end

# Start storing processed Chars into l.charstore
function readon(l::Lexer{IO_t})  where {IO_t <: IO}
    l.doread = true
    if l.charstore.size != 0
        take!(l.charstore)
    end
    write(l.charstore, l.chars[1])
    return l.chars[1]
end

# Stop with storing processed Chars into l.charstore
function readoff(l::Lexer{IO_t})  where {IO_t <: IO}
    l.doread = false
    return l.chars[1]
end

function accept(l::Lexer, f::Union{Function, Char, Vector{Char}, String})
    c = peekchar(l)
    if isa(f, Function)
        ok = f(c)::Bool
    elseif isa(f, Char)
        ok = c == f
    else
        ok = c in f
    end
    ok && readchar(l)
    return ok
end

function accept_batch(l::Lexer, f)
    ok = false
    while accept(l, f)::Bool
        ok = true
    end
    return ok
end

function accept_batch(l::Lexer, f::Function)
    ok = false
    while f(peekchar(l))::Bool
        readchar(l)
        ok = true
    end
    return ok
end

function emit(l::Lexer{IO_t}, kind::Tokens.Kind, err::Tokens.TokenError=Tokens.NO_ERROR) where IO_t
    if (kind == Tokens.WHITESPACE ||
        kind == Tokens.COMMENT ||
        Tokens.isident(kind) ||
        Tokens.is_reserved_word(kind) ||
        Tokens.isliteral(kind) ||
        kind == Tokens.FALSE ||
        kind == Tokens.TRUE)

        str = String(take!(l.charstore))
    elseif kind == Tokens.ERROR
        p = position(l)
        seek(l, l.token_start_pos)
        str = String(read(l.io, p-l.token_start_pos))
    else
        str = ""
    end
    tok = Tokens.Token(
        kind,
        err,
        (l.token_start_row, l.token_start_col),
        (l.current_row, l.current_col - 1),
        str,
    )
    readoff(l)
    return tok
end

function emit_error(l::Lexer, err::Tokens.TokenError=Tokens.UNKNOWN)
    return emit(l, Tokens.ERROR, err)
end

# We consumed a whitespace
function lex_whitespace(l::Lexer)
    accept_batch(l, iswhitespace)
    return emit(l, Tokens.WHITESPACE)
end

_is_end_of_single_line_comment(c) = c == '\n' || c == EOF_CHAR
# We consumed a '#' or //
function lex_single_line_comment(l::Lexer)
    accept_batch(l, !_is_end_of_single_line_comment)
    return emit(l, Tokens.COMMENT)
end

# We consumed a '.'
function lex_dot(l::Lexer)
    if is_ident_first_char(peekchar(l))
        readon(l)
        return lex_ident(l)
    elseif isdigit(peekchar(l))
        readon(l)
        return lex_digit(l, l.chars[1])
    end
    return emit(l, Tokens.DOT)
end

function lex_forwardslash(l::Lexer, c)
    pc, ppc = dpeekchar(l)
    if pc == '*'  # /*
        readon(l)
        n_start, n_end = 0, 0
        while true
            if c == '/' && pc == '*'
                n_start += 1
                iseof(ppc) && return emit_error(l, Tokens.EOF_MULTICOMMENT)
                readchar(l) # skip past the '*' to avoid ambiguities like "/*/*" being decomposed to "/*" "*/" "/*"
                c = readchar(l)
                pc, ppc = dpeekchar(l)
            elseif c == '*' && pc == '/'
                n_end += 1
                readchar(l) # skip past the '/' to avoid ambiguities like "/*/*" being decomposed to "/*" "*/" "/*"
                n_start == n_end && return emit(l, Tokens.COMMENT)
                iseof(ppc) && n_start != n_end && return emit_error(l, Tokens.EOF_MULTICOMMENT)
                c = readchar(l)
                pc, ppc = dpeekchar(l)
            else
                iseof(pc) && return emit_error(l, Tokens.EOF_MULTICOMMENT)
                c = readchar(l)
                pc, ppc = dpeekchar(l)
            end
        end
    elseif pc == '/' # //
        readon(l)
        readchar(l)
        return lex_single_line_comment(l)
    else
        return emit(l, Tokens.FORWARD_SLASH)
    end
end

# We consumed a letter or a '_'
function lex_ident(l::Lexer)
    accept_batch(l, is_fully_qualified_ident_char)
    return emit(l, Tokens.IDENTIFIER)
end

function _tryparse_exponent(l)
    if accept(l, "eE")
        accept(l, "+-")
        pc, ppc = dpeekchar(l)
        if pc == '0' && isdigit(ppc)
            accept_batch(l, isdigit)
            return false
        end
        accept_batch(l, isdigit) || return false
    end
    return true
end

# floatLit = (
#     decimals "." [ decimals ] [ exponent ] |
#     decimals exponent |
#     "."decimals [ exponent ] ) |
# )
# decimals  = decimalDigit { decimalDigit }
# exponent  = ( "e" | "E" ) [ "+" | "-" ] decimals
# We consumed a DIGIT or '.'
function lex_digit(l::Lexer, c)
    pc, ppc = dpeekchar(l)
    if c == '0' && isoctal(pc) # lex OCTAL int
        accept_batch(l, isoctal)
        is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION) # number must not be immediately followed by an identifier
        return emit(l, Tokens.OCT_INT_LIT)
    elseif c == '0' && (pc == 'x' || pc == 'X') # lex HEX int
        readchar(l)
        pc, ppc = dpeekchar(l)
        !isxdigit(pc) && return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
        accept_batch(l, isxdigit)
        is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION)
        return emit(l, Tokens.HEX_INT_LIT)
    elseif c == '0' && isdigit(pc) # 09 (leading zero and non-oct digit after -> error)
        return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
    elseif c == '.' # starts with a digit [.]123
        accept_batch(l, isdigit) || return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
        _tryparse_exponent(l) || return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
        is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION)
        return emit(l, Tokens.FLOAT_LIT) # .123E-123
    elseif isdigit(c)
        accept_batch(l, isdigit) # 123
        if peekchar(l) == 'e' || peekchar(l) == 'E' # 123E-123
            _tryparse_exponent(l) || return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
            is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION)
            return emit(l, Tokens.FLOAT_LIT)
        elseif accept(l, '.') # 123.
            accept_batch(l, isdigit) # 123.[456]
            _tryparse_exponent(l) || return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
            is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION)
            return emit(l, Tokens.FLOAT_LIT)
        else
            is_ident_first_char(peekchar(l)) && return emit_error(l, Tokens.INVALID_NUMERIC_LITERAL_JUXTAPOSITION)
            return emit(l, Tokens.DEC_INT_LIT) # 123
        end
    else
        return emit_error(l, Tokens.INVALID_NUMERIC_CONSTANT)
    end
end

# `c` is a consumed '\'' or '"'
function lex_quote(l::Lexer, c)
    enclosing_quote = c
    while true
        pc, ppc = dpeekchar(l)
        if iseof(pc)
            return emit_error(l, Tokens.EOF_STRING)
        elseif isnewline(pc)
            readchar(l)
            return emit_error(l, Tokens.EOL_STRING)
        elseif pc == '\\'
            if ppc in "abfnrtv\\\""
                readchar(l)
                readchar(l)
            elseif ppc in "?'"
                # The single quote must not be escaped in the resulting julia string
                # Similarly, from unittest.proto:
                # // Tests for C++ trigraphs.
                # // Trigraphs should be escaped in C++ generated files, but they should not be
                # // escaped for other languages.
                # // Note that in .proto file, "\?" is a valid way to escape ? in string
                # // literals.
                l.doread = false
                readchar(l)
                l.doread = true
                readchar(l)
            # TODO: check that these codepoints are not immediately followed by a different string?
            elseif isoctal(ppc) # UTF-8 byte in octal
                readchar(l)
                readchar(l)
                accept(l, isoctal)
                accept(l, isoctal)
            elseif ppc == 'x' # UTF-8 byte in hexadecimal
                readchar(l)
                readchar(l)
                !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                accept(l, isxdigit)
            elseif ppc == 'u' # Unicode code point up to 0xffff
                readchar(l)
                readchar(l)
                !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
            elseif ppc == 'U'
                readchar(l)
                readchar(l)
                (readchar(l) != '0') && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                (readchar(l) != '0') && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                if accept(l, '0') # Unicode code point up to 0xfffff
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                elseif accept(l, '1') # Unicode code point between 0x100000 and 0x10ffff
                    (readchar(l) != '0') && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                    !isxdigit(readchar(l)) && return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                else
                    return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
                end
            else
                return emit_error(l, Tokens.INVALID_STRING_ESCAPE_SEQUENCE)
            end
        elseif pc == enclosing_quote
            readchar(l)
            break
        elseif pc == '$'
            write(l.charstore, '\\')
            readchar(l)
        else
            readchar(l)
        end
    end
    return emit(l, Tokens.STRING_LIT)
end

function start_token!(l)
    l.token_start_pos = l.charspos[1]
    l.token_start_row = l.current_row
    l.token_start_col = l.current_col
end

function next_token(l::Lexer)
    start_token!(l)
    c = readchar(l)
    if iseof(c)
        return emit(l, Tokens.ENDMARKER)
    elseif iswhitespace(c)
        readon(l)
        return lex_whitespace(l)
    elseif c == '#'
        readon(l)
        return lex_single_line_comment(l)
    elseif c == '{'
        return emit(l, Tokens.LBRACE)
    elseif c == '}'
        return emit(l, Tokens.RBRACE)
    elseif c == '>'
        return emit(l, Tokens.GREATER)
    elseif c == '<'
        return emit(l, Tokens.LESS)
    elseif c == ','
        return emit(l, Tokens.COMMA)
    elseif c == '.'
        return lex_dot(l) # Tokens.DOT or (fully qualified) Tokens.IDENTIFIER
    elseif c == '/'
        return lex_forwardslash(l, c) # Tokens.COMMENT or Tokens.FORWARD_SLASH
    elseif c == '\\'
        return emit(l, Tokens.BACKWARD_SLASH)
    elseif c == '('
        return emit(l, Tokens.LPAREN)
    elseif c == ')'
        return emit(l, Tokens.RPAREN)
    elseif c == '['
        return emit(l, Tokens.LBRACKET)
    elseif c == ']'
        return emit(l, Tokens.RBRACKET)
    elseif c == '-'
        return emit(l, Tokens.MINUS)
    elseif c == '+'
        return emit(l, Tokens.PLUS)
    elseif c == ':'
        return emit(l, Tokens.COLON)
    elseif c == '='
        return emit(l, Tokens.EQ)
    elseif c == '"' || c == '\''
        readon(l)
        return lex_quote(l, c)
    elseif c == ';'
        return emit(l, Tokens.SEMICOLON)
    elseif isdigit(c)
        readon(l)
        return lex_digit(l, c)
    elseif c == '_'
        readon(l)
        return lex_ident(l)
    elseif isletter(c)
        readon(l)
        return lex_type_or_keyword_or_identifier(l, c)
    else
        return emit_error(l)
    end
    @assert false "unreachable"
end

Base.IteratorSize(::Type{Lexer{IO_t}}) where {IO_t} = Base.SizeUnknown()
Base.IteratorEltype(::Type{Lexer{IO_t}}) where {IO_t} = Base.HasEltype()
Base.eltype(::Type{Lexer{IO_t}}) where {IO_t} = Tokens.Token

function Base.iterate(l::Lexer)
    seekstart(l)
    l.token_start_row = 1
    l.token_start_col = 1
    l.token_start_pos = l.io_start_pos

    l.current_row = 1
    l.current_col = 1
    l.current_pos = l.io_start_pos
    t = next_token(l)
    return t, t.kind == Tokens.ENDMARKER
end

function Base.iterate(l::Lexer, isdone::Bool)
    isdone && return nothing
    t = next_token(l)
    return t, t.kind == Tokens.ENDMARKER
end

function tryread(l, chars, k)
    for s in chars
        c = peekchar(l)
        c != s && return lex_ident(l)
        readchar(l)
    end
    is_fully_qualified_ident_char(peekchar(l)) && return lex_ident(l)
    return emit(l, k)
end

const _PROTOBUF_TYPES_AND_KEYWORDS = [
    "reserved", "syntax", "package", "import", "public", "weak", "option", "extensions",
    "to", "max", "service", "stream", "rpc", "returns", "repeated", "oneof", "optional",
    "required", "float", "double", "int32", "int64", "uint32", "uint64", "sint32",
    "sint64", "fixed32", "fixed64", "sfixed32", "sfixed64", "bool", "string", "bytes",
    "map", "message", "enum", "extend", "group", "true", "false",
]

# using DataStructures
# function buildtrie(keywords)
#     t = Trie(keywords, [0 for _ in keywords])
#     t.value = 0
#     for w in keywords  # init all values zero
#         k = t.children
#         for c in w
#             k[c].value = 0
#             k = k[c].children
#         end
#     end
#     for w in keywords  # count passes through each node
#         t.value += 1
#         d = t.children
#         for c in w
#             d[c].value += 1
#             d = d[c].children
#         end
#     end
#     return t
# end
# function _build_lexer_str(t, i=1, prefix="", str_rest="")
#     is_shared = t.value > 1
#     is_shared_key = t.is_key && is_shared
#     n = length(keys(t.children))  # number of branches of the current prefix
#     if t.is_key # we are at the end of a keyword (which might be a subset of a longer one)
#         tok = uppercase(string(prefix, str_rest))
#         # if someone else went through here, this is not the longest keyword with this prefix
#         if is_shared_key
#             println("    " ^ (i+1), "return emit(l, Tokens.$(tok))")
#         else
#             println("    " ^ (i), "return tryread(l, ", Tuple(collect(str_rest)), ", Tokens.$(tok))")
#         end
#     end
#     j = 0  # the current branch number
#     for (next_char, child) in t.children
#         j += 1
#         is_shared_next = child.value > 1
#         is_non_terminal_next = child.is_key && is_shared_next
#         if (is_shared_next || is_shared || i == 1)
#             println("    " ^ i, (1 < j <= n) || is_shared_key ? "else" : "", "if c == '$(next_char)'")
#             i > 1 && println("    " ^ (i+1), "readchar(l)")
#             is_shared_next && println("    " ^ (i+1), "c = peekchar(l)")
#             is_non_terminal_next && println("    " ^ (i+1), "if !is_ident_char(c)")
#             _build_lexer_str(child, i+1, string(prefix, next_char), str_rest)
#             j == n && begin
#                 println("    " ^ i, "else")
#                 println("    " ^ (i+1), "return lex_ident(l)")
#                 println("    " ^ i, "end")
#             end
#         else
#             _build_lexer_str(child, i, prefix, string(str_rest, next_char))
#         end
#     end
# end
# function build_lexer_str(keywords)
#     @assert allunique(keywords)
#     println("function lex_type_or_keyword_or_identifier(l::Lexer, c)")
#     t = buildtrie(keywords)
#     _build_lexer_str(t)
#     println("end")
# end
# build_lexer_str(_PROTOBUF_TYPES_AND_KEYWORDS)
function lex_type_or_keyword_or_identifier(l::Lexer, c)
    if c == 'f'
        c = peekchar(l)
        if c == 'a'
            readchar(l)
            return tryread(l, ('l', 's', 'e'), Tokens.FALSE)
        elseif c == 'l'
            readchar(l)
            return tryread(l, ('o', 'a', 't'), Tokens.FLOAT)
        elseif c == 'i'
            readchar(l)
            c = peekchar(l)
            if c == 'x'
                readchar(l)
                c = peekchar(l)
                if c == 'e'
                    readchar(l)
                    c = peekchar(l)
                    if c == 'd'
                        readchar(l)
                        c = peekchar(l)
                        if c == '3'
                            readchar(l)
                            return tryread(l, ('2',), Tokens.FIXED32)
                        elseif c == '6'
                            readchar(l)
                            return tryread(l, ('4',), Tokens.FIXED64)
                        else
                            return lex_ident(l)
                        end
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        else
            return lex_ident(l)
        end
    elseif c == 'w'
        return tryread(l, ('e', 'a', 'k'), Tokens.WEAK)
    elseif c == 'd'
        return tryread(l, ('o', 'u', 'b', 'l', 'e'), Tokens.DOUBLE)
    elseif c == 'e'
        c = peekchar(l)
        if c == 'n'
            readchar(l)
            return tryread(l, ('u', 'm'), Tokens.ENUM)
        elseif c == 'x'
            readchar(l)
            c = peekchar(l)
            if c == 't'
                readchar(l)
                c = peekchar(l)
                if c == 'e'
                    readchar(l)
                    c = peekchar(l)
                    if c == 'n'
                        readchar(l)
                        c = peekchar(l)
                        if c == 's'
                            readchar(l)
                            return tryread(l, ('i', 'o', 'n', 's'), Tokens.EXTENSIONS)
                        elseif c == 'd'
                            readchar(l)
                            return tryread(l, (), Tokens.EXTEND)
                        else
                            return lex_ident(l)
                        end
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        else
            return lex_ident(l)
        end
    elseif c == 'o'
        c = peekchar(l)
        if c == 'n'
            readchar(l)
            return tryread(l, ('e', 'o', 'f'), Tokens.ONEOF)
        elseif c == 'p'
            readchar(l)
            c = peekchar(l)
            if c == 't'
                readchar(l)
                c = peekchar(l)
                if c == 'i'
                    readchar(l)
                    c = peekchar(l)
                    if c == 'o'
                        readchar(l)
                        c = peekchar(l)
                        if c == 'n'
                            readchar(l)
                            c = peekchar(l)
                            if !is_ident_char(c)
                                return emit(l, Tokens.OPTION)
                            elseif c == 'a'
                                readchar(l)
                                return tryread(l, ('l',), Tokens.OPTIONAL)
                            else
                                return lex_ident(l)
                            end
                        else
                            return lex_ident(l)
                        end
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        else
            return lex_ident(l)
        end
    elseif c == 's'
        c = peekchar(l)
        if c == 'f'
            readchar(l)
            c = peekchar(l)
            if c == 'i'
                readchar(l)
                c = peekchar(l)
                if c == 'x'
                    readchar(l)
                    c = peekchar(l)
                    if c == 'e'
                        readchar(l)
                        c = peekchar(l)
                        if c == 'd'
                            readchar(l)
                            c = peekchar(l)
                            if c == '3'
                                readchar(l)
                                return tryread(l, ('2',), Tokens.SFIXED32)
                            elseif c == '6'
                                readchar(l)
                                return tryread(l, ('4',), Tokens.SFIXED64)
                            else
                                return lex_ident(l)
                            end
                        else
                            return lex_ident(l)
                        end
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        elseif c == 'y'
            readchar(l)
            return tryread(l, ('n', 't', 'a', 'x'), Tokens.SYNTAX)
        elseif c == 'i'
            readchar(l)
            c = peekchar(l)
            if c == 'n'
                readchar(l)
                c = peekchar(l)
                if c == 't'
                    readchar(l)
                    c = peekchar(l)
                    if c == '3'
                        readchar(l)
                        return tryread(l, ('2',), Tokens.SINT32)
                    elseif c == '6'
                        readchar(l)
                        return tryread(l, ('4',), Tokens.SINT64)
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        elseif c == 'e'
            readchar(l)
            return tryread(l, ('r', 'v', 'i', 'c', 'e'), Tokens.SERVICE)
        elseif c == 't'
            readchar(l)
            c = peekchar(l)
            if c == 'r'
                readchar(l)
                c = peekchar(l)
                if c == 'i'
                    readchar(l)
                    return tryread(l, ('n', 'g'), Tokens.STRING)
                elseif c == 'e'
                    readchar(l)
                    return tryread(l, ('a', 'm'), Tokens.STREAM)
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        else
            return lex_ident(l)
        end
    elseif c == 'i'
        c = peekchar(l)
        if c == 'n'
            readchar(l)
            c = peekchar(l)
            if c == 't'
                readchar(l)
                c = peekchar(l)
                if c == '3'
                    readchar(l)
                    return tryread(l, ('2',), Tokens.INT32)
                elseif c == '6'
                    readchar(l)
                    return tryread(l, ('4',), Tokens.INT64)
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        elseif c == 'm'
            readchar(l)
            return tryread(l, ('p', 'o', 'r', 't'), Tokens.IMPORT)
        else
            return lex_ident(l)
        end
    elseif c == 'r'
        c = peekchar(l)
        if c == 'e'
            readchar(l)
            c = peekchar(l)
            if c == 's'
                readchar(l)
                return tryread(l, ('e', 'r', 'v', 'e', 'd'), Tokens.RESERVED)
            elseif c == 't'
                readchar(l)
                return tryread(l, ('u', 'r', 'n', 's'), Tokens.RETURNS)
            elseif c == 'p'
                readchar(l)
                return tryread(l, ('e', 'a', 't', 'e', 'd'), Tokens.REPEATED)
            elseif c == 'q'
                readchar(l)
                return tryread(l, ('u', 'i', 'r', 'e', 'd'), Tokens.REQUIRED)
            else
                return lex_ident(l)
            end
        elseif c == 'p'
            readchar(l)
            return tryread(l, ('c',), Tokens.RPC)
        else
            return lex_ident(l)
        end
    elseif c == 't'
        c = peekchar(l)
        if c == 'r'
            readchar(l)
            return tryread(l, ('u', 'e'), Tokens.TRUE)
        elseif c == 'o'
            readchar(l)
            return tryread(l, (), Tokens.TO)
        else
            return lex_ident(l)
        end
    elseif c == 'p'
        c = peekchar(l)
        if c == 'a'
            readchar(l)
            return tryread(l, ('c', 'k', 'a', 'g', 'e'), Tokens.PACKAGE)
        elseif c == 'u'
            readchar(l)
            return tryread(l, ('b', 'l', 'i', 'c'), Tokens.PUBLIC)
        else
            return lex_ident(l)
        end
    elseif c == 'm'
        c = peekchar(l)
        if c == 'a'
            readchar(l)
            c = peekchar(l)
            if c == 'x'
                readchar(l)
                return tryread(l, (), Tokens.MAX)
            elseif c == 'p'
                readchar(l)
                return tryread(l, (), Tokens.MAP)
            else
                return lex_ident(l)
            end
        elseif c == 'e'
            readchar(l)
            return tryread(l, ('s', 's', 'a', 'g', 'e'), Tokens.MESSAGE)
        else
            return lex_ident(l)
        end
    elseif c == 'g'
        return tryread(l, ('r', 'o', 'u', 'p'), Tokens.GROUP)
    elseif c == 'u'
        c = peekchar(l)
        if c == 'i'
            readchar(l)
            c = peekchar(l)
            if c == 'n'
                readchar(l)
                c = peekchar(l)
                if c == 't'
                    readchar(l)
                    c = peekchar(l)
                    if c == '3'
                        readchar(l)
                        return tryread(l, ('2',), Tokens.UINT32)
                    elseif c == '6'
                        readchar(l)
                        return tryread(l, ('4',), Tokens.UINT64)
                    else
                        return lex_ident(l)
                    end
                else
                    return lex_ident(l)
                end
            else
                return lex_ident(l)
            end
        else
            return lex_ident(l)
        end
    elseif c == 'b'
        c = peekchar(l)
        if c == 'y'
            readchar(l)
            return tryread(l, ('t', 'e', 's'), Tokens.BYTES)
        elseif c == 'o'
            readchar(l)
            return tryread(l, ('o', 'l'), Tokens.BOOL)
        else
            return lex_ident(l)
        end
    else
        return lex_ident(l)
    end
end


end # module

function _parse_identifier_with_url(ps)
    ident = val(expectnext(ps, Tokens.IDENTIFIER))
    if accept(ps, Tokens.FORWARD_SLASH)
        ident = string(ident, "/", val(expectnext(ps, Tokens.IDENTIFIER)))
    end
    return ident
end


function _parse_option_value(ps) # TODO: proper value parsing with validation
    accept(ps, Tokens.PLUS)
    has_minus = accept(ps, Tokens.MINUS)
    nk, nnk = dpeekkind(ps)
    str_val = val(readtoken(ps))
    # C-style string literals spanning multiple lines
    if nk == Tokens.STRING_LIT && nnk == Tokens.STRING_LIT
        iob = IOBuffer()
        write(iob, str_val)
        while peekkind(ps) == Tokens.STRING_LIT
            seek(iob, position(iob) - 1)
            write(iob, @view(val(readtoken(ps))[begin+1:end]))
        end
        str_val = String(take!(iob))
    end
    return has_minus ? string("-", str_val) : str_val
end

function _parse_option_name(ps)
    buf = IOBuffer()
    option_name = ""
    last_name_part = ""
    prev_had_parens = false
    while true
        if accept(ps, Tokens.LPAREN)
            write(buf, "(", _parse_identifier_with_url(ps), ")")
            expectnext(ps, Tokens.RPAREN)
            prev_had_parens = true
        elseif accept(ps, Tokens.LBRACKET)
            write(buf, "[", _parse_identifier_with_url(ps), "]")
            expectnext(ps, Tokens.RBRACKET)
        elseif accept(ps, Tokens.IDENTIFIER)
            last_name_part = val(token(ps))
            if prev_had_parens
                startswith(last_name_part, '.') || error("Invalid option identifier $(option_name)$(last_name_part)")
            end
            write(buf, last_name_part)
        elseif accept(ps, Tokens.DOT)
            expectnext(ps, Tokens.LPAREN)
            write(buf, ".(", _parse_identifier_with_url(ps), ")")
            expectnext(ps, Tokens.RPAREN)
            prev_had_parens = true
        else
            break
        end
    end
    return String(take!(buf))
end

function _parse_aggregate_option(ps)
    # TODO: properly validate that `option (complex_opt2).waldo = { waldo: 212 }` doesn't happen
    #       `option (complex_opt2) = { waldo: 212 }` ok
    #       `option (complex_opt2).waldo = 212 ` ok
    option_value_dict = Dict{String,Union{Dict,String}}()
    while !accept(ps, Tokens.RBRACE)
        option_name = _parse_option_name(ps)
        accept(ps, Tokens.COLON)
        if accept(ps, Tokens.LBRACE)
            option_value_dict[option_name] = _parse_aggregate_option(ps)
        else
            option_value_dict[option_name] = _parse_option_value(ps)
        end
        accept(ps, Tokens.COMMA)
    end
    return option_value_dict
end

# We consumed a LBRACKET ([)
function parse_field_options!(ps::ParserState, options::Dict{String,Union{String,Dict{String}}})
    while true
        _parse_option!(ps, options)
        accept(ps, Tokens.COMMA) && continue
        accept(ps, Tokens.RBRACKET) && break
        error("Missing comma in option lists at $(ps.l.current_row):$(ps.l.current_col)")
    end
end

# We consumed OPTION
# NOTE: does not eat SEMICOLON
function _parse_option!(ps::ParserState, options::Dict{String,Union{String,Dict{String}}})
    option_name = _parse_option_name(ps)
    accept(ps, Tokens.COLON)
    expectnext(ps, Tokens.EQ)  # =
    if accept(ps, Tokens.LBRACE) # {key: val, ...}
        options[option_name] = _parse_aggregate_option(ps)
        # accept(ps, Tokens.SEMICOLON)
    else
        options[option_name] = _parse_option_value(ps)
    end
    return nothing
end

using ProtoBuf: Codecs
using .Codecs: vbyte_decode, vbyte_encode
using Test

test_vbyte_decode(bytes, expected) = @test vbyte_decode(PipeBuffer(bytes), typeof(unsigned(expected))) == unsigned(expected)
test_vbyte_encode(input, expected) = (io = IOBuffer(); vbyte_encode(io, unsigned(input)); @test take!(io) == expected)
test_vbyte_roundtrip(input) = (io = PipeBuffer(); vbyte_encode(io, unsigned(input)); @test vbyte_decode(io, typeof(unsigned(input))) == input)

@testset "vbyte" begin
    @testset "decode" begin
        @testset "UInt32" begin
            test_vbyte_decode(UInt8[0x00], UInt32(0))
            test_vbyte_decode(UInt8[0x01], UInt32(1))
            test_vbyte_decode(UInt8[0x80, 0x01], UInt32(128))
            test_vbyte_decode(UInt8[0x80, 0x80, 0x01], UInt32(1) << 14)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x01], UInt32(1) << 21)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x01], UInt32(1) << 28)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x08], UInt32(1) << 31)

            # For robustness, UInt32 should be able to decode UInt64 varints
            # truncating to UInt32
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x88, 0x00], UInt32(1) << 31)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x88, 0x80, 0x00], UInt32(1) << 31)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x88, 0x80, 0x80, 0x00], UInt32(1) << 31)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x88, 0x80, 0x80, 0x80, 0x00], UInt32(1) << 31)
            test_vbyte_decode(UInt8[0xaa, 0xaa, 0xaa, 0xaa, 0x2a, 0xaa, 0xaa, 0xaa, 0x2a], 0xa54a952a)

            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x05], mapreduce(i->UInt64(i) << 7(i - 1), |, 5:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x04], mapreduce(i->UInt64(i) << 7(i - 1), |, 4:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x03], mapreduce(i->UInt64(i) << 7(i - 1), |, 3:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x02], mapreduce(i->UInt64(i) << 7(i - 1), |, 2:-1:0))
            test_vbyte_decode(UInt8[0x01], mapreduce(i->UInt64(i) << 7(i - 1), |, 1:-1:0))
        end
        @testset "UInt64" begin
            test_vbyte_decode(UInt8[0x00], UInt64(0))
            test_vbyte_decode(UInt8[0x01], UInt64(1))
            test_vbyte_decode(UInt8[0x80, 0x01], UInt64(128))
            test_vbyte_decode(UInt8[0x80, 0x80, 0x01], UInt64(1) << 14)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x01], UInt64(1) << 21)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 28)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 35)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 42)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 49)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 56)
            test_vbyte_decode(UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01], UInt64(1) << 63)
            test_vbyte_decode(UInt8[0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x2a], 0x2a54a952a54a952a)

            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x70], mapreduce(i->UInt64(i) << 7(i - 1), |, 10:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x0a], mapreduce(i->UInt64(i) << 7(i - 1), |, 9:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x09], mapreduce(i->UInt64(i) << 7(i - 1), |, 9:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x08], mapreduce(i->UInt64(i) << 7(i - 1), |, 8:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x07], mapreduce(i->UInt64(i) << 7(i - 1), |, 7:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x06], mapreduce(i->UInt64(i) << 7(i - 1), |, 6:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x84, 0x05], mapreduce(i->UInt64(i) << 7(i - 1), |, 5:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x83, 0x04], mapreduce(i->UInt64(i) << 7(i - 1), |, 4:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x82, 0x03], mapreduce(i->UInt64(i) << 7(i - 1), |, 3:-1:0))
            test_vbyte_decode(UInt8[0x81, 0x02], mapreduce(i->UInt64(i) << 7(i - 1), |, 2:-1:0))
            test_vbyte_decode(UInt8[0x01], mapreduce(i->UInt64(i) << 7(i - 1), |, 1:-1:0))
        end
    end

    @testset "encode" begin
        @testset "UInt32" begin
            test_vbyte_encode(UInt32(0), UInt8[0x00])
            test_vbyte_encode(UInt32(1), UInt8[0x01])
            test_vbyte_encode(UInt32(128), UInt8[0x80, 0x01])
            test_vbyte_encode(UInt32(1) << 14, UInt8[0x80, 0x80, 0x01])
            test_vbyte_encode(UInt32(1) << 21, UInt8[0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt32(1) << 28, UInt8[0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt32(1) << 31, UInt8[0x80, 0x80, 0x80, 0x80, 0x08])

            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 5:-1:0), UInt8[0x81, 0x82, 0x83, 0x84, 0x05])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 4:-1:0), UInt8[0x81, 0x82, 0x83, 0x04])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 3:-1:0), UInt8[0x81, 0x82, 0x03])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 2:-1:0), UInt8[0x81, 0x02])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 1:-1:0), UInt8[0x01])
        end
        @testset "UInt64" begin
            test_vbyte_encode(UInt64(0), UInt8[0x00])
            test_vbyte_encode(UInt64(1), UInt8[0x01])
            test_vbyte_encode(UInt64(128), UInt8[0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 14, UInt8[0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 21, UInt8[0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 28, UInt8[0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 35, UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 42, UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 49, UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 56, UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01])
            test_vbyte_encode(UInt64(1) << 63, UInt8[0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x01])

            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 10:-1:0), UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x09])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 9:-1:0),  UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x09])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 8:-1:0),  UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x08])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 7:-1:0),  UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x07])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 6:-1:0),  UInt8[0x81, 0x82, 0x83, 0x84, 0x85, 0x06])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 5:-1:0),  UInt8[0x81, 0x82, 0x83, 0x84, 0x05])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 4:-1:0),  UInt8[0x81, 0x82, 0x83, 0x04])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 3:-1:0),  UInt8[0x81, 0x82, 0x03])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 2:-1:0),  UInt8[0x81, 0x02])
            test_vbyte_encode(mapreduce(i->UInt64(i) << 7(i - 1), |, 1:-1:0),  UInt8[0x01])
        end
    end

    @testset "idempotency" begin
        @testset "UInt32" begin
            for b in Iterators.product(((0x00, 0xFF) for _ in 1:4)...)
                test_vbyte_roundtrip(reinterpret(UInt32, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0x01) for _ in 1:4)...)
                test_vbyte_roundtrip(reinterpret(UInt32, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0x80) for _ in 1:4)...)
                test_vbyte_roundtrip(reinterpret(UInt32, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0xaa) for _ in 1:4)...)
                test_vbyte_roundtrip(reinterpret(UInt32, collect(b))[1])
            end
        end

        @testset "UInt64" begin
            for b in Iterators.product(((0x00, 0xFF) for _ in 1:8)...)
                test_vbyte_roundtrip(reinterpret(UInt64, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0x01) for _ in 1:8)...)
                test_vbyte_roundtrip(reinterpret(UInt64, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0x80) for _ in 1:8)...)
                test_vbyte_roundtrip(reinterpret(UInt64, collect(b))[1])
            end
            for b in Iterators.product(((0x00, 0xaa) for _ in 1:8)...)
                test_vbyte_roundtrip(reinterpret(UInt64, collect(b))[1])
            end
        end
    end
end

# Frequently Asked Questions

### How do I work with `.textproto` files?

`.textproto` files are not currently supported by this package. You can, however, use the `protoc` compiler (e.g. via the `protoc_jll` package) to translate between `text` and `binary` formats using the `--encode` and `--decode` commands.

### How do I work with `oneof` fields?

A `oneof` field represents a set of possible fields (*members*) of which only one can be set at a time. Individual members of a `oneof` field cannot be distinguished by their `type` alone, one needs to know the respective member field `name` as well. In this package, we use a `OneOf{T}` type to represent the chosen member, is only has two fields: a `value::T` and a `name::Symbol`. Dereferencing a `OneOf` instance will return the value.

Because Protocol Buffers stress that one needs to handle situations where message definitions evolve and when data transfer can fail, we need to have a *default value* for all fields, `oneof` fields included. Given multiple members, there is no clear default value to choose, so we represent the absence of a `OneOf` instance with `nothing`. This means that, by default, all `oneof` fields are presented as `Union{Nothing,OneOf{...}}` in Julia. These unions can sometimes be tricky to reason about for the Julia compiler so we recommend the following when working with `OneOf` types:

* Try to manually split the `Union`, i.e. instead of

```julia
if !isnothing(my_message.one_of_field)
elseif my_message.one_of_field === :option1
    do_someting(my_message.one_of_field[])
elseif my_message.one_of_field === :option2
    do_someting_else(my_message.one_of_field[])
# ...
end
```

do this:

```julia
one_of_field = my_message.one_of_field
if !isnothing(one_of_field)
elseif one_of_field === :option1
    do_someting(one_of_field[])
elseif one_of_field === :option2
    do_someting_else(one_of_field[])
# ...
end
```
* When you *know* that the `oneof` field is guaranteed to be received when decoding, you can tell the `protojl` not to use a `Union` by providing a `force_requires` keyword argument with `Dict("my_proto_file.proto" => Set("MyMessage.one_of_field"))`.

* You can parametrize your structs on the type of `oneof`s by providing a `parametrize_oneofs=true` keyword argument to `protojl`.

### How complete is this package?

The package should have fairly complete support for both `proto2` and `proto3` syntaxes with the following exceptions:

* Services and RPC are not yet supported
* Extensions are not yet supported
* Text Format is not yet supported (but see [How do I work with `.textproto` files?](@ref))

Future development will focus on Services and RPC with an overall goal of getting a new, native Julia `gRPC` implementation.

# ProtoBuf.jl Documentation

## Overview

`ProtoBuf.jl` provides a compiler and codec for Google's [Protocol Buffers](https://developers.google.com/protocol-buffers) serialization format.

Use the `protojl` function to translate your `.proto` files to Julia, then you can encode and decode your messages with
```julia
encode(e::ProtoEncoder, x::YourMessage)
decode(d::ProtoDecoder, ::Type{YourMessage})
```
Where the `ProtoEncoder` and `ProtoDecoder` are simple types wrapping your `IO`.

### Installation

The package is not currently registered, to install it, use:

```julia
import Pkg; Pkg.add("ProtoBuf")
```

### Quickstart

Given a `test.proto` file in your current working directory:
```protobuf
syntax = "proto3";

enum MyEnum {
    DEFAULT = 0;
    OTHER = 1;
}

message MyMessage {
    sint32 a = 1;
    repeated string b = 2;
}
```
You can generate Julia bindings with the `protojl` function:
```julia-repl
julia> using ProtoBuf

julia> protojl("test.proto", ".", "output_dir")
```

This will create a Julia file at `output_dir/test_pb.jl` which you can simply `include` and start using it to encode and decode messages:

```julia-repl
julia> include("output_dir/test_pb.jl")
Main.test_pb

julia> io = IOBuffer();

julia> e = ProtoEncoder(io);

julia> encode(e, test_pb.MyMessage(-1, ["a", "b"]))
8

julia> seekstart(io);

julia> d = ProtoDecoder(io);

julia> decode(d, test_pb.MyMessage)
Main.test_pb.MyMessage(-1, ["a", "b"])
```

If you are curious, this is what the generated file looks like:

```julia
# Autogenerated using ProtoBuf.jl v0.1.0 on 2022-07-25T11:32:05.368
# original file: /Users/tdrvostep/_proj/ProtoBuf.jl/test.proto (proto3 syntax)

module test_pb

import ProtoBuf as PB
using ProtoBuf: OneOf
using EnumX: @enumx

export MyEnum, MyMessage

@enumx MyEnum DEFAULT=0 OTHER=1

struct MyMessage
    a::Int32
    b::Vector{String}
end
PB.default_values(::Type{MyMessage}) = (;a = zero(Int32), b = Vector{String}())
PB.field_numbers(::Type{MyMessage}) = (;a = 1, b = 2)

function PB.decode(d::PB.AbstractProtoDecoder, ::Type{<:MyMessage})
    a = zero(Int32)
    b = PB.BufferedVector{String}()
    while !PB.message_done(d)
        field_number, wire_type = PB.decode_tag(d)
        if field_number == 1
            a = PB.decode(d, Int32, Val{:zigzag})
        elseif field_number == 2
            PB.decode!(d, b)
        else
            PB.skip(d, wire_type)
        end
    end
    return MyMessage(a, b[])
end

function PB.encode(e::PB.AbstractProtoEncoder, x::MyMessage)
    initpos = position(e.io)
    x.a != zero(Int32) && PB.encode(e, 1, x.a, Val{:zigzag})
    !isempty(x.b) && PB.encode(e, 2, x.b)
    return position(e.io) - initpos
end
function PB._encoded_size(x::MyMessage)
    encoded_size = 0
    x.a != zero(Int32) && (encoded_size += PB._encoded_size(x.a, 1, Val{:zigzag}))
    !isempty(x.b) && (encoded_size += PB._encoded_size(x.b, 2))
    return encoded_size
end
end # module
```
## Migrating from earlier versions of ProtoBuf.jl

Below is a list of notable differences that were introduced in 1.0.

### Method Names

For translating proto files, use `protojl` function (previously `protoc`). To decode proto messages, use the `decode` method (previously `readproto`) and to encode Julia structs, use `encode` (previously `writeproto`). See [Quickstart](@ref) for an example.
### Mutability
Messages are now translated to immutable structs. This means that code that used the mutable structs to accumulate data will now have to prepare each field and construct the struct after all of them are ready.

### Common abstract type

By default, the generated structs don't share any common abstract type (well, except `Any`), when you set the `common_abstract_type` option to `true`, every struct definition will be a subtype of `ProtoBuf.AbstractProtoBufMessage`.

### Naming Conventions
The naming of nested messages and enums now generates names, that cannot collide with other definitions. For example:
```protobuf
message A {
    message B {}
}
```
now generates structs named `A` and `var"A.B"`. In protobuf, it is legal to a define message called `A_B` but not `A.B`, which is a syntax to refer to these nested definitions.

Similarly, field names that coincide with Julia reserved keywords were previously prefixed with an underscore (e.g. `_function`), now we prefix them with a `#` (e.g. `var"#function"`).

### Enumerations
[EnumX.jl](https://github.com/fredrikekre/EnumX.jl) is used to define `enums` instead of `NamedTuple`s. This means that to get the type of the enum, one must use `MyEnum.T` as `MyEnum` is a `Module`. You can now dispatch on `Base.Enum` when working with `@enumx`-based enums.

### `oneof` Fields
`oneof` fields are now explicitly represented in the generated struct. Specifically, for a message
```protobuf
message MyMessage {
    oneof oneof_field {
        int32 option1 = 1;
        string option2 = 2;
    }
}
```
a struct with a single field will be generated:
```julia
struct MyMessage
   oneof_field::Union{Nothing,OneOf{<:Union{Int32,String}}}
end
```
Once instantiated, it will contain a value like `OneOf{:option1, 42}` or `OneOf{:option2, "The answer to life, the universe, and everything"}`. One can access the name and the value of the field via the `:name` and `:value` properties, respectively. Dereferencing the field will return the value of the field (e.g. `my_message.oneof_field[] == 42`)

### Packages and Code Structure
For `.proto` files that are packages, a nested directory structure will be generated. For example, `{file_name}.proto` containing `package foo_bar.baz_grok`, the following directory structure is created:
```bash
root  # `output_directory` arg from from `protojl`
└── foo_bar
    ├── foo_bar.jl  # defines module `foo_bar`, imports `baz_grok`
    └── baz_grok
        ├── {file_name}_pb.jl
        └── baz_grok.jl  # defines module `baz_grok`, includes `{file_name}_pb.jl`
```
You should include the top-level module of a generated package, i.e. `foo_bar.jl` in this example.
When reading `.proto` files that use `import` statements, the imported files have to be located at the respective import paths relative to `search_directories`.

`.proto` files that don't have a `package` specifier will generate a single file containing a module. For example, `{file_name}.proto` will translate to a `{file_name}_pb.jl` file defining a `{file_name}_pb` module. You can generate a file without a module by providing `always_use_modules=false` options to `protojl`.

### Constructors
By default, there are no additional constructors generated for the Julia structs. You can use the `add_kwarg_contructors=true` option to `protojl` to create outer constructors that accept keyword arguments and provide default values where available.

```@contents
Pages = ["reference.md"]
Depth = 3
```

```@meta
CurrentModule = ProtoBuf
```

# API Reference

### Code Generation

```@docs
protojl
```

### Encoding and Decoding

```@docs
encode(::AbstractProtoEncoder, ::T) where {T}
decode(::AbstractProtoDecoder, ::Type{T}) where {T}
```

### Metadata

```@docs
reserved_fields
extendable_field_numbers
oneof_field_types
field_numbers
default_values
```
